<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

$objPort = Portador::CarregarObjeto(2);
$token = (string) trim($objPort->get('gdata3'));
$key = (string) trim($objPort->get('gdata2'));

$moip = new Moip\Moip(new Moip\Auth\BasicAuth($token, $key), Moip\Moip::ENDPOINT_PRODUCTION);

$filters = new Moip\Helper\Filters();
$filters->in(Moip\Resource\OrdersList::STATUS, ['PAID']);

$qtd = 25;
$page = $request->get('page')+0;
if($page <= 0) $page = 1;

$inicio = $qtd * ($page-1);


function order_get($id){
    global $token, $key;
    $curl = curl_init();
    $headers = array(
        'Content-Type:application/json',
        'Authorization: Basic '. base64_encode("{$token}:{$key}")
    );
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    curl_setopt_array($curl, array(
        CURLOPT_RETURNTRANSFER => 1,
        CURLOPT_URL => 'https://api.moip.com.br/v2/orders/'.$id,
    ));
    $resp = curl_exec($curl);
    //echo $resp;
    
    curl_close($curl);
    return json_decode($resp);
}

function save_order($id, $id_pessoa, $nomefantasia){
    if(!Conta::VerificaExistencia($id,'numero_titulo=')){
            
                //echo 'order: '.PHP_EOL;
                $order = order_get($id);
                //echo 'ok'.PHP_EOL.'total: ';
                $total = ((int) $order->amount->total)/100;
                //echo $total.' - ok'.PHP_EOL.'payments: ';
                $payments = $order->payments;
                //echo print_r($payments,true).' - ok'.PHP_EOL.'itens: ';
                $itens = $order->items;
                //echo print_r($itens,true).' - ok'.PHP_EOL.'vencimento: ';
                $fi = $payments[0]->fundingInstrument;
                //echo 'ok'.PHP_EOL.'FundingInstrument: ';
                $vencimento = '';
                if(isset($fi->boleto)){
                    //echo 'BOLETO';
                    $vencimento = $fi->boleto->expirationDate;
                    //echo $vencimento.' - ok'.PHP_EOL.'instructions: ';
                    if(isset($fi->boleto->instructionLines)){
                        $descricao = $fi->boleto->instructionLines->second;    
                    }else{
                        $descricao = $itens[0]->product;
                    }
                }else{
                    $descricao = $itens[0]->product;
                }
                //echo $descricao.' - ok'.PHP_EOL.'pagamento: ';
                $events = $payments[0]->events;
                //print_r($events);
                foreach ($events as $event) {
                    if($event->type == 'PAYMENT.AUTHORIZED'){
                        $pagamento = date('Y-m-d',strtotime($event->createdAt)); 
                        if($vencimento == '') $vencimento = $pagamento;
                        break;   
                    }
                }
                //echo 'ok'.PHP_EOL.' -->';

                echo $nomefantasia.' - '.$descricao.' R$ '.$total.' - Paga: '.$pagamento.' - ';
            
                $objC = new Conta();
                $objC->set('id_pessoa',$id_pessoa);
                $objC->set('id_contratacao',0);
                $objC->set('id_recorrencia',0);
                $objC->set('numero_titulo',$id);
                $objC->set('numero_nf','');
                $objC->set('tipo',2);
                $objC->set('status',3);
                $objC->set('vencimento',$vencimento);
                $objC->set('pagamento',$pagamento);
                $objC->set('valor',$total);
                $objC->set('descricao',$descricao);
                $ret = $objC->Inserir();

                $idConta = $ret[0];

                if($pagamento != ''){
                    $objM = new Movimentacao();
                    $objM->set('tipo',2);
                    $objM->set('status',3);
                    $objM->set('id_conta',$idConta);
                    $objM->set('id_forma',2);
                    $objM->set('id_portador',2);
                    $objM->set('id_portador_origem',0);
                    $objM->set('valor',$total);
                    $objM->set('juro',0);
                    $objM->set('multa',0);
                    $objM->set('desconto',0);
                    $objM->set('despesa',4);
                    $objM->set('data',$pagamento);
                    $objM->set('obs','');
                    $objM->Inserir();
                }
                echo 'INSERIDA';
            
        }else{
            //echo ' -->';
            echo 'JA ESTAVA INSERIDA';
        }
}


$orders = $moip->orders()->getList(new Moip\Helper\Pagination($qtd, $inicio), $filters)->getOrders();

echo '<div class="row">
    <button class="btn btn-lg btn-danger" onclick="importaMoip('.($page-1).')">ANTERIOR ('.($page-1).')</button>
    &nbsp;&nbsp;&nbsp;&nbsp;
    <button class="btn btn-lg btn-danger" onclick="importaMoip('.$page.')">ATUALIZAR</button>
    &nbsp;&nbsp;&nbsp;&nbsp;
    <button class="btn btn-lg btn-danger" onclick="importaMoip('.($page+1).')">PROXIMA ('.($page+1).')</button></div>';

$i = 0;
$hasError = false;
if(count($orders) > 0){
    foreach($orders as $orderObj){
        //print_r($orderObj);

        $fullname = trim((string) $orderObj->customer->fullname);
        $email = trim((string) $orderObj->customer->email);
        $ownId = $orderObj->ownId;

        echo '<h3>'.(++$i).' - '.$fullname.' ('.$email.') - '.$orderObj->id.' ('.$ownId.')</h3>';
        //echo '<!-- ';
        //echo '$rs pessoa email - ';
        $rs = Pessoa::Buscar('id,nomefantasia',$email,'email');
        //echo 'ok'.PHP_EOL;
        if($rs->next()){
            save_order($orderObj->id, $rs->getInt('id'), $rs->getString('nomefantasia'));
            
        }else{
            unset($rs);
            //echo '$rs pessoa nome - ';
            $rs = Pessoa::Buscar('id,nomefantasia',trim($fullname),'nomefantasia');
            if($rs->next()){

                $pessoa = Pessoa::CarregarObjeto($rs->getInt('id'));
                $pessoa->set('obs',($pessoa->get('obs') !=''?' - ':'').$pessoa->get('obs').$pessoa->get('email'));
                $pessoa->set('email',$email);
                $pessoa->Alterar();

                save_order($orderObj->id, $rs->getInt('id'), $rs->getString('nomefantasia'));
            }else{
                //echo ' -->';
                echo '<strong><font color="red">Pessoa n&atilde;o encontrada</font></strong>';
                $hasError = true;
            }
        }
        echo '<br>';
        //exit;
    }
}else{
    echo 'Uruulll, acabou!!!!';
    $hasError = true;
}

if(!$hasError) echo '<script> setTimeout(function(){ importaMoip('.($page+1).'); }, 2000);</script>';