<?php

class Atendimento extends Flex {

    protected $nomeTable = 'atendimentos';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'id_painel' => 'int',
        'id_responsavel' => 'int',
        'id_setor' => 'int',
        'solicitante' => 'string',
        'nome' => 'string',
        'descricao' => 'string',
        'status' => 'int',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    public static $nmSetor = array(
        1 => 'Administrativo',
        2 => 'Financeiro',
        3 => 'Suporte',
    );
    
    public static $nmStatus = array(
        0 => 'Cancelado',
        1 => 'Pendente',
        2 => 'Aguardando Suporte',
        3 => 'Aguardando Cliente',
        4 => 'Finalizado',
    );

    protected $painel = null;
    public function getPainel() {
        if(!$this->painel || $this->painel->get('id') != $this->get('id_painel')){
            if($this->get('id_painel')!=0)
                $this->painel = Painel::CarregarObjeto($this->get('id_painel'));
            else{
                $this->painel = new Painel();
            }
        }
        return $this->painel;        
    }
    
   
    
    protected $resp = null;
    public function getResponsavel() {
        if(!$this->resp || $this->resp->get('id') != $this->get('id_responsavel')){
            if($this->get('id_responsavel')!=0)
                $this->resp = Usuario::CarregarObjeto($this->get('id_responsavel'));
            else{
                $this->resp = new Usuario();
                $this->resp->set('nome','N&atilde;o informado');
                
            }
        }
        return $this->resp;        
    }
    
    public static function validate() {
        global $objSession;
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';


        //if($objSession instanceof Painel && (date('H') > 17 || date('H') < 8 || in_array(date('w'), array(0,6)) ) ){
        //    $error .= '<li>Hor&aacute;rio bloqueado. Os tickets de atendimento s&oacute; podem ser abertos de seg. &agrave; sex. de 8 &agrave;s 18;</li>';
        //}
       
        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        global $objSession;
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('solicitante', $_POST["solicitante"]);
            $objeto->set('id_setor', $_POST["id_setor"]);
            $objeto->set('descricao', $_POST["descricao"]);
            $objeto->set('id_painel', $_POST["id_painel"]);
            $objeto->set('id_setor', $_POST["id_setor"]);
            $objeto->set('id_responsavel', $_POST["id_responsavel"]);
            $objeto->set('status', $_POST["status"]);
        
        
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        global $objSession;
        $classe = __CLASS__;
        $objeto = new $classe();
        if($objSession->get('gerente') != 1){
            MessageBox::Show("Sem permiss&atilde;o.", "danger");
            return false;
        }
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $objC = new Painel();

        $table = "(
                    SELECT a.*, b.nome painel, b.email FROM  
                    {$objeto->getNomeTable(true)} a 
                    LEFT JOIN {$objC->getNomeTable(true)} b ON a.id_painel = b.id
                    ) atendimentos
                    ";
        if($opcao == 'todos' && !ctype_digit($parametro) && $parametro != ''){
            $parametro_adicional = "
            (
            nome LIKE '%$parametro%' OR descricao LIKE '%$parametro%' 
            OR painel LIKE '%$parametro%' OR email LIKE '%$parametro%') ".$parametro_adicional;
            $opcao = '';
            $parametro = '';
        }
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit, $table);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $objSession;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('data', date('Y-m-d H:i:s'));
        $objeto->set('valor', 0);
        $objeto->set('status', 1);

        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }else{
            $codigo += 0;
        }


        if($objSession instanceof Painel){

            //if( date('H') > 17 || date('H') < 8 || in_array(date('w'), array(0,6)) ){
            //    $string .= MessageBox::Show('ATEN&Ccedil;&Atilde;o: Os tickets de atendimento s&oacute; podem ser abertos de seg. &agrave; sex. de 8 &agrave;s 18','warning',true);
            //}
           

            $string .= '<div class="form-group col-sm-3 required">';
            $string .= '<label for="">Solicitante</label>';
            $string .= '<input name="solicitante" type="text" class="form-control required" maxlength="50" value="' . $objeto->get('solicitante') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-5 required">';
            $string .= '<label for="">Descreva seu problema</label>';
            $string .= '<input name="nome" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('nome') . '"/>';
            $string .= '</div>';

            $string .= '
            <div class="form-group col-md-12">
                <label for="">Mais detalhes</label>
                <textarea class="form-control" rows="8" name="descricao">' . $objeto->get('descricao') . '</textarea>
            </div>';

        }else{
            
            $string .= '<div class="form-group col-sm-6 required">';
            $string .= '<label for="">Painel </label>';
            $string .= '<input id="id_painel" name="id_painel" type="hidden" value="'.$objeto->get('id_painel').'"/>';
            $string .= '<div class="input-group">';
            $string .= '<input id="m_painel" type="text" class="form-control autocomplete" data-table="paineis" data-callback="getDataPainel(ui.item.value);" data-field="id_painel" value="'.$objeto->getPainel()->get('nome').'"/>';
            $string .= '<div class="input-group-addon'.($objeto->getPainel()->get('tipo')==2?' gold':'').'" id="tipo_painel"><a href="javascript:;" onclick="javascript:openFastEdit(\'paineis\',$(\'#id_painel\').val(),\'\',\'\',\'\');"><span class="glyphicon glyphicon-user"></span></a></div>';
            $string .= '</div>';
            $string .= '</div>';
        
            $string .= '<div class="form-group col-sm-6 required">';
            $string .= '<label for="">Problema</label>';
            $string .= '<input name="nome" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('nome') . '"/>';
            $string .= '</div>';
           
            $string .= '
            <div class="form-group col-md-12">
                <label for="">Mais detalhes</label>
                <textarea class="form-control" rows="8" name="descricao">' . $objeto->get('descricao') . '</textarea>
            </div>';
             
            
            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Setor</label>';
            $string .= '<select class="form-control" name="id_setor" id="id_setor">';
            foreach (self::$nmSetor as $key => $value) {
                $string .= '<option value="' . $key . '" ' . ($objeto->get('id_setor') == $key ? " selected " : "") . '>' . $value . '</option>';
            }
            $string .= '</select>';
            $string .= '</div>';
            
            
            $string .= '<div class="form-group col-sm-4 required">';
            $string .= '<label for="">Respons&aacute;vel <a href="javascript:;" class="btn btn-primary btn-xs addcat" onclick="javascript:openFastAdd(\'usuarios\',\'responsavel\',\'/filtro/helpdesk,i,1\');"><span class="glyphicon glyphicon-plus"></span></a></label>';
            $string .= '<select class="form-control" name="id_responsavel" id="id_responsavel">';
            $string .= '<option value="0" ' . ($objeto->get('id_responsavel') == 0 ? " selected " : "") . '>&nbsp;</option>';
            $rs = Usuario::Buscar('id,nome', '', '', '', 'nome ASC');
            while ($rs->next()) {
                $string .= '<option value="' . $rs->getInt('id') . '" ' . ($objeto->get('id_responsavel') == $rs->getInt('id') ? " selected " : "") . '>' . $rs->getString('nome') . '</option>';
            }
            unset($rs);
            $string .= '</select>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Situa&ccedil;&atilde;o</label>';
            $string .= '<select class="form-control" name="status" id="status">';
            foreach (self::$nmStatus as $key => $value) {
                $string .= '<option value="' . $key . '" ' . ($objeto->get('status') == $key ? " selected " : "") . '>' . $value . '</option>';
            }
            $string .= '</select>';
            $string .= '</div>';
            
            if($codigo > 0){
            

                    $string .= '<div class="col-sm-12"><h4>Repostas <a href="javascript:void(0);" class="pull-right small" onclick="if($(\'.reply-editor\').css(\'display\') == \'none\'){ $(\'.reply-editor\').slideDown(\'fast\');}else{$(\'.reply-editor\').slideUp(\'fast\');}"><span class="glyphicon glyphicon-arrow-left"></span> Responder</a></h4>';
                
                    $string .= '<div class="row reply-editor">';
                    
                        $string .= '<div class="form-group col-sm-12">';
                        $string .= '<label for="">Resposta</label>';
                        $string .= '<textarea id="resposta" class="form-control" name="resposta" rows="4"></textarea>';
                        $string .= '</div>';

                        $string .= '<div class="form-group col-sm-12">';
                        $string .= '<label>
                                        <input type="checkbox" name="change-status" id="change-status" value="1"> Mudar Status do atendimento para "Aguardando Cliente".
                                    </label> ';
                        $string .= '</div>';

                        $string .= '<div class="form-group col-sm-12">';
                        $string .= '<label>
                                        <input type="checkbox" name="send-mail" id="send-mail" value="1"> Enviar email de aviso informando que o atendimento foi respondido.
                                    </label> ';
                        $string .= '</div>';

                        $string .= '<div class="form-group col-sm-12">';
                        $string .= '<button class="btn btn-primary btn-sm" type="button" id="btnAddItem" onclick="javascript: addItemAtendimento('.$codigo.',$$(\'resposta\').value,$$(\'change-status\').checked,$$(\'send-mail\').checked);"><span class="glyphicon glyphicon-send"></span> Enviar</button> ';
                        $string .= '<button class="btn btn-default btn-sm" type="button" onclick="$(\'.reply-editor\').slideUp(\'fast\'); return false;">Cancelar</button> ';
                        $string .= '</div>';
                    $string .= '</div>';
                    
                    $string .= '<div id="txtItens">';
                        $rs = ItemAtendimento::Buscar('id, id_atendimento', $codigo, 'id_atendimento', '', 'id DESC');
                        $string .= ItemAtendimento::GetTable($rs, $codigo);
                    $string .= '</div>';
                $string .= '</div>';
                $string .= '</div>';
            }
            
        }

        return $string;
    }

    public static function GetTable($rs) {
        global $request;
        $string = '
            <table class="table table-responsive table-striped table-hover">
            <thead>
              <tr>
                '.($request->get('module')=='atendimentos'?'<th width="10"><input id="qtdRegistros" type="checkbox" onclick="javascript:marcaCheckBoxGG();" value="' . $rs->numRows() . '"/></th>':'').'
                <th class="col-sm-7 col-xs-7">Ocorr&ecirc;ncia</th>
                <th class="col-sm-4 col-xs-3">Painel</th>
                <th class="col-sm-1 col-xs-2 text-center">Situa&ccedil;&atilde;o</th>
              </tr>
            </thead>
            <tbody>';
        $i = 0;
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $i++;
            $string .= '<tr id="tr">
                '.($request->get('module')=='atendimentos'?'<td><input type="checkbox" id="chkDel' . $i . '" value="' . $objeto->get('id') . '" onclick="javascript:controlDelButton();" /></td>':'').'
                <td class="link-edit">
                    <a href="'.($request->get('module')=='atendimentos'?'#editar-' . $objeto->get('id'):'javascript:;') . '" onclick="javascript: showEditForm(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Editar">'.$objeto->get('id')." - " . $objeto->get('nome') . '</a> 
                    <a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');"><span class="glyphicon glyphicon-trash" data-toggle="tooltip" data-placement="left" title="Excluir"></span></a>
                    <br><em class="small">' . Data::getFormat($objeto->get('dt_cad'), 'd/m/Y H:i') . ' - Respons&aacute;vel: <strong>'.$objeto->getResponsavel()->get('nome').'</strong></em> 
                </td>
                <td class="small"><a href="javascript:;" onclick="javascript: openFastEdit(\'painels\','.$objeto->get('id_painel').',\'\',\'\',\'\');" data-toggle="tooltip" data-placement="right" title="Editar painel">' . $objeto->getPainel()->get('nome') . '</a></td>
                <td class="text-center small">' . self::$nmStatus[$objeto->get('status')] . '</td>
                
            </tr>';
        }
        unset($i, $rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    
    public function getFilterAdditional() {
        $arr['name'] = 'Situa&ccedil;&atilde;o';
        $arr['data'] = array();
        foreach(self::$nmStatus as $key=>$value){
            $arr['data'] += array('status,i,'.$key=>$value);
        }
        $arr['data'] += array('' => 'Todos');
        return $arr;
    }
}
