<?php

class AvaliacaoProduto extends Flex {

    protected $nomeTable = 'avaliacoesproduto';
    protected $mapper = array(
        'id' => 'int',
        'id_produto' => 'int',
        'id_pedido' => 'int',
        'descricao' => 'string',
        'nota' => 'number',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    protected $prod = null;
    public function getProduto() {
        if (!$this->prod || $this->prod->get('id') != $this->get('id_produto')) {
            if($this->get('id_produto') == 0){

            }else{ 
                $this->prod = Produto::CarregarObjeto($this->get('id_produto'));
                
            }
        }
        return $this->prod;
    }

    protected $ped = null;
    public function getPedido() {
        if (!$this->ped || $this->ped->get('id') != $this->get('id_pedido')) {
            if($this->get('id_pedido') == 0){

            }else{ 
                $this->ped = Pedido::CarregarObjeto($this->get('id_pedido'));
                
            }
        }
        return $this->ped;
    }
    
    protected $pessoa = null;
    public function getPessoa() {
        if (!$this->pessoa || $this->pessoa->get('id') != $this->getPedido()->get('id_pessoa')) {
            $this->pessoa =$this->getPedido()->getPessoa();
        }
        return $this->pessoa;
    }
    
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('id_produto', $_POST["id_produto"]);
            $objeto->set('id_pedido', $_POST["id_pedido"]);
            $objeto->set('descricao', $_POST["descricao"]);
            $objeto->set('nota', (float) str_replace(',','.',str_replace('.','',$_POST["nota"])));

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();
            
            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('nota',5);
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }else{
            $objeto->set('id_produto',$request->get('id_produto')+0);
            $objeto->set('id_pedido',$request->get('id_pedido')+0);
        }
        
        $string .= '<input name="id_pedido" type="hidden" value="' . $objeto->get('id_pedido') . '"/>';
        $string .= '<input name="id_produto" type="hidden" value="' . $objeto->get('id_produto') . '"/>';
        
        $string .= '<div class="form-group col-sm-3">';
        $string .= '<label for="">Nota</label>';
        $string .= '<input name="nota" id="valor_mov" type="text" class="form-control money" maxlength="255" value="'.Common::parseMoney($objeto->get('nota')+0).'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-12">';
        $string .= '<label for="">Descri&ccedil;&atilde;o</label>';
        $string .= '<textarea id="descricao" class="form-control name="descricao" rows="10">' . $objeto->get('descricao') . '</textarea>';
        $string .= '</div>';

        return $string;
    }

    public static function GetTable($rs) {
        $string = '';

        if($rs->numRows()>0){
            $string = '
                <table class="table table-responsive table-striped table-hover">
                <thead>
                  <tr>
                    <th class="col-sm-10">Descri&ccedil;&atilde;o</th>
                    <th class="col-sm-2 text-center">Nota</th>
                  </tr>
                </thead>
                <tbody>';
                while ($rs->next()) {
                    $objeto = self::CarregarObjeto($rs->getInt('id'));
                    $string .= '<tr id="tr">
                        <td class="link-edit text-center">
                            <a href="javascript:;" onclick="javascript: openFastEdit(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'txtAvaliacoes\',\'/filtro/id_produto,i,'.$objeto->get('id_produto').'\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->getPessa()->get('nomefantasia').'</a> 
                            <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'getTableList(\\\'txtAvaliacoes\\\', \\\''.$objeto->getNomeTable().'/filtro/id_produto,i,'.$objeto->get('id_produto').'\\\')\',false);" data-toggle="tooltip" data-placement="top" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a>
                            <br><span class="small">'.$objeto->get('descricao').'</span>
                        </td>
                        <td>'.Common::parseMoney($objeto->get('nota')).'</td>
                    </tr>';
                }

            $string .= "</tbody>
                  </table>";
        }else{
            $string .= 'Nenhuma avalia&ccedil;&atilde;o adicionado.';
        }

        return $string;
    }
    
}
