<?php


class Api {

    public $baseUrl = '';
    public $defaultHeaders = [];
    
    public function __construct($baseUrl='', $defaultHeaders=[]){
        $this->baseUrl = $baseUrl;
        $this->defaultHeaders = $defaultHeaders;
    }

    public function post($url, $vars=[], $headers=[]){
        return $this->request('POST',$this->baseUrl.$url, $vars, $headers);
    }

    public function put($url, $vars=[], $headers=[]){
        return $this->request('PUT',$this->baseUrl.$url, $vars, $headers);
    }

    public function delete($url, $headers=[]){
        return $this->request('DELETE',$this->baseUrl.$url, [], $headers);
    }

    public function get($url, $headers=[]){
        return $this->request('GET',$this->baseUrl.$url, [], $headers);
    }

    public function request($type, $url, $vars=[], $headersX = []){
        $headers = array_merge($headersX, $this->defaultHeaders);
        $curl = curl_init();
        //echo $url.'<br><br>';
        if(count($vars) > 0){
            $data_string = json_encode($vars);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data_string);
            $headers[] = 'Content-Length: ' . strlen($data_string);
        }

        curl_setopt($curl, CURLOPT_CUSTOMREQUEST, $type);
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_MAXREDIRS, 10);
        curl_setopt($curl, CURLOPT_TIMEOUT, 0);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, false);
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    
        $response = curl_exec($curl);

        $ret = array(
            'response' => $response,
            'error' => curl_error($curl),
            'info' => curl_getinfo($curl),
        );
        curl_close($curl);

        return $ret;
    }

}
