<?php

class Data {
    public static $arrDOW = array('dom','seg','ter','qua','qui','sex','sab');
    public static function getNomeMes($mes, $lang) {
        if ($lang == "EN") {
            switch ($mes + 0) {
                case 1: $mes_ext = "January";
                    break;
                case 2: $mes_ext = "February";
                    break;
                case 3: $mes_ext = "March";
                    break;
                case 4: $mes_ext = "April";
                    break;
                case 5: $mes_ext = "May";
                    break;
                case 6: $mes_ext = "June";
                    break;
                case 7: $mes_ext = "July";
                    break;
                case 8: $mes_ext = "August";
                    break;
                case 9: $mes_ext = "September";
                    break;
                case 10: $mes_ext = "October";
                    break;
                case 11: $mes_ext = "November";
                    break;
                case 12: $mes_ext = "December";
                    break;
            }
        } else {
            switch ($mes + 0) {
                case 1: $mes_ext = "Janeiro";
                    break;
                case 2: $mes_ext = "Fevereiro";
                    break;
                case 3: $mes_ext = "Mar&ccedil;o";
                    break;
                case 4: $mes_ext = "Abril";
                    break;
                case 5: $mes_ext = "Maio";
                    break;
                case 6: $mes_ext = "Junho";
                    break;
                case 7: $mes_ext = "Julho";
                    break;
                case 8: $mes_ext = "Agosto";
                    break;
                case 9: $mes_ext = "Setembro";
                    break;
                case 10: $mes_ext = "Outubro";
                    break;
                case 11: $mes_ext = "Novembro";
                    break;
                case 12: $mes_ext = "Dezembro";
                    break;
            }
        }
        return $mes_ext;
    }

    public static function getNomeDiaSemana($dia, $lang) {
        $diaSem = '';
        if ($lang == "EN") {
            switch ($dia) {
                case "0" : $diaSem = "Sunday";
                    break;
                case "1" : $diaSem = "Monday";
                    break;
                case "2" : $diaSem = "Thursday";
                    break;
                case "3" : $diaSem = "Wednesday";
                    break;
                case "4" : $diaSem = "Tuesday";
                    break;
                case "5" : $diaSem = "Friday";
                    break;
                case "6" : $diaSem = "Saturday";
                    break;
            }
        } else {
            switch ($dia) {
                case "0" : $diaSem = "Domingo";
                    break;
                case "1" : $diaSem = "Segunda-feira";
                    break;
                case "2" : $diaSem = "Ter&ccedil;a-feira";
                    break;
                case "3" : $diaSem = "Quarta-feira";
                    break;
                case "4" : $diaSem = "Quinta-feira";
                    break;
                case "5" : $diaSem = "Sexta-feira";
                    break;
                case "6" : $diaSem = "S&aacute;bado";
                    break;
            }
        }

        return $diaSem;
    }

    public static function getFormat($data, $formato, $lang = 'PT') {
        if (self::isValid($data)) {
            $regex1 = '/^([0-9]{2})\/([0-9]{2})\/([0-9]{4})/';
            $regex2 = '/^([0-9]{4})-([0-9]{2})-([0-9]{2})/';
            $arrDate = array(
                'h' => 0,
                'i' => 0,
                's' => 0,
                'd' => 0,
                'm' => 0,
                'y' => 0,
            );
            $pData = explode(" ", $data);
            if (preg_match($regex2, $data)) {
                list($arrDate['y'], $arrDate['m'], $arrDate['d']) = explode('-', $pData[0]);
            } else {
                list($arrDate['d'], $arrDate['m'], $arrDate['y']) = explode('/', $pData[0]);
            }

            if (isset($pData[1])) {
                list($arrDate['h'], $arrDate['i'], $arrDate['s']) = explode(':', $pData[1]);
            }

            $mkDate = mktime($arrDate['h'], $arrDate['i'], $arrDate['s'], $arrDate['m'], $arrDate['d'], $arrDate['y']);

            if (strtolower($formato) == 'extenso') {
                $result = $arrDate['d'] . ' de ' . self::getNomeMes($arrDate['m'], $lang) . ' de ' . $arrDate['y'];
            } elseif (strtolower($formato) == 'completa') {
                $replacement = ($lang != 'EN' ? "%s, %s de %s de %s" : '%s, %s %s %s');
                $result = sprintf($replacement, self::getNomeDiaSemana(date("w", $mkDate), $lang), $arrDate['d'], self::getNomeMes($arrDate['m'], $lang), $arrDate['y']
                );
            } else {
                $result = date($formato, $mkDate);
            }

            return $result;
        } else {
            return 'Invalid date.';
        }
    }

    public static function isValid($data) {
        $regex1 = '/^([0-9]{2})\/([0-9]{2})\/([0-9]{4})/';
        $regex2 = '/^([0-9]{4})-([0-9]{2})-([0-9]{2})/';
        $arrDate = array(
            'h' => 0,
            'i' => 0,
            's' => 0,
            'd' => 0,
            'm' => 0,
            'y' => 0,
        );
        $pData = explode(" ", $data);
        $test1 = @preg_match($regex1, $data);
        $test2 = @preg_match($regex2, $data);
        if ($test2) {
            list($arrDate['y'], $arrDate['m'], $arrDate['d']) = explode('-', $pData[0]);
        } elseif ($test1) {
            list($arrDate['d'], $arrDate['m'], $arrDate['y']) = explode('/', $pData[0]);
        } else {
            return false;
        }
        return checkdate($arrDate['m'], $arrDate['d'], $arrDate['y']);
    }

    public static function BuscaDataCompleta() {
        switch (date("w")) {
            case "0" : $retorno = "Domingo, ";
                break;
            case "1" : $retorno = "Segunda, ";
                break;
            case "2" : $retorno = "Ter&ccedil;a, ";
                break;
            case "3" : $retorno = "Quarta, ";
                break;
            case "4" : $retorno = "Quinta, ";
                break;
            case "5" : $retorno = "Sexta, ";
                break;
            case "6" : $retorno = "S&aacute;bado, ";
                break;
        }
        $retorno .= date("d") . " de ";
        switch (date("m")) {
            case "01" : $retorno .= "janeiro";
                break;
            case "02" : $retorno .= "fevereiro";
                break;
            case "03" : $retorno .= "mar&ccedil;o";
                break;
            case "04" : $retorno .= "abril";
                break;
            case "05" : $retorno .= "maio";
                break;
            case "06" : $retorno .= "junho";
                break;
            case "07" : $retorno .= "julho";
                break;
            case "08" : $retorno .= "agosto";
                break;
            case "09" : $retorno .= "setembro";
                break;
            case "10" : $retorno .= "outubro";
                break;
            case "11" : $retorno .= "novembro";
                break;
            case "12" : $retorno .= "dezembro";
                break;
        }
        return $retorno . " de " . date("Y");
    }

    public static function RemontaData($data, $separadores, $entrada, $saida) {

        $arrEnt = explode($separadores, $entrada);
        $arrDat = explode($separadores, $data);

        $dtMod = array($arrEnt[0] => $arrDat[0], $arrEnt[1] => $arrDat[1], $arrEnt[2] => $arrDat[2]);

        $newDate = str_replace($arrEnt[0], $dtMod[$arrEnt[0]], $saida);
        $newDate = str_replace($arrEnt[1], $dtMod[$arrEnt[1]], $newDate);
        $newDate = str_replace($arrEnt[2], $dtMod[$arrEnt[2]], $newDate);

        return $newDate;
    }
    public static function isHoliday($ano, $data){
        $dia = 86400;
        $data = self::getFormat($data,'d/m/Y');
        $datas = array();
        $datas['pascoa'] = easter_date($ano);
        $datas['sexta_santa'] = $datas['pascoa'] - (2 * $dia);
        $datas['carnavalt'] = $datas['pascoa'] - (47 * $dia);
        $datas['carnavals'] = $datas['pascoa'] - (48 * $dia);
        $datas['corpus_cristi'] = $datas['pascoa'] + (60 * $dia);
        $feriados = array (
            date('d/m',$datas['carnavalt']),
            date('d/m',$datas['carnavals']),
            date('d/m',$datas['sexta_santa']),
            date('d/m',$datas['pascoa']),
            date('d/m',$datas['corpus_cristi']),
            '01/01',
            '12/10',
            '21/04',
            '01/05',
            '23/08',
            '02/11',
            '25/12',
            '15/11',
        );
         
        //return (in_array(substr($data,0,5),$feriados) || Holiday::VerificaExistencia('','',"(DATE_FORMAT(data,'%d/%m') = '".self::getFormat($data,'d/m')."' AND tipo = 1) OR data = '".self::getFormat($data,'Y-m-d')."'"));
        return (in_array(substr($data,0,5),$feriados));
    }

    public static function dateToTimestamp($data){
        $ano = substr($data, 6,4);
        $mes = substr($data, 3,2);
        $dia = substr($data, 0,2);
        return mktime(0, 0, 0, $mes, $dia, $ano);  
    } 

    
    public static function isHoraUtil($dh){
        $dow = self::$arrDOW[self::getFormat($dh,'w')];
        $hora = strtotime(self::getFormat($dh,'H:i:s'));
        $util = false;
        if(Config::getConfig($dow) == 1){
            if(Config::getConfig($dow.'_i') == 1 && Config::getConfig($dow.'_ii') != '' && Config::getConfig($dow.'_if') != ''){
                $util = (
                    ($hora >= strtotime(Config::getConfig($dow.'_hi').':00') && $hora <= strtotime(Config::getConfig($dow.'_ii').':00') )
                    ||
                    ($hora >= strtotime(Config::getConfig($dow.'_if').':00') && $hora <= strtotime(Config::getConfig($dow.'_hf').':00'))
                );
            }else{
                $util = ($hora >= strtotime(Config::getConfig($dow.'_hi').':00') && $hora <= strtotime(Config::getConfig($dow.'_hf').':00'));
            }
        }
        return $util;
        
        /*
        global $Config;
        $pts = explode(' ',$dh);
        $pD = explode('/',$pts[0]);
        $pH = explode(':',$pts[1]);
        $hrIni = explode(':',$Config->InicioExpediente);
        $hrFim = explode(':',$Config->FimExpediente);
        
        if($pH[0] < $hrIni[0] || $pH[0] > $hrFim[0]){
            return false;
        }else{
            if($pH[0] == $hrFim[0] && ($pH[1] > $hrFim[1] || $pH[2] > 0)){
                return false;
            }elseif($pH[0] == $hrIni[0] && $pH[1] < $hrIni[1]){
                return false;
            }else{
                return true;
            }
        }*/
    }

    public static function isDiaUtil($dh){
        $dow = self::$arrDOW[self::getFormat($dh,'w')];
        return (Config::getConfig($dow) == 1 && !self::isHoliday(self::getFormat($dh,'Y'), self::getFormat($dh,'Y-m-d')));
        /*
        global $Config;
        $pts = explode(' ',$dh);
        $arrDNT = array();
        if($Config->DDS0+0==0) $arrDNT[] = 0;
        if($Config->DDS1+0==0) $arrDNT[] = 1;
        if($Config->DDS2+0==0) $arrDNT[] = 2;
        if($Config->DDS3+0==0) $arrDNT[] = 3;
        if($Config->DDS4+0==0) $arrDNT[] = 4;
        if($Config->DDS5+0==0) $arrDNT[] = 5;
        if($Config->DDS6+0==0) $arrDNT[] = 6;
        return (!self::isHoliday(date('Y'), $pts[0]) && !in_array(date("w", self::dateToTimestamp($pts[0])), $arrDNT));*/
    }

    public static function soma1Hora($dh){
        $pts = explode(' ',$dh);
        $pD = explode('/',$pts[0]);
        $pH = explode(':',$pts[1]);
        return date("d/m/Y H:i:s", mktime($pH[0]+1, $pH[1], $pH[2], $pD[1], $pD[0], $pD[2]));
    }
    
    public static function somaMin($dh,$qtd=1){
        $pts = explode(' ',$dh);
        $pD = explode('/',$pts[0]);
        $pH = explode(':',$pts[1]);
        return date("d/m/Y H:i:s", mktime($pH[0], $pH[1]+$qtd, $pH[2], $pD[1], $pD[0], $pD[2]));
    }

    public static function soma1Dia($dh){
        $pts = explode(' ',$dh);
        $pD = explode('/',$pts[0]);
        $pH = explode(':',$pts[1]);
        return date("d/m/Y H:i:s", mktime($pH[0], $pH[1], $pH[2], $pD[1], $pD[0]+1, $pD[2]));
    }

    public static function SomaHorasUteis($data,$qtd){
        while(!self::isHoraUtil($data)){
            $data = self::soma1Hora($data);
        }
        for($i=1; $i<=$qtd; $i++){
            $data = self::soma1Hora($data);
            while(!self::isHoraUtil($data)){
                $data = self::soma1Hora($data);
            }

            while(!self::isDiaUtil($data)){
                $data = self::soma1Dia($data);
            }
        }
        return $data;
    }

    public static function SomaDiasUteis($data, $qtd){
        for($i=1; $i<=$qtd; $i++){
            $data = self::soma1Dia($data);
            while(!self::isDiaUtil($data)){
                $data = self::soma1Dia($data);
            }
        }
        return $data;
    }
    
    public static function SomaMinutosUteis($data, $qtd){
        $qtdHs = floor($qtd/60);
        $minRest = $qtd - ($qtdHs*60);
        $min = self::getFormat($data,'mi');
        
        //realizando o ajuste de minutos
        if($minRest > 0){
            if($minRest+$min > 60){
                $data = self::SomaHorasUteis($data,1);
                $data = self::somaMin($data,$minRest-60);//subtrai os minutos que passaram ap�s somar 1h
            }else{
                $data = self::somaMin($data,$minRest);
             
            }
        }
        //realizando a somat�ria de horas
        for($i=1; $i<=$qtdHs; $i++){
            $data = self::SomaHorasUteis($data,1);
        }
        return $data;
    }
}
