<?php

class Flex {

    protected $params = array();
    protected $mapper = array();
    protected $persisted = false;
    protected $nomeTable;
    protected $prefixTable = '';
    protected $primaryKey = array();

    public function __construct($id = array()) {

        $this->setPersisted(false);

        if (count($id) > 0) {
            if ($id[0] != "") {
                $i = 0;
                foreach ($this->primaryKey as $pk) {
                    $this->set($pk, $id[$i++]);
                }
                $this->setPersisted(true);
            }
        }
    }

    public function set($var, $value) {
        $this->params[$var] = $value;
    }

    public function get($var) {
        if (array_key_exists($var, $this->params)) {
            return $this->params[$var];
        } else {
            return '';
        }
    }

    public function getImage($type = 'r', $id = 0, $nomeTable = '') {
        if($this->get('img') == '')
            return '';
        
        global $defaultPath;
        if ($nomeTable == '')
            $nomeTable = $this->getNomeTable();
        if ($id == 0)
            $id = $this->get('id');
        $path = "uploads/" . $nomeTable . ($nomeTable[(strlen($nomeTable) - 1)] == '/' ? '' : '/');
        
        $img = str_pad($id + 0, 7, '0', STR_PAD_LEFT) . '_';
        switch ($type) {
            case 'thumb' : case 't' : case 'xs' : $img .= 'thumb';
                break;
            case 'small' : case 's' : case 'sm' :  $img .= 'small';
                break;
            case 'zoom' : case 'z' : case 'lg' : $img .= 'zoom';
                break;
            default : $img .= 'regular';
                break;
        }
        $img .= '_'.$this->get('img');
        if(file_exists($defaultPath . $path.$img)){
            return __PATH__ . $path.$img;
        }elseif(file_exists($defaultPath.$path.$this->get('img'))){
            return __PATH__ . $path.$this->get('img');
        }
        return '';
    }

    public function getFile($id = 0, $nomeTable = '', $nmFile='file') {
        global $defaultPath;
        if ($nomeTable == '')
            $nomeTable = $this->getNomeTable();
        if ($id == 0)
            $id = $this->get('id');
        $file = "uploads/" . $nomeTable . ($nomeTable[(strlen($nomeTable) - 1)] == '/' ? '' : '/');
        $file .= str_pad($id + 0, 7, '0', STR_PAD_LEFT) . '_'.$this->get($nmFile);
        return (file_exists($defaultPath . $file) ? __PATH__ . $file : '');
    }
    
    public function getPhysicalFile($id = 0, $nomeTable = '', $nmFile='file') {
        global $defaultPath;
        if ($nomeTable == '')
            $nomeTable = $this->getNomeTable();
        if ($id == 0)
            $id = $this->get('id');
        $file = "uploads/" . $nomeTable . ($nomeTable[(strlen($nomeTable) - 1)] == '/' ? '' : '/');
        $file .= str_pad($id + 0, 7, '0', STR_PAD_LEFT) . '_'.$this->get($nmFile);
        return (file_exists($defaultPath . $file) ? $defaultPath . $file : '');
    }
    
    public function getFileSize($id = 0, $nomeTable = '', $nmFile='file') {
        global $defaultPath;
        if ($nomeTable == '')
            $nomeTable = $this->getNomeTable();
        if ($id == 0)
            $id = $this->get('id');
        $file = "uploads/" . $nomeTable . ($nomeTable[(strlen($nomeTable) - 1)] == '/' ? '' : '/');
        $file .= str_pad($id + 0, 7, '0', STR_PAD_LEFT) . '_'.$this->get($nmFile);
        
        $file = $defaultPath . $file;
        if(file_exists($file))
            $tamanhoarquivo = filesize($file);
        else{
            return "0KB";
        }

        $bytes = array('B','KB', 'MB', 'GB', 'TB');

        if($tamanhoarquivo <= 999)
            $tamanhoarquivo = 1;

        for($i = 0; $tamanhoarquivo > 999; $i++) {
            $tamanhoarquivo /= 1024;
        }

        return round($tamanhoarquivo).$bytes[$i];
        
    }
    
    public function issetParam($var) {
        return (array_key_exists($var, $this->mapper));
    }

    public function getMapper() {
        return $this->mapper;
    }

    public function getParams() {
        return $this->params;
    }

    public function typeParam($var) {
        return $this->mapper[$var];
    }

    public function getNomeTable($prefix = false) {
        
        return ($prefix ? $this->getPrefixTable() : '').$this->nomeTable;
    }

    public function getPrefixTable() {
        return $this->prefixTable;
    }

    public function setPersisted($value) {
        $this->_persisted = $value;
    }

    public function getPersisted() {
        return $this->_persisted;
    }

    public function Inserir() {
        $retorno = array(0 => 0, 1 => false);
        try {
            $connection = new Connection();

            $campos = $valores = "";

            $usr = (isset($_SESSION[$GLOBALS['Sessao']]['obj']) ? $_SESSION[$GLOBALS['Sessao']]['obj']->get('login') : 'site');
            if($usr == 'site' && isset($_SESSION[$GLOBALS['SessaoC']]['obj'])){
                $usr = $_SESSION[$GLOBALS['SessaoC']]['obj']->get('login');
            }
            if ($this->issetParam("usr_cad")) {
                $this->set("usr_cad", $usr);
            }
            if ($this->issetParam("dt_cad")) {
                if (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle')
                    $this->set("dt_cad", 'SYSDATE');
                elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'sqlserver')
                    $this->set("dt_cad", 'GETDATE()');
                elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'postgre')
                    $this->set("dt_cad", 'current_date');
                else
                    $this->set("dt_cad", 'NOW()');
            }
            if ($this->issetParam("usr_ualt")) {
                $this->set("usr_ualt", $usr);
            }
            if ($this->issetParam("dt_ualt")) {
                if (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle')
                    $this->set("dt_ualt", 'SYSDATE');
                elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'sqlserver')
                    $this->set("dt_ualt", 'GETDATE()');
                elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'postgre')
                    $this->set("dt_ualt", 'current_date');
                else
                    $this->set("dt_ualt", 'NOW()');
            }

            foreach ($this->params as $var => $value) {
                if ($var != '') {
                    $campos .= ($campos == '' ? '' : ', ') . "{$var}";
                    $valores .= ($valores == '' ? '' : ', ') . ":{$var}:";
                }
            }

            if ($this->prefixTable == '') {
                $this->prefixTable = $GLOBALS['DBPREFIX'];
            }

            $statement = $connection->prepareStatement("INSERT INTO {$this->getPrefixTable()}{$this->getNomeTable()} ({$campos}) VALUES ($valores)");
            foreach ($this->params as $var => $value) {
                if ($var != '') {
                    switch (strtolower($this->mapper[$var])) {
                        case 'int' : $statement->setInt($var, $value);
                            break;
                        case 'number' : $statement->setNumber($var, $value);
                            break;
                        case 'sql' : $statement->setSql($var, $value);
                            break;
                        case 'clob' : $statement->setCLOB($var, $value);
                            break;
                        case 'date' :
                            if($value == '') 
                                $statement->setSql($var, "NULL");
                            elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle')
                                $statement->setSql($var, "TO_DATE('{$value}','DD/MM/YYYY HH24:MI:SS')");
                            else
                                $statement->setString($var, $value);
                            break;
                        default : $statement->setString($var, $value);
                            break;
                    }
                }
            }

            //pegando a primary key - Usado apenas em oracle
            if (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle') {
                foreach ($this->primaryKey as $pk) {
                    if ($this->params[$pk] == '') {
                        $statement->setReturnVar($pk);
                    }
                }
            }
            
            $retorno[0] = $statement->executeQuery();

            //$connection->closeConnection();

            $retorno[1] = true;
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
        return $retorno;
    }

    public function Alterar() {
        $retorno = array(0 => 0, 1 => "");
        try {
            $connection = new Connection();

            $usr = (isset($_SESSION[$GLOBALS['Sessao']]['obj']) ? $_SESSION[$GLOBALS['Sessao']]['obj']->get('login') : 'site');
            if($usr == 'site' && isset($_SESSION[$GLOBALS['SessaoC']]['obj'])){
                $usr = $_SESSION[$GLOBALS['SessaoC']]['obj']->get('login');
            }
            
            if ($this->issetParam("usr_ualt")) {
                $this->set("usr_ualt", $usr);
            }
            if ($this->issetParam("dt_ualt")) {
                if (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle')
                    $this->set("dt_ualt", 'SYSDATE');
                elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'sqlserver')
                    $this->set("dt_ualt", 'GETDATE()');
                elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'postgre')
                    $this->set("dt_ualt", 'current_date');
                else
                    $this->set("dt_ualt", 'NOW()');
            }

            $valores = $where = "";

            foreach ($this->params as $var => $value) {
                if (!in_array($var, $this->primaryKey) && $var != "dt_cad" && $var != 'usr_cad') {
                    $valores .= ($valores == '' ? '' : ', ') . "{$var} = :{$var}:";
                }
            }

            foreach ($this->primaryKey as $pk) {
                $where .= ($where == '' ? '' : ' AND ') . "{$pk} = :{$pk}:";
            }

            if ($this->prefixTable == '') {
                $this->prefixTable = $GLOBALS['DBPREFIX'];
            }

            $statement = $connection->prepareStatement("UPDATE {$this->getPrefixTable()}{$this->getNomeTable()} SET {$valores} WHERE {$where}");
            foreach ($this->params as $var => $value) {
                if (!in_array($var, $this->primaryKey) && $var != "dt_cad" && $var != 'usr_cad') {
                    switch (strtolower($this->mapper[$var])) {
                        case 'int' : $statement->setInt($var, $value);
                            break;
                        case 'number' : $statement->setNumber($var, $value);
                            break;
                        case 'sql' : $statement->setSql($var, $value);
                            break;
                        case 'clob' : $statement->setCLOB($var, $value);
                            break;
                        case 'date' :
                            if($value == '') 
                                $statement->setSql($var, "NULL");
                            elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle')
                                $statement->setSql($var, "TO_DATE('{$value}','DD/MM/YYYY HH24:MI:SS')");
                            else
                                $statement->setString($var, $value);
                            break;
                        default : $statement->setString($var, $value);
                            break;
                    }
                }
            }

            foreach ($this->primaryKey as $pk) {
                switch (strtolower($this->mapper[$pk])) {
                    case 'int' : $statement->setInt($pk, $this->params[$pk]);
                        break;
                    case 'number' : $statement->setNumber($pk, $this->params[$pk]);
                        break;
                    case 'sql' : $statement->setSql($pk, $this->params[$pk]);
                        break;
                    case 'date' :
                        if (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle')
                            $statement->setSql($pk, "TO_DATE('{$this->params[$pk]}','DD/MM/YYYY HH24:MI:SS')");
                        else
                            $statement->setString($pk, $this->params[$pk]);
                        break;
                    default : $statement->setString($pk, $this->params[$pk]);
                        break;
                }
            }

            $retorno[0] = $statement->executeQuery();
            unset($statement);

            //$connection->closeConnection();

            $retorno[1] = true;
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }

        return $retorno;
    }

    public function Exclui($arr = array()) {
        $retorno = array(0 => 0, 1 => false);
        try {
            $connection = new Connection();

            $where = "";

            foreach ($arr as $var => $value) {
                $where .= ($where == '' ? '' : ' AND ') . "{$var} IN({$value})";
            }
            $statement = $connection->prepareStatement("DELETE FROM {$this->getPrefixTable()}{$this->getNomeTable()} WHERE {$where}");
            $retorno[0] = $statement->executeQuery();

            //$connection->closeConnection();

            $retorno[1] = true;
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }

        return $retorno[1];
    }

    protected function BuscaDadosBanco($arr = array()) {
        try {
            $connection = new Connection();
            $where = "";
            foreach ($arr as $var => $value) {
                $where .= ($where == '' ? '' : ' AND ') . "" . $var . " = '{$value}'";
            }

            $fields = "";
            foreach ($this->mapper as $var => $type) {
                if (strtolower($type) == 'date' && strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle') {
                    $fields .= ",TO_CHAR({$var},'DD/MM/YYYY HH24:MI:SS') as {$var}";
                } else
                    $fields .= ",{$var}";
            }
            $fields = substr($fields, 1);
            $statement = $connection->prepareStatement("SELECT {$fields} FROM {$this->getPrefixTable()}{$this->getNomeTable()} WHERE {$where}");

            return $statement->executeReader();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }

        return false;
    }

    public function carregaObjeto() {
        $arr = array();
        
        foreach ($this->primaryKey as $pk) {
            $arr = array_merge($arr, array($pk => $this->params[$pk]));
        }
        $rs = $this->BuscaDadosBanco($arr);

        if ($rs->numRows() > 0) {
            while ($rs->next()) {
                foreach ($this->mapper as $var => $type) {
                    switch ($type) {
                        case 'int' : $this->set($var, $rs->getInt($var));
                            break;
                        case 'number' : $this->set($var, $rs->getNumber($var));
                            break;
                        default : $this->set($var, $rs->getString($var));
                            break;
                    }
                }

                $this->setPersisted(true);
            }
        }
    }

    public function getTabAdicional() {
        return '';
    }

    public function getContentTabAdicional() {
        return '';
    }

    public function getFilterAdditional() {
        return array('name'=>'','data'=>array());
    }
    
    public function getFilterAdditionalHtml() {
        return '';
    }
    
    public function getFunctionAdditional() {
        return '';
    }

    public function searchInTable($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ativo = "", $ordena = "", $limit = "", $table='') {
        try {
            $select = stripcslashes($select);
            $parametro = stripcslashes($parametro);
            $opcao = stripcslashes($opcao);
            $ativo = stripcslashes($ativo);
            $sql = "";

            $connection = new Connection();

            if($table=='')
                $table = "{$this->getPrefixTable()}{$this->getNomeTable()}";
            $order = ($ordena != "" ? " ORDER BY " . $ordena : "");
            $criterio = "";
            if ($opcao != "") {
                $field = str_replace('=', '', $opcao);
                $isEqual = strpos($opcao, '=');

                if (array_key_exists($field, $this->mapper)) {
                    if ($this->mapper[$field] == 'int') {
                        $criterio = "{$field} IN ({$parametro})";
                    } else {
                        if ($isEqual)
                            $criterio = "{$field} = '{$parametro}'";
                        else
                            $criterio = "{$field} LIKE '%{$parametro}%'";
                    }
                }elseif ($field == 'todos') {
                    $criterio .= "(";
                    if(ctype_digit($parametro) && array_key_exists('id', $this->mapper)){
                        $criterio .= "id IN($parametro)";
                    }
                    foreach ($this->mapper as $key => $type) {
                        if ($type == 'string' && !in_array($key, array('dt_cad', 'usr_cad', 'dt_ualt', 'usr_ualt')))
                            $criterio .= ($criterio == '(' ? '' : ' OR ') . "{$key} LIKE '%".Common::removeDiatrics(utf8_decode($parametro))."%'";
                            //$criterio .= ($criterio == '(' ? '' : ' OR ') . "CONVERT(CAST(CONVERT({$key} USING latin1) AS BINARY) USING utf8) LIKE '%".Common::removeDiatrics($parametro)."%'";
                    }
                    $criterio .= ")";
                    if($criterio == '()') $criterio = '1';
                }
            }

            $criterio .= $parametro_adicional;
            $criterio .= (trim($ativo) != "" ? ($criterio == '' ? '' : ' AND') . " ativo = " . $ativo . " " : "");

            if ($criterio != "") {
                $criterio = " WHERE " . $criterio;
            }

            if ($limit == "") {
                $sql = "SELECT $select FROM {$table} {$criterio} {$order}";
            } else {
                list($inicio, $qtd) = explode(",", $limit);

                if (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'oracle') {
                    $fim += $inicio;
                    $sql = "select *  from ( select topn.*, ROWNUM rnum from (" . $sql . ") topn where ROWNUM <= {$fim} ) where rnum  > {$inicio}";
                } elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'sqlserver') {
                    $inicio +=$qtd;
                    $ordenaInvert = (str_replace(' ASC1', ' DESC', str_replace(' DESC', ' ASC', str_replace(' ASC', ' ASC1', $ordena))));
                    $sql = "select {$select} from 
                    (
                        select top {$qtd} * from 
                        (
                            select top {$inicio} * from {$table} {$criterio}
                            order by {$ordena}
                        ) as newtbl order by {$ordenaInvert}
                    ) as newtbl2 {$order}";
                } elseif (strtolower($GLOBALS['DBCONN']['data']['drive']) == 'postgre') {
                    $sql .= "SELECT $select FROM {$table} {$criterio} {$order} LIMIT {$qtd} OFFSET {$inicio}";
                } else {
                    $sql .= "SELECT $select FROM {$table} {$criterio} {$order} LIMIT {$inicio},{$qtd}";
                }
            }
            //echo "<!-- $sql -->\n";
            $statement = $connection->prepareStatement($sql);
            return $statement->executeReader();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
    }

}
