<?php

class Mail {

    public static function SendMail($from, $fromName, $subject, $destinatarios, $msg, $anexos=array(),$bcc=array(),$sendedEmail=null){
        try{
            
            $msgPadrao = "
                <!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">
                <html xmlns=\"http://www.w3.org/1999/xhtml\">
                <head>
                <meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />
                <title></title>

                <style scoped>

                    .wrapper { padding: 30px 0 }

                    .container { 
                        margin: 0 auto;
                        width: 50%; 
                        min-width: 600px }

                    .text-center { text-align: center }

                    h2 { margin-bottom: 2em }

                    .header { border-bottom: 1px solid #EEE }

                    .body { background: #F6F6F6 }

                    .body-message {
                        line-height: 150%; 
                        line-height: 150%; 
                        font-size: 12pt; 
                        color: #777777 }

                    .group { 
                        display: block;
                        margin-bottom: 30px;
                        background: #FFFFFF;
                        line-height: normal;
                        font-size: 0% }

                    .group-item { 
                        font-size: 12pt;
                        display: inline-block;
                        border-top: 1px solid #DDD }

                    .group-item.col-12  { width: 100% }
                    .group-item.col-4   { width: 33.33333% }

                    .group-item .item-label { 
                        display: block;
                        font-size: 75%;
                        color: #AAA;
                        text-transform: uppercase }

                    .group-item .item-inf { 
                        display: block;
                        font-size: 120%;
                        font-weight: bold;
                        padding-bottom: 20px; }

                    .group-item .item-label,
                    .group-item .item-inf { 
                        border-left: 5px solid #DDD;
                        padding-top: 7px;
                        padding-left: 10px }

                    .btn {
                        border-radius: 5px;
                        background: #00B1B1;
                        color: #FFF;
                        margin: 30px 0;
                        display: inline-block;
                        text-decoration: none;
                        padding: 15px 20px;
                        line-height: normal;
                        font-size: 140% }

                    .btn-link {
                        color: #00B1B1;
                        margin: 30px 0;
                        display: inline-block;
                        text-decoration: none;
                        padding: 15px 20px;
                        line-height: normal;
                        font-size: 140% }

                    .small { font-size: 80% }

                    .cite { 
                        padding-top: 20px;
                        margin-top: 20px;
                        border-top: 1px solid #DDD;
                        font-size: 120% }

                    .footer {
                        font-size: 12pt;
                        border-top: 1px solid #EEE; 
                        color: #AAA }

                    .footer .container { font-size: 75% }

                    @media(max-width: 767px){
                        .container {  
                            margin: 0;
                            padding: 0 20px; 
                            width: 100%; 
                            min-width: auto }
                    }

                </style>

                </head>
                <body>

                <div class=\"header wrapper\">
                    <h1 class=\"container\"><img src=\"https://posvenda.online/img/brand-site-azul.png\" style=\"margin: 0\" height=\"50\" /></h1>
                </div>
                <div class=\"body wrapper\">
                     <div class=\"container\">
                        <h2>{$subject}</h2>
                        <div class=\"body-message\">#MSG#</div>
                    </div>
                </div>

                <div class=\"footer wrapper\">
                    <div class=\"container\">Essa mensagem foi enviado dia ".date("d/m/Y H:i:s")." atrav&eacute;s do sistema PosVenda.Online.</div>
                </div>

                </body></html>";

            $charset = 'utf-8';
            $subject = html_entity_decode($subject,ENT_QUOTES,$charset);
            
            $msg = str_replace("#MSG#", $msg, $msgPadrao);

            //if(Config::getConfig('email_tiposmtp')+0 == 1){

                $mail = new PHPMailer();
                $mail->IsSMTP();
                $mail->CharSet = $charset;
                $mail->AddReplyTo($from, html_entity_decode($fromName,ENT_QUOTES,$mail->CharSet));
                $mail->SetFrom($from, html_entity_decode($fromName,ENT_QUOTES,$mail->CharSet));
                $mail->Subject = $subject;
                $mail->SMTPOptions = array(
                    'ssl' => array(
                        'verify_peer' => false,
                        'verify_peer_name' => false,
                        'allow_self_signed' => true
                    )
                );
                
                $mail->MsgHTML($msg);
                
                foreach($destinatarios as $destinatario)
                    $mail->AddAddress($destinatario);
                foreach($bcc as $destinatario)
                    $mail->AddBcc($destinatario);

                $mail->AddBcc(Config::getConfig('email'));
                    
                if(count($anexos) > 0){
                    foreach ($anexos as $anexo){
                        $mail->AddAttachment($anexo);
                    }
                }
                
                return $mail->Send();



            /* }else{

                $apiKey = $GLOBALS['SendGridAPI'];
                $sg = new SendGrid($apiKey);
                $from = new Email(html_entity_decode($fromName,ENT_QUOTES,$charset), $from);
                

                $mail = new MailSG();
                $content = new Content("text/html", $msg);
               
                
                $mail->setFrom($from);
                $personalization = new Personalization();

                foreach($destinatarios as $destinatario)
                    $personalization->addTo(new Email($destinatario, $destinatario));
                foreach($bcc as $destinatario)
                    $personalization->addBcc(new Email($destinatario, $destinatario));
                    
                if(count($anexos) > 0){
                    foreach ($anexos as $anexo){
                        $pts = explode('/', $anexo);
                        $file_encoded = base64_encode(file_get_contents($anexo));
                        $attachment = new Attachment();
                        $attachment->setContent($file_encoded);
                        $attachment->setType(mime_content_type($anexo));
                        $attachment->setDisposition("attachment");
                        $attachment->setFilename(end($pts));
                        $mail->addAttachment($attachment);
                    }
                }

                
                $mail->addPersonalization($personalization);
                $mail->setSubject($subject);
                $mail->addContent($content);


                $response = $sg->client->mail()->send()->post($mail);
                    
                if($sendedEmail){
                    $id_message = '';
                    $headers = $response->headers();
                    foreach ( $headers as $header) {
                        if(substr($header, 0, 13) == 'X-Message-Id:'){
                            $id_message = trim(substr($header, 14));
                        }
                    }

                    $headers[] = 'statusCode: '.$response->statusCode();
                    $headers[] = 'Body: '.$response->body();

                    $sendedEmail->set('id_message', $id_message);
                    $sendedEmail->set('destinatarios', implode(';',$destinatarios));
                    $sendedEmail->set('assunto', $subject);
                    $sendedEmail->set('mensagem', $msg);
                    $sendedEmail->set('data', date('Y-m-d H:i:s'));
                    $sendedEmail->set('retorno', print_r($headers,true));
                    $sendedEmail->Inserir();
                }
                //print_r($response->headers());
                //echo $response->body();

                return ( $response->statusCode() == 202);
            }
            /*print_r($response->headers());
            echo $response->body();

            ;*/

        }catch(Exception $e){
            echo $e->getMessage();
            return false;
        }
    }
}