<?php

class Cidade extends Flex {

    protected $nomeTable = 'cidades';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'id_estado' => 'string',
        'codigo' => 'string',
        'nome' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    protected $estado = null;
    public function getEstado(){
        if(!$this->estado || $this->estado->get('id') != $this->get('id_estado')){
            $this->estado = Estado::CarregarObjeto($this->get('id_estado'));
        }
        return $this->estado;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('codigo', $_POST["codigo"]);
            $objeto->set('id_estado', $_POST["id_estado"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));
        $canDelete = true;
        foreach ($arrIds as $id) {
            if(Pessoa::VerificaExistencia($id, 'id_cidade') || Local::VerificaExistencia($id, 'id_cidade')){
                $canDelete = false;
            }
        }
        if(!$canDelete){
            MessageBox::Show('Esta cidade est&aacute; sendo usada em algum(as) pessoas(s)/local(is). Remova-a antes de excluir.', "danger");
            return false;
        }else{
            return $objeto->Exclui(array('id' => $ids));
        }
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $objetoS = new Estado();
        $table = " (select c.*, CONCAT(c.nome,'/',e.uf) cidade, e.uf, e.nome estado FROM {$objeto->getPrefixTable()}{$objeto->getNomeTable()} c LEFT JOIN {$objetoS->getPrefixTable()}{$objetoS->getNomeTable()} e ON c.id_estado = e.id) cidades ";
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit, $table);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {

        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Cod. IBGE</label>';
        $string .= '<input name="codigo" type="text" class="form-control required" maxlength="10" value="'.$objeto->get('codigo').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-7 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="Nome" maxlength="255" value="'.$objeto->get('nome').'"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Estado </label>';
        $string .= '<select class="form-control" name="id_estado" id="id_estado">';
        $rs = Estado::Buscar('id,nome','','','','nome ASC');
        while($rs->next()){
            $string .= '<option value="'.$rs->getInt('id').'" '.($objeto->get('id_estado') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
        } 
        unset($rs);
        $string .= '</select>';
        $string .= '</div>';
        
        return $string;
    }
    
    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-xs-12">Nome</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('id').' - '.$objeto->get('nome') . '/'.$objeto->getEstado()->get('nome').'</a> 
        </td>
        <td><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>
        ';
    }
    
}
