<?php

class Cliente extends Flex {

    protected $nomeTable = 'clientes';
    protected $mapper = array(
        'id' => 'int',
        'tipo' => 'int',
        'nomefantasia' => 'string',
        'razaosocial' => 'string',
        'cpfcnpj' => 'string',
        'ie' => 'string',
        'rg' => 'string',
        'im' => 'string',
        'sexo' => 'int',
        'cep' => 'string',
        'endereco' => 'string',
        'numero' => 'string',
        'complemento' => 'string',
        'bairro' => 'string',
        'id_cidade' => 'int',
        'cidade' => 'string',
        'estado' => 'string',
        'nasc' => 'date',
        'tel' => 'string',
        'tel2' => 'string',
        'tel3' => 'string',
        'email' => 'string',
        'obs' => 'string',
        'instagram' => 'string',
        'facebook' => 'string',
        'status' => 'int',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static $nmStatus = array(
        1 => 'Normal',
        //2 => 'Atraso',
        //3 => 'Lead',
        0 => 'Desativado',
    );
    
    public static $nmSexo = array(
        0 => 'N&atilde;o informado',
        1 => 'Masculino',
        2 => 'Feminino',
    );
    
    public static $nmTipo = array(
        1 => 'Jur&iacute;dica',
        2 => 'F&iacute;sica',
    );
    
    public static $key = 'C@|@#';
    
    public function getMaskedCPFCNPJ(){
        return Common::Mask($this->get('cpfcnpj'),(strlen($this->get('cpfcnpj'))>11?'##.###.###/####-##':'###.###.###-##'));
    }
    public function getTel($tipo=''){
        return Common::Mask($this->get('tel'.$tipo),(strlen($this->get('tel'.$tipo))>10?'(##) ###-###-###':'(##) ####-####'));
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';
        
        if($_POST['tipo']==2){
            $_POST['cpf'] = Common::Replace('/[^0-9]/i', '', $_POST['cpf']);
            if($_POST['cpf'] !=''){
                if(!Common::validaCPF($_POST['cpf'])){
                    $error .= '<li>CPF inv&aacute;lido.</li>';
                }
                if(self::VerificaExistencia($_POST['cpf'], 'cpfcnpj=',$paramAdd)){
                    $error .= '<li>CPF em uso.</li>';
                }
            }
        }else{
            $_POST['cnpj'] = Common::Replace('/[^0-9]/i', '', $_POST['cnpj']);
            if($_POST['cnpj'] !=''){
                if(!Common::validaCNPJ($_POST['cnpj'])){
                    $error .= '<li>CNPJ inv&aacute;lido.</li>';
                }
                if(self::VerificaExistencia($_POST['cnpj'], 'cpfcnpj=',$paramAdd)){
                    $error .= '<li>CNPJ em uso.</li>';
                }
            }
        }
        
        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        global $Config, $defaultPath;
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }
            
            
            $objeto->set('tipo', $_POST["tipo"]);
            if($_POST["tipo"] == 1){
                $objeto->set('cpfcnpj', Common::Replace('/[^0-9]/i','',$_POST['cnpj']));
                $objeto->set('razaosocial', $_POST["razaosocial"]);
                $objeto->set('nomefantasia', $_POST["nomefantasia"]);
            }else{
                $objeto->set('cpfcnpj', Common::Replace('/[^0-9]/i','',$_POST['cpf']));
                $objeto->set('razaosocial', $_POST['nome']);
                $objeto->set('nomefantasia', $_POST["nome"]);
            }
            
            $objeto->set('status', $_POST["status"]);
            $objeto->set('sexo', $_POST["sexo"]);
            $objeto->set('id_cidade', $_POST["id_cidade"]+0);
            $objeto->set('cidade', $_POST["cidade"]);
            $objeto->set('estado', $_POST["estado"]);
            $objeto->set('cep', Common::Replace('/[^0-9]/i','',$_POST["cep"]));
            $objeto->set('endereco', $_POST["endereco"]);
            $objeto->set('numero', $_POST["numero"]);
            $objeto->set('complemento', $_POST["complemento"]);
            $objeto->set('bairro', $_POST["bairro"]);
            $objeto->set('nasc', (Data::isValid($_POST["nasc"])? Data::getFormat($_POST["nasc"],'Y-m-d') : '') );
            $objeto->set('ie', $_POST["ie"]);
            $objeto->set('rg', $_POST["rg"]);
            $objeto->set('im', $_POST["im"]);
            $objeto->set('tel', Common::Replace('/[^0-9]/i','',$_POST["tel"]));
            $objeto->set('tel2', Common::Replace('/[^0-9]/i','',$_POST["tel2"]));
            $objeto->set('tel3', Common::Replace('/[^0-9]/i','',$_POST["tel3"]));
            $objeto->set('email', trim($_POST["email"]));
            $objeto->set('obs', $_POST["obs"]);
            $objeto->set('facebook', $_POST["facebook"]);
            $objeto->set('instagram', $_POST["instagram"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();
            
            $id = ($request->getParameter('id') == ""?$retorno[0]:$request->getParameter('id')+0);
            
            if(isset($_POST['idTemp']) && $_POST['idTemp']+0 >0 ){
                $conn = new Connection();
                $obj = new HistoricoCliente();
                $sql = "UPDATE {$GLOBALS['DBPREFIX']}{$obj->getNomeTable()} SET id_cliente = {$id} WHERE id_cliente = ".($_POST['idTemp']+0);
                $conn->prepareStatement($sql)->executeQuery();
            }
            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));
        
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('tipo',2);
        $objeto->set('status',1);
        
        $idTemp = time();
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }else{
            $string .= '<input type="hidden" name="idTemp" value="'.$idTemp.'" />';
            $codigo = $idTemp;
        }

        $string .= '<div class="col-sm-12">';
        $string .= '<ul class="nav nav-tabs">';
        $string .= '<li class="active"><a href="#dados_cliente" data-toggle="tab">Dados</a></li>';
        $string .= '<li><a href="#historico_cliente" data-toggle="tab">Hist&oacute;rico</a></li>';
        $string .= '</ul>';
        
        $string .= '<div class="tab-content">';
        $string .= '<div class="tab-pane active" id="dados_cliente">';

            $string .= '<div class="row">';
                
                $string .= '<div class="form-group col-xs-6 required">';
                $string .= '<label for="">Pessoa</label>';
                $string .= '<select class="form-control" name="tipo" id="tipo" onchange="$(\'#tipo\'+this.value).removeClass(\'hidden\');$(\'#tipo\'+(this.value==1?2:1)).addClass(\'hidden\');">';
                foreach(self::$nmTipo as $key=>$value){
                    $string .= '<option value="'.$key.'" '.($objeto->get('tipo') == $key? " selected " : "").'>'.$value.'</option>';
                } 
                $string .= '</select>';
                $string .= '</div>';


                $string .= '<div class="form-group col-xs-6">';
                $string .= '<label for="">Situa&ccedil;&atilde;o</label>';
                $string .= '<select class="form-control" name="status">';
                foreach(self::$nmStatus as $key=>$value){
                    $string .= '<option value="'.$key.'" '.($objeto->get('status') == $key? " selected " : "").'>'.$value.'</option>';
                } 
                $string .= '</select>';

                $string .= '</div>';

            $string .= '</div>';

            $string .= '<div id="tipo2" class="row '.($objeto->get('tipo')==2?'':'hidden').'" >';
                
                $string .= '<div class="form-group col-sm-8 required">';
                $string .= '<label for="">Nome</label>';
                $string .= '<input name="nome" type="text" class="form-control" maxlength="255" value="' . $objeto->get('razaosocial') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4 col-xs-6">';
                $string .= '<label for="">Sexo</label>';
                $string .= '<select class="form-control" name="sexo" id="sexo">';
                foreach(self::$nmSexo as $key=>$value){
                    $string .= '<option value="'.$key.'" '.($objeto->get('sexo') == $key? " selected " : "").'>'.$value.'</option>';
                } 
                $string .= '</select>';
                $string .= '</div>';

                $string .= '<div class="form-group col-sm-12"></div>';
                
                $string .= '<div class="form-group col-sm-4 col-xs-6">';
                $string .= '<label for="">CPF</label>';
                $string .= '<input name="cpf" type="text" class="form-control" maxlength="14" value="' . $objeto->get('cpfcnpj') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4 col-xs-6">';
                $string .= '<label for="">RG</label>';
                $string .= '<input name="rg" type="text" class="form-control" maxlength="255" value="' . $objeto->get('rg') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group col-sm-4 col-xs-6">';
                $string .= '<label for="">Nascimento</label>';
                $string .= '<input type="text" class="form-control date" name="nasc" value="'.Data::getFormat($objeto->get('nasc'), 'd/m/Y').'">';
                $string .= '</div>';

            $string .= '</div>';
                
            $string .= '<div id="tipo1" class="row '.($objeto->get('tipo')==1?'':'hidden').'">';

                $string .= '<div class="form-group col-sm-8 required">';
                $string .= '<label for="">Nome Fantasia</label>';
                $string .= '<input name="nomefantasia" type="text" class="form-control" maxlength="255" value="' . $objeto->get('nomefantasia') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4 required">';
                $string .= '<label for="">Raz&atilde;o social</label>';
                $string .= '<input name="razaosocial" type="text" class="form-control" maxlength="255" value="' . $objeto->get('razaosocial') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">CNPJ</label>';
                $string .= '<input name="cnpj" type="text" class="form-control" maxlength="18" value="' . $objeto->get('cpfcnpj') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4 col-xs-6">';
                $string .= '<label for="">Inscri&ccedil;&atilde;o Estadual</label>';
                $string .= '<input name="ie" type="text" class="form-control" maxlength="255" value="' . $objeto->get('ie') . '"/>';
                $string .= '</div>';  
                
                $string .= '<div class="form-group col-sm-4 col-xs-6">';
                $string .= '<label for="">Inscri&ccedil;&atilde;o Municipal</label>';
                $string .= '<input name="im" type="text" class="form-control" maxlength="255" value="' . $objeto->get('im') . '"/>';
                $string .= '</div>';    
                
            $string .= '</div>';  
                

            $string .= '<div class="row">';
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">CEP</label>';
                $string .= '<input name="cep" id="cep" type="text" onblur="getEndereco();" class="form-control" title="CEP" maxlength="10" value="' . $objeto->get('cep') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Endere&ccedil;o</label>';
                $string .= '<input name="endereco" id="endereco" type="text" class="form-control" title="Endere&ccedil;o" maxlength="255" value="' . $objeto->get('endereco') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-2 col-xs-6">';
                $string .= '<label for="">N&uacute;mero</label>';
                $string .= '<input name="numero" type="text" class="form-control" title="N&uacute;mero" maxlength="10" value="' . $objeto->get('numero') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-2 col-xs-6">';
                $string .= '<label for="">Complemento</label>';
                $string .= '<input name="complemento" type="text" class="form-control" title="Complemento" maxlength="255" value="' . $objeto->get('complemento') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Bairro</label>';
                $string .= '<input name="bairro" id="bairro" type="text" class="form-control" title="Bairro" maxlength="255" value="' . $objeto->get('bairro') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group col-md-2 hidden">';
                $string .= '<label for="">C&oacute;d. cidade</label>';
                $string .= '<input id="id_cidade" name="id_cidade" type="text" readonly class="readonly form-control" value="' . $objeto->get('id_cidade') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Cidade</label>';
                $string .= '<input name="cidade" id="cidade" type="text" class="form-control autocomplete" autocomplete="off" data-table="cidades" data-name="nome" data-field="id_cidade" title="Cidade" maxlength="255" value="' . $objeto->get('cidade') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Estado</label>';
                $string .= '<select class="form-control" name="estado" id="estado">';
                foreach($GLOBALS['Estados'] as $key=>$value){
                    $string .= '<option value="'.$key.'" '.($objeto->get('estado') == $key? " selected " : "").'>'.$value.'</option>';
                } 
                $string .= '</select>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Telefone</label>';
                $string .= '<input name="tel" type="text" class="form-control phone" title="Telefone" value="' . $objeto->get('tel') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Telefone 2</label>';
                $string .= '<input name="tel2" type="text" class="form-control phone" title="Telefone" value="' . $objeto->get('tel2') . '"/>';
                $string .= '</div>';
                
                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Telefone 3</label>';
                $string .= '<input name="tel3" type="text" class="form-control phone" title="Telefone" value="' . $objeto->get('tel3') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Facebook</label>';
                $string .= '<input name="facebook" type="text" class="form-control" title="Facebook" value="' . $objeto->get('facebook') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Instagram</label>';
                $string .= '<input name="instagram" type="text" class="form-control" title="Instagram" value="' . $objeto->get('instagram') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group col-sm-4">';
                $string .= '<label for="">Email</label>';
                $string .= '<input name="email" type="text" autocomplete="off" class="form-control ckEmail" title="Email" value="' . $objeto->get('email') . '"/>';
                $string .= '</div>';

                $string .= '<div class="form-group">';
                $string .= '<label for="">Observa&ccedil;&atilde;o</label>';
                $string .= '<textarea id="obs" class="form-control" name="obs" rows="5">'.$objeto->get('obs').'</textarea>';
                $string .= '</div>';

        $string .= '</div>';
        $string .= '</div>';
        
            $string .= '<div class="tab-pane" id="historico_cliente">';
                $string .= '<h4>Histórico<button type="button" onclick="javascript: openFastAdd(\'historicocliente\',\'\',\'/id_cliente/'.$codigo.'\',\'getTableList(\\\'txthistoricocliente\\\', \\\'historicocliente/filtro/id_cliente,i,'.$codigo.'\\\')\');" class="btn btn-primary btn-circle btn-sm"><span class="glyphicon glyphicon-plus"></span></button></h4> ';
                $string .= '<div id="txthistoricocliente">';
                $rs = HistoricoCliente::Buscar('id', $codigo, 'id_cliente', '', 'id DESC');
                $string .= HistoricoCliente::GetTable($rs);
                $string .= '</div>';
            $string .= '</div>';
            /*
            $string .= '<div class="tab-pane" id="processos_cliente">';
                // $string .= '<h3>Processos</h3>';
                $string .= '<div id="txtProcessos">';
                $rs = Processo::Buscar('id','', '', 'id IN(SELECT id_cliente FROM clientesprocesso WHERE id_cliente='.($codigo+0).')', 'id DESC');
                $string .= Processo::GetTable($rs);
                $string .= '</div>';
            $string .= '</div>';
    
            $string .= '</div>';
            */
        

        $string .= '</div>';
        
        return $string;
    }


    public static function GetTable($rs) {
        $string = '
            <div class="table-responsive">
                <table class="table table-hover">
                <thead>
                <tr>
                    <th class="hidden-xs"><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                    <th class="col-sm-8 col-xs-7">Nome</th>
                    <th class="col-sm-3 hidden-xs">Telefone(s)</th>
                    <th class="col-sm-1 col-xs-3 text-center">Compras</th>
                    <th class="col-xs-2 visible-xs">Whats</th>
                </tr>
                </thead>
                <tbody>';
            while ($rs->next()) {
                $objeto = self::CarregarObjeto($rs->getInt('id'));
                $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
            }
            unset($rs);

            $string .= "</tbody>
                </table>
            </div>";

        return $string;
    }

    public static function GetLine($objeto){
        $telefones  = $objeto->getTelWhatsLink();
        $telefones .= ($objeto->get('tel2') != '' ? ' / '.$objeto->getTelWhatsLink('2'): '');
        $telefones .= ($objeto->get('tel3') != '' ? ' / '.$objeto->getTelWhatsLink('3'): '');
        
        $whats  = $objeto->getTelWhatsLink('','Opa, tudo bem?',false);
        $whats .= ($whats == '' && $objeto->get('tel2') != '' ? $objeto->getTelWhatsLink('2','Opa, tudo bem?',false) : '');
        $whats .= ($whats == '' && $objeto->get('tel3') != '' ? $objeto->getTelWhatsLink('3','Opa, tudo bem?',false) : '');
        
        $endereco = '';
        if($objeto->get('endereco') != '') 
            $endereco = $objeto->get('endereco').', '.$objeto->get('numero').' - '.$objeto->get('bairro').' - '.$objeto->get('cidade').'/'.$objeto->get('estado').' - CEP '.$objeto->get('cep');

        $rsP = Pedido::Buscar('count(id) qtd',$objeto->get('id'),'id_cliente');
        $rsP->next();
        $qtdPedidos = $rsP->getInt('qtd');

        return '
        <td class="hidden-xs"><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td class="text-uppercase">
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');">
            '.$objeto->get('nomefantasia') . '</a><br class="visible-xs" /><small class="visible-xs-inline">'.$telefones.'</small>
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><i class="fas fa-trash"></i></a>-->
        </td>
        <td class="nowrap hidden-xs">
            '.$telefones.'
        </td>
        <td class="text-center">'.$rsP->getInt('qtd').'</td>
        <td class="text-center visible-xs">'.$whats.'</td>';
        
    }


    function getTelWhatsLink($tipo="",$msg="Opa, tudo bem?", $mostrarTel=true){
        if($this->get('tel'.$tipo) != ''){
            if(in_array(substr($this->get('tel'.$tipo), 2,1), array(8,9))){
                return ($mostrarTel ? $this->getTel($tipo) : '').' <a href="http://api.whatsapp.com/send?phone=55'.$this->get('tel'.$tipo).'&text='.$msg.'" target="_blank" data-toggle="tooltip" data-placement="right" title="Chamar no WhatsApp"><i class="fab fa-whatsapp"></i></a>';
            }else{
                return ($mostrarTel ? $this->getTel($tipo) : '');
            }
        }
        return '';
    }
}
