<?php

class Estado extends Flex {

    protected $nomeTable = 'estados';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'uf' => 'string',
        'nome' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('uf', $_POST["uf"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));
        $canDelete = true;
        foreach ($arrIds as $id) {
            if(City::VerificaExistencia($id, 'id_state')){
                $canDelete = false;
            }
        }
        if(!$canDelete){
            MessageBox::Show('Este estado est&aacute; sendo usada em alguma(s) cidade(s). Remova-a antes de excluir.', "danger");
            return false;
        }else{
            return $objeto->Exclui(array('id' => $ids));
        }
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {

        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">UF</label>';
        $string .= '<input name="uf" type="text" class="form-control required" title="Nome" maxlength="2" value="'.$objeto->get('uf').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-10 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="Nome" maxlength="255" value="'.$objeto->get('nome').'"/>';
        $string .= '</div>';
        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-xs-12">Nome</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('id').' - '.$objeto->get('nome').' ('.$objeto->get('uf').')</a> 
        </td>
        <td><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>
        ';
    }
}
