<?php

class Estatico extends Flex {

    protected $nomeTable = 'estaticos';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'descricao' => 'string',
        'page' => 'string',
        'ativo' => 'int',
        'keywords' => 'string',
        'img' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    public static $tamImagem = array(
        'thumb' => array('w'=>56,'h'=>56),
        'small' => array('w'=>120,'h'=>120),
        'regular' => array('w'=>480,'h'=>360),
        'zoom' => array('w'=>800,'h'=>600),
    );

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if(self::VerificaExistencia(trim($_POST["page"]), 'page', $paramAdd)){
            $error .= '<li>P&aacute;gina em uso;</li>';
        }
        if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
            if($_FILES["imagem"]["error"] != 0){
                $error .= '<li>Imagem inv&aacute;lida;</li>';
            }
            if(!in_array(Common::getFileExtension($_FILES["imagem"]["name"]), Image::$TypesAllowed)){
                $error .= '<li>Tipo de imagem n&atilde;o suportado. Tipos suportados ('.implode(',',Image::$TypesAllowed).');</li>';
            }
        }
       
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') == "") {
                $objeto->set('ativo', 1);
            } else {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('descricao', $_POST["descricao"]);
            $objeto->set('page', $_POST["page"]);
            $objeto->set('keywords', $_POST["keywords"]);
            $imgBefore = "";
            if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
                $imgBefore = $objeto->get('img');
                $objeto->set('img', Image::configureName($_FILES["imagem"]["name"]));
            }

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            $id = ( $request->getParameter('id') != "" ? $objeto->get('id') : $retorno[0] );
            if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
                Image::SaveFromUpload($imgBefore,'imagem', self::$tamImagem, $id, $objeto->getNomeTable());
            }

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    public static function ExcluirImagem($id){
        $obj = self::CarregarObjeto($id);
        Image::DeleteImage(self::$tamImagem, $id, $obj->getNomeTable(), $obj->get('img'));
        unset($obj);
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();

        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));

        foreach ($arrIds as $id) {
            self::ExcluirImagem($id);
        }

        return $objeto->Exclui(array('id' => $ids));
    }

    public static function &CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        if($opcao=='page'){
            $opcao = 'page=';
        }
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {

        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-8 required">';
        $string .= '<label for="">T&iacute;tulo</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="T&iacute;tulo" maxlength="255" value="'.$objeto->get('nome').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-6 col-md-4 required">';
        $string .= '<label for="">URL</label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon">/</span>';
        $string .= '<input name="page" type="text" class="form-control required" title="URL" maxlength="50" value="'.$objeto->get('page').'"/>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-12 required">';
        $string .= '<label for="">Texto</label>';
        $string .= '<textarea title="Texto" class="ckeditor" id="descricao" name="descricao" height="80">'.$objeto->get('descricao').'</textarea>';
        $string .= '</div>';
        
        $string .= '<div class="form-group  col-md-6 col-xs-12">';
        $string .= '<label for="">Imagem <small class="rule">('.implode(', ',Image::$TypesAllowed).')</small></label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span>';
        $string .= '<input name="imagem" type="file" class="form-control" title="Imagem" value=""/>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-md-6 col-xs-12">';
        $string .= '<label for="">Keywords  <small class="rule">(m&aacute;x. 10 keywords separadas por v&iacute;rgula)</small></label>';
        $string .= '<span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="top" title="Keywords, em portugu&ecirc;s palavras-chave, s&atilde;o os termos principais que determinam qual &eacute; o assunto de uma determinada p&aacute;gina da internet. &Eacute; muito importante escolher as keywords certas, pois &eacute; baseado nelas que os mecanismos de buscas exibem seus resultados. Quando voc&ecirc; busca na internet pela palavra &quote;eletrodom&eacute;sticos&quote;?, por exemplo, s&atilde;o listados todos os sites que possuam essa como uma de suas keywords."></span>';
        $string .= '<input name="keywords" type="text" class="form-control" title="Keywordks" value="'.$objeto->get('keywords').'"/>';
        $string .= '</div>';
        
        if ($codigo + 0 > 0) {
            $string .= Image::ShowImageGG($objeto);
        }

        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th width="10"><input id="qtdRegistros" type="checkbox" onclick="javascript:marcaCheckBoxGG();" value="'.$rs->numRows().'"/></th>
                <th class="col-sm-5 col-xs-12 nowrap">T&iacute;tulo</th>
                <th class="col-sm-5 hidden-xs">URL</th>
                <th class="col-sm-2 text-center hidden-xs">Criado</th>
                <th width="10"></th>
              </tr>
            </thead>
            <tbody>';
        $i = 0;
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $i++;
            $string .= '<tr id="tr">
                <td><input type="checkbox" id="chkDel'.$i.'" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
                <td class="link-edit">
                    <a href="#editar-'.$objeto->get('id').'" onclick="javascript: showEditForm(\''.$objeto->getNomeTable().'\','.$objeto->get('id').');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('nome').'</a> 
                    <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a>
                </td>
                <td class="hidden-xs">'.$objeto->get('page').'</td>
                <td class="small text-center hidden-xs">'.Data::getFormat($objeto->get('dt_cad'), 'd/m/Y H:i:s').'</td>
                <td id="status'.$objeto->get('id').'" ><a href="javascript:;" onclick="javascript: changeStatus(\''.$objeto->getNomeTable().'\','.$objeto->get('id').', '.($objeto->get('ativo')==1?'0':'1').')"><span class="glyphicon glyphicon-ok-sign '.($objeto->get('ativo')==1?'':'d').'pub" title="'.($objeto->get('ativo')==1?'Desativar':'Ativar').'"></span></a></td>
            </tr>';
        }
        unset($i,$rs);

        $string .= "</tbody>
              </table>";
        
        return $string;
    }
    
    
}
