<?php

class FaixaEtaria extends Flex {

    protected $nomeTable = 'faixasetarias';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'inicio' => 'int',
        'fim' => 'int',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('inicio', $_POST["inicio"]);
            $objeto->set('fim', $_POST["fim"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
        
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {

        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }
        
        $string .= '<div class="form-group col-sm-8 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="Nome" maxlength="255" value="'.$objeto->get('nome').'"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Ano ini</label>';
        $string .= '<input name="inicio" type="text" class="form-control onlynumbers required" maxlength="10" value="'.$objeto->get('inicio').'"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Ano fim</label>';
        $string .= '<input name="fim" type="text" class="form-control onlynumbers required" maxlength="10" value="'.$objeto->get('fim').'"/>';
        $string .= '</div>';
        
        return $string;
    }
    
    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-xs-12">Nome</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('nome') . '</a> 
        </td>
        <td><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>
        ';
    }
    
}
