<?php

class FormaEnvio extends Flex {

    protected $nomeTable = 'formasenvio';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';
        
        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }
        
        $string .= '<div class="form-group col-sm-12">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control" maxlength="50" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';
        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-hover w-50">
            <thead>
              <tr>
                <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                <th class="w-100">Nome</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="right" title="Editar">'.$objeto->get('nome').'</a> 
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="left" title="Excluir" class="pull-right"><i class="fas fa-trash"></i></a>-->
        </td>
        ';
    }

    public static function load($nome){
        $rs = self::Buscar('id', $nome,'nome=');
        if($rs->numRows() == 0){
            $classe = __CLASS__;
            $obj = new $classe();
            $obj->set('nome', $nome);
            $ret = $obj->Inserir();
            return $ret[0];
        }else{
            $rs->next();
            return $rs->getInt('id');
        }
    }

}
