<?php

class PadMoney {

	public $endpoint = 'https://api.padmoney.com/v2';
	public $token;
	public $chave;

	public function __construct($token, $chave, $sandbox=false){
		$this->token = $token;
		$this->chave = $chave;
		if($sandbox) $this->endpoint = 'https://dev.padmoney.com/api/v2';
	}

	public function CURL($type='GET', $url='', $vars=[]){
		$ch = curl_init($url); 
		$headers = array();
		if(count($vars)>0){
			$data_string = json_encode($vars);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
			$headers[] = 'Content-Type: application/json';
			$headers[] = 'Content-Length: ' . strlen($data_string);
		}
		$headers[] = 'Padmoney-Token: ' .$this->token;
		$headers[] = 'Padmoney-Token-Secret: ' .$this->chave;

		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $type);
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

		$data = curl_exec($ch);
		if($data === false)
		{ 
			$data = json_encode( array('code' => 500, 'message' => 'Curl error: ' . curl_error($ch)) );
		}else{
			$data = json_decode($data);
		}
		curl_close($ch);
		return $data;
	}

	public function put($url='', $vars=array()){
		return $this->CURL('PUT', $this->endpoint.$url, $vars);
	}

	public function post($url='', $vars=array()){
		return $this->CURL('POST', $this->endpoint.$url, $vars);
	}

	public function get($url='')
	{
		return $this->CURL('GET', $this->endpoint.$url);
	}

	public function newBoleto($data){
		return $this->post('/bank_billets',$data);
	}

	public function getBoleto($id){
		return $this->get('/bank_billets/'.$id);
	}
	
	public function cancelBoleto($id){
		return $this->put('/bank_billets/'.$id.'/cancel',array());
	}

	public function getBoletoUrl($id){
		return $this->endpoint.'/public/bank_billets/print?q='.$id;
	}

}