<?php

class Grupo extends Flex {

    protected $nomeTable = 'grupos';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    public static function validate() {
        $error = '';//print_r($_POST,true);
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';
        
        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__; 
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            $id = ($request->getParameter('id') == ""?$retorno[0]:$request->getParameter('id')+0);
            
            if(isset($_POST['idTemp']) && $_POST['idTemp']+0 >0 ){
                $conn = new Connection();
                $obj = new PermissaoGrupo();
                $sql = "UPDATE {$GLOBALS['DBPREFIX']}{$obj->getNomeTable()} SET id_grupo = {$retorno[0]} WHERE id_grupo = ".($_POST['idTemp']+0);
                $conn->prepareStatement($sql)->executeQuery();
            }
            
            
            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Duplicate($id){
    	global $objSession;
    	$classe = __CLASS__;
        $objeto = new $classe();

    	$orig = self::CarregarObjeto($id);
    	
    	$objeto->set('nome', $orig->get('nome').' - Duplicado');
        $retorno = $objeto->Inserir();

        $nid = $retorno[0]+0;
        if( $nid > 0 ){
        	$conn = new Connection();
            
            $obj = new PermissaoGrupo();
            $sql = "INSERT INTO {$GLOBALS['DBPREFIX']}{$obj->getNomeTable()} (id_permissao, id_grupo, sel, ins, upd, del, usr_cad, dt_cad, usr_ualt, dt_ualt) SELECT id_permissao, {$nid}, sel, ins, upd, del, '{$objSession->get('login')}', NOW(), '{$objSession->get('login')}', NOW() FROM {$GLOBALS['DBPREFIX']}{$obj->getNomeTable()} WHERE id_grupo = {$id}";
            $conn->prepareStatement($sql)->executeQuery();

        }

        return $nid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));

        foreach ($arrIds as $id) {
            GroupCategory::ExcluirCategories($id);
        }
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $idTemp = time();
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }else{
            $string .= '<input type="hidden" name="idTemp" value="'.$idTemp.'" />';
            $codigo = $idTemp;
        }
        
        
        $string .= '<div class="form-group col-sm-12 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="Nome" maxlength="255" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';
       
        $string .= '<div class="form-group col-sm-12">';
        $string .= '<h4>Permiss&otilde;es
            <button type="button" onclick="javascript: openFastAdd(\'permissoesgrupo\',\'\',\'/id_grupo/'.$codigo.'\',\'getTableList(\\\'txtpermissoes\\\', \\\'permissoesgrupo/id_grupo/'.$codigo.'/filtro/id_grupo,i,'.$codigo.'\\\')\');" class="pull-right btn btn-primary ">
              <span class="glyphicon glyphicon-plus"></span> <span class="hidden-xs hidden-sm">Adicionar</span>
            </button></h4>';
        $string .= '<div id="txtpermissoes">';
        
        $rs = PermissaoGrupo::Buscar('*', $codigo, 'id_grupo', '', 'id ASC');
        $string .= PermissaoGrupo::GetTable($rs);
    
        $string .= '</div>';
        $string .= '</div>';

        
        
        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-hover w-50">
            <thead>
              <tr>
              <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
              <th class="w-100">Nome</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="right" title="Editar">'.$objeto->get('nome').'</a> 
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="left" title="Excluir" class="pull-right"><i class="fas fa-trash"></i></a>-->
        </td>
        ';
    }


}
