<?php

class HistoricoPedido extends Flex {

    protected $nomeTable = 'historicopedido';
    protected $mapper = array(
        'id' => 'int',
        'id_pedido' => 'int',
        'descricao' => 'string',
        'data' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    protected $a = null;
    public function getPedido() {
        if (!$this->a || $this->a->get('id') != $this->get('id_pedido')) {
            $this->a = Pedido::CarregarObjeto($this->get('id_pedido'));
        }
        return $this->a;
    }

    protected $b = null;
    public function getUsuario() {
        if (!$this->b || $this->b->get('login') != $this->get('usr_cad')) {
            $this->b = Usuario::CarregarObjeto($this->get('usr_cad'),'login=');
        }
        return $this->b;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }
            $objeto->set('id_pedido', $_POST["id_pedido"]);
            $objeto->set('data', Data::getFormat($_POST["data"],'Y-m-d'));
            $objeto->set('descricao', $_POST["descricao"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();
            
            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('data',date('Y-m-d'));
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }else{
            $objeto->set('id_pedido',$request->get('id_pedido')+0);
        }

        

        $string .= '<input name="id_pedido" type="hidden" class="form-control" value="' . $objeto->get('id_pedido') . '"/>';
        
        
        $string .= '<div class="form-group col-sm-3">';
        $string .= '<label for="">Data</label>';
        $string .= '<input type="text" class="form-control date" name="data" value="'.Data::getFormat($objeto->get('data'), 'd/m/Y').'">';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-12">';
        $string .= '<label for="">Descri&ccedil;&atilde;o</label>';
        $string .= '<textarea class="form-control '.($objeto->get('id_pedido') == 0 ? 'required':'').'" name="descricao" rows="5">' . $objeto->get('descricao') . '</textarea>';
        $string .= '</div>';
        
        return $string;
    }

    public static function GetTable($rs) {
        $i = 0;
        $string = '';
        if($rs->numRows()>0){
        $string = '
            <table class="table table-responsive table-striped table-hover">
            <thead>
              <tr>
                <th class="col-sm-12">Descri&ccedil;&atilde;o</th>
              </tr>
            </thead>
            <tbody>';
            while ($rs->next()) {
                $objeto = self::CarregarObjeto($rs->getInt('id'));
                $i++;
                $credito = $debito = 0;
                $credito += $objeto->get('valor') + $objeto->get('juro') + $objeto->get('multa'); 
                
                $totalc = $credito;
                $totald = $debito;

                $string .= '<tr id="tr">
                    <td class="link-edit small">
                        <a href="javascript:;" onclick="javascript: openFastEdit(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'txthistorico\',\'/id_pedido/'.$objeto->get('id_pedido').'/filtro/id_pedido,i,'.$objeto->get('id_pedido').'\');" data-toggle="tooltip" data-placement="top" title="Editar">'.Data::getFormat($objeto->get('data'),'d/m/Y').' por '.$objeto->getUsuario()->get('nome').'</a> 
                        <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'getTableList(\\\'txthistorico\\\', \\\''.$objeto->getNomeTable().'/filtro/id_pedido,i,'.$objeto->get('id_pedido').'\\\')\',false);" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a>
                        <br>'.$objeto->get('descricao').'
                    </td>
                </tr>';
            }

        $string .= "</tbody>
              </table>";
        }else{
            $string .= 'Nenhum hist&oacute;rico adicionado.';
        }
        unset($i, $rs);

        return $string;
    }
    
}
