<?php

class Integracao extends Flex {

    protected $nomeTable = 'integracoes';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'id_empresa' => 'int',
        'importar' => 'int',
        'sistema' => 'int',
        'data1' => 'string',
        'data2' => 'string',
        'data3' => 'string',
        'data4' => 'string',
        'data5' => 'string',
        'data6' => 'string',
        'data7' => 'string',
        'data8' => 'string',
        'data9' => 'string',
        'data10' => 'string',
        'data11' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    public static $nmSistema = array(
        1 => 'Bling',
        2 => 'Mercado Livre',
        3 => 'Ideris',
        4 => 'Tiny',
    );

    public static $ipnSistema = array(
        1 => 'bling',
        2 => 'meli',
        3 => 'ideris',
        4 => 'tiny',
    );

    protected $d = null;
    public function getEmpresa() {
        if (!$this->d || $this->d->get('id') != $this->get('id_empresa')) {
            $this->d = Empresa::CarregarObjeto($this->get('id_empresa'));
        }
        return $this->d;
    }

    
    public static function validate() {
        global $objPainel;

        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';
        
        if($_POST['importar'] == 1){
            $rs = self::Buscar('count(id) qtd',1,'importar',($id == 0 ? '' : 'AND id <> '.$id));
            $rs->next();
            if($rs->getInt('qtd') == $objPainel->getPlano()->get('integracoes')){
                $error .= '<li>Seu limite de integra&ccedil;&otilde;es foi atingido</li>';
            }
        }

        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('id_empresa', $_POST["id_empresa"]+0);
            $objeto->set('sistema', $_POST["sistema"]+0);
            $objeto->set('importar', $_POST["importar"]+0);
            $objeto->set('nome', self::$nmSistema[$objeto->get('sistema')].' - '.$objeto->getEmpresa()->get('nome'));

            for($i=1; $i <= 11; $i++){
                $objeto->set('data'.$i, (isset($_POST["data{$i}_".$objeto->get('sistema')]) ? 
                    is_array($_POST["data{$i}_".$objeto->get('sistema')]) ?  
                        implode('#', $_POST["data{$i}_".$objeto->get('sistema')]) 
                        : $_POST["data{$i}_".$objeto->get('sistema')]
                : '' ));
            }

            if ($objeto->getPersisted()){
                $retorno = $objeto->Alterar();
            }
            else{
                $retorno = $objeto->Inserir();
            }

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('sistema',1);
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }
        

        $string .= '<div class="form-group col-sm-5">';
        $string .= '<label for="">Empresa</label>';
        $string .= '<select class="form-control" name="id_empresa" id="id_empresa">';
        $rs = Empresa::Buscar('id,nome','','','','nome');
        while($rs->next()){
            $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_empresa') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
        } 
        $string .= '</select>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-5">';
        $string .= '<label for="">Sistema</label>';
        $string .= '<select class="form-control" name="sistema" id="sistema" onchange="$(\'.sistema\').addClass(\'hidden\'); $(\'#g\'+this.value).removeClass(\'hidden\');">';
        foreach(self::$nmSistema as $key=>$value){
            $string .= '<option value="'.$key.'" '.($objeto->get('sistema') == $key? " selected " : "").'>'.$value.'</option>';
        } 
        $string .= '</select>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2">';
        $string .= '<label for="">Realiza Sincroniza&ccedil;&atilde;o</label>';
        $string .= '<select class="form-control" name="importar" id="importar">';
        $string .= '<option value="0" '.($objeto->get('importar') != 1 ? " selected " : "").'>N&atilde;o</option>';
        $string .= '<option value="1" '.($objeto->get('importar') == 1 ? " selected " : "").'>Sim</option>';
        $string .= '</select>';
        $string .= '</div>';
        

        $string .= '<div class="sistema'.($objeto->get('sistema') == 1 ? '' : ' hidden').'" id="g1">';
          
            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">ApiKey</label>';
            $string .= '<input name="data1_1" id="apikeyBling" onblur="if(this.value!=\'\' && $(\'#situacoesBling\').val() == \'\'){ getStatusBling(); }" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 1 ? $objeto->get('data1') : '') . '"/>';
            $string .= '<input name="data2_1" id="situacoesBling" type="hidden" value="' . ($objeto->get('sistema') == 1 ? $objeto->get('data2') : '') . '"/>';
            $string .= '</div>';
            
            $string .= '
            <div class="form-group col-sm-3">
                <button class="btn btn-lg btn-block btn-primary" style="margin-top:20px" onclick="getStatusBling();" type="button">Buscar situa&ccedil;&otilde;es</button>
                <script>
                    function getStatusBling(){
                        if($(\'#apikeyBling\').val() != \'\'){
                            blockUi();
                            var url = __PATH__+`ajax/get-situacoes-bling/key/${$(\'#apikeyBling\').val()}`;
                            $.ajax({
                                url: url,
                                type: "GET",
                                dataType: "json",
                                success: function(data, textStatus, jqXHR) {
                                    unblockUi();
                                    if(data["qtd"]){
                                        $("#situacoesBling").val(data["situacoes"]);
                                        $("#optionBling").html(data["data"]);
                                    }else{
                                        showErrorAlert("Ocorreu um erro.",  "Nenhuma situa&ccedil;&atilde;o encontrada. Verifique os dados enviados.");
                                        $("#situacoesBling").val("");
                                        $("#optionBling").html("");
                                    }
                                    $("#optionBling").multiselect("rebuild");
                                },
                                error: function(jqXHR, textStatus, errorThrown)
                                {
                                    unblockUi();
                                    showErrorAlert("Ocorreu um erro.",  `JQXHR: ${jqXHR.responseText}<br>Status: ${textStatus} <br>Throw: ${errorThrown}`);
                        
                                }
                            });
                        }
                    }

                    '.($objeto->get('sistema') == 1 && $objeto->get('data2') == '' ? 'getStatusBling()' : '').'
                </script>
            </div>';

            $situacoes = ($objeto->get('sistema') == 1 ? explode('#',$objeto->get('data2')) : []);
            $situacoesSelecionadas = ($objeto->get('sistema') == 1 ? explode('#',$objeto->get('data3')) : []);
            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Situa&ccedil;&otilde;es para importa&ccedil;&atilde;o</label>';
            $string .= '<select class="form-control multiselsearch" name="data3_1[]" id="optionBling" multiple >';
            if(count($situacoes)) foreach($situacoes as $situacao){
                $string .= '<option value="'.$situacao.'" '.( in_array($situacao, $situacoesSelecionadas) ? " selected " : "").'>'.$situacao.'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Cod. Loja</label>';
            $string .= '<input name="data4_1" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 1 ? $objeto->get('data4') : '') . '"/>';
            $string .= '</div>';
            
        $string .= '</div>';

        $string .= '<div class="sistema'.($objeto->get('sistema') == 2 ? '' : ' hidden').'" id="g2">';
          
            $string .= '<div class="form-group col-sm-12">';
            $string .= '<label for="">AccessToken</label>';
            $string .= '<input name="data1_2" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 2 ? $objeto->get('data1') : '') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-8">';
            $string .= '<label for="">RefreshToken</label>';
            $string .= '<input name="data2_2" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 2 ? $objeto->get('data2') : '') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">User_Id</label>';
            $string .= '<input name="data3_2" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 2 ? $objeto->get('data3') : '') . '"/>';
            $string .= '</div>';
            
            $string .= '
            <div class="form-group col-sm-4">
                <button class="btn btn-lg btn-block btn-primary" style="margin-top:20px" onclick="getAccessTokenMeli();" type="button">Gerar/Renovar Acesso &agrave; API</button>
                <script>
                    function getAccessTokenMeli(){
                        if($(\'#id_empresa\').val() != \'\' && $(\'#id_empresa\').val() != 0){
                            blockUi();
                            var url = __PATH__+`ajax/get-access-token-meli/empresa/${$(\'#id_empresa\').val()}/id/'.$codigo.'`;
                            $.ajax({
                                url: url,
                                type: "GET",
                                dataType: "json",
                                success: function(data, textStatus, jqXHR) {
                                    unblockUi();
                                    location = data[\'data\'];
                                },
                                error: function(jqXHR, textStatus, errorThrown)
                                {
                                    unblockUi();
                                    showErrorAlert("Ocorreu um erro.",  `JQXHR: ${jqXHR.responseText}<br>Status: ${textStatus} <br>Throw: ${errorThrown}`);
                        
                                }
                            });
                        }else{
                            showErrorAlert("Erro",  "Por favor, selecione uma Empresa.");
                        }
                    }
                </script>
            </div>';

        $string .= '</div>';


        $string .= '<div class="sistema'.($objeto->get('sistema') == 3 ? '' : ' hidden').'" id="g3">';
          
            $string .= '<div class="form-group col-sm-9">';
            $string .= '<label for="">Token</label>';
            $string .= '<input name="data1_3" id="tokenIderis" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 3 ? $objeto->get('data1') : '') . '"/>';
            $string .= '</div>';
                
            $string .= '
            <div class="form-group col-sm-3">
                <button class="btn btn-lg btn-block btn-primary" style="margin-top:20px" onclick="getJwtIderis();" type="button">Gerar Autentica&ccedil;&atilde;o</button>
                <script>
                    function getJwtIderis(){
                        if($(\'#tokenIderis\').val() != \'\'){
                            blockUi();
                            var url = __PATH__+`ajax/get-jwt-ideris/key/${$(\'#tokenIderis\').val()}`;
                            $.ajax({
                                url: url,
                                type: "GET",
                                dataType: "json",
                                success: function(data, textStatus, jqXHR) {
                                    unblockUi();
                                    $("#jwtIderis").val(data["data"]);
                                },
                                error: function(jqXHR, textStatus, errorThrown)
                                {
                                    unblockUi();
                                    showErrorAlert("Ocorreu um erro.",  `JQXHR: ${jqXHR.responseText}<br>Status: ${textStatus} <br>Throw: ${errorThrown}`);
                        
                                }
                            });
                        }
                    }

                    '.($objeto->get('sistema') == 1 && $objeto->get('data2') == '' ? 'getStatusBling()' : '').'
                </script>
            </div>';

            $string .= '<div class="form-group col-sm-12">';
            $string .= '<label for="">Autenticacao (JWT)</label>';
            $string .= '<input name="data2_3" id="jwtIderis" type="text" class="form-control" value="' . ($objeto->get('sistema') == 3 ? $objeto->get('data2') : '') . '"/>';
            $string .= '</div>';

        $string .= '</div>';



        $string .= '<div class="sistema'.($objeto->get('sistema') == 4 ? '' : ' hidden').'" id="g4">';
          
            $string .= '<div class="form-group col-sm-9">';
            $string .= '<label for="">ApiKey</label>';
            $string .= '<input name="data1_4" id="apikeyTiny" onblur="if(this.value!=\'\' && $(\'#situacoesTiny\').val() == \'\'){ getStatusTiny(); }" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 4 ? $objeto->get('data1') : '') . '"/>';
            $string .= '</div>';
            $situacoes = [
                'aberto' => 'Em aberto',
                'aprovado' => 'Aprovado',
                'preparando_envio' => 'Preparando envio',
                'faturado' => 'Faturado (atendido)',
                'pronto_envio' => 'Pronto para envio',
                'enviado' => 'Enviado',
                'entregue' => 'Entregue',
                'cancelado' => 'Cancelado',
            ];

            $situacoesSelecionadas = ($objeto->get('sistema') == 4 ? explode('#',$objeto->get('data2')) : []);
            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Situa&ccedil;&otilde;es para importa&ccedil;&atilde;o</label>';
            $string .= '<select class="form-control multiselsearch" name="data2_4[]" id="optionTiny" multiple >';
            if(count($situacoes)) foreach($situacoes as $situacao => $nm){
                $string .= '<option value="'.$situacao.'" '.( in_array($situacao, $situacoesSelecionadas) ? " selected " : "").'>'.$nm.'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';
            /*
            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Token</label>';
            $string .= '<input name="data3_4" id="tokenTiny" type="text" class="form-control" maxlength="255" value="' . ($objeto->get('sistema') == 4 ? $objeto->get('data3') : '') . '"/>';
            $string .= '</div>';*/
        $string .= '</div>';


        return $string;
    }

     public static function GetTable($rs) {
        $string = '
            <table class="table table-hover w-50">
            <thead>
              <tr>
                <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                <th class="w-100">Nome</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');">'.$objeto->get('nome').'</a>'.($objeto->get('importar') == 1 ? ' <em class="small">(Realiza importa&ccedil;&atilde;o)</em>':'').'
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><i class="fas fa-trash"></i></a>-->
        </td>
        ';
    }

}
