<?php

class ItemAtendimento extends Flex {

    protected $nomeTable = 'itensatendimento';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'id_atendimento' => 'int',
        'id_usuario' => 'int',
        'nome' => 'string',
        'mensagem' => 'string',
        'data' => 'string',
    );
    protected $primaryKey = array('id_atendimento','id');

    protected $atendimento = null;
    public function getAtendimento() {
        if(!$this->atendimento || $this->atendimento->get('id') != $this->get('id_atendimento')){
            if($this->get('id_atendimento')!=0){
                $this->atendimento = Atendimento::CarregarObjeto($this->get('id_atendimento'));
            }else{
                $this->atendimento = new Atendimento();
            }
        }
        return $this->atendimento;        
    }

    protected $usuario = null;
    public function getUsuario() {
        if(!$this->usuario || $this->usuario->get('id') != $this->get('id_usuario')){
            if($this->get('id_usuario')!=0)
                $this->usuario = Usuario::CarregarObjeto($this->get('id_usuario'));
            else{
                $this->usuario = $this->getAtendimento()->getPainel();
            }
        }
        return $this->usuario;        
    }

    public static function ExcluirItens($id_atendimento) {
        $classe = __CLASS__;
        $objeto = new $classe();
        try {
            $id_atendimento +=0;
            $connection = new Connection();
            $sql = "DELETE FROM {$GLOBALS['DBPREFIX']}{$objeto->getNomeTable()} WHERE id_atendimento = {$id_atendimento}";
            $statement = $connection->prepareStatement($sql);
            $statement->executeQuery();
            return true;
        } catch (SQLException $e) {
            echo $e->getMessage();
            return false;
        }
        return false;
    }
    
    public static function Excluir($id_atendimento, $id) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id_atendimento' => $id_atendimento, 'id'=>$id));
    }
    
    public static function CarregarObjeto($id_atendimento, $id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id_atendimento, $id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        if ($opcao == 'atendimento') {
            $opcao = 'id_atendimento';
        }
        if ($opcao == 'usuario') {
            $opcao = 'id_usuario';
        }
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
    
    public static function getQtdRespostas($id) {
        $rs = self::Buscar('count(id) qtd', $id, 'atendimento');
        $rs->next();
        return $rs->getInt('qtd');
    }
   
    public static function GetTable($rs, $id_atendimento=0) {
        global $objSession;
        $string = '';

        $isPainel = ($objSession instanceof Painel);

        if($rs->numRows() == 0 && $id_atendimento == 0){
            $string .= '<p>Nenhum item adicionado.</p>';
        }else{
            $string .= '<ul class="list-group">';
            while($rs->next()){
                $objeto = self::CarregarObjeto($rs->getInt('id_atendimento'),$rs->getInt('id'));

                $string .= '<li class="list-group-item comment">
                          <span class="log"><strong>'.$objeto->get('nome').'</strong> deixou coment&aacute;rio</span> <span class="small data pull-right">'.Data::getFormat($objeto->get('data'),'d/m/Y H:i:s').($isPainel?'':'<a href="javascript:;" onclick="javascript: delItemAtendimento('.$objeto->get('id_atendimento').','.$objeto->get('id').');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a>').'</span>
                          <div class="text">
                            <p>'.nl2br($objeto->get('mensagem')).'</p>
                          </div>
                        </li>';
            }
            if($id_atendimento > 0){
                $objeto = Atendimento::CarregarObjeto($id_atendimento);
                if($objeto->get('mensagem') != ''){
                    $string .= '<li class="list-group-item comment">
                              <span class="log"><strong>'.$objeto->get('solicitante').'</strong> deixou coment&aacute;rio</span> <span class="small data pull-right">'.Data::getFormat($objeto->get('data'),'d/m/Y H:i:s').'</span>
                              <div class="text">
                                <p>'.nl2br($objeto->get('mensagem')).'</p>
                              </div>
                            </li>';
                }
            }
            $string .= '</ul>';
        }
        
        return $string;
    }
}