<?php

class Painel extends Flex {

    protected $nomeTable = 'paineis';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'id_plano' => 'int',
        'nome' => 'string',
        'celular' => 'string',
        'email' => 'string',
        'subdominio' => 'string',
        'banco' => 'string',
        'status' => 'int',
        'expiracao' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    protected $plano = null;
    public function getPlano() {
        if(!$this->plano || $this->plano->get('id') != $this->get('id_plano')){
            if($this->get('id_plano')!=0)
                $this->painel = Plano::CarregarObjeto($this->get('id_plano'));
            else{
                $this->painel = new Plano();
            }
        }
        return $this->painel;        
    }

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';

        if (self::VerificaExistencia(trim($_POST["subdominio"]), 'subdominio=', $paramAdd)) {
            $error .= '<li>Subdom&iacute;nio em uso;</li>';
        }
        if (self::VerificaExistencia(trim($_POST["banco"]), 'banco=', $paramAdd)) {
            $error .= '<li>Banco em uso;</li>';
        }

        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('email', $_POST["email"]);
            $objeto->set('celular', Common::Replace('/[^0-9]/','',$_POST["celular"]));
            $objeto->set('subdominio', $_POST["subdominio"]);
            $objeto->set('banco', $_POST["banco"]);
            $objeto->set('id_plano', $_POST["id_plano"]);
            $objeto->set('expiracao', Data::getFormat($_POST["expiracao"],'Y-m-d'));

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();

        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Cliente</label>';
        $string .= '<input name="nome" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Email</label>';
        $string .= '<input name="email" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('email') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Celular</label>';
        $string .= '<input name="celular" type="text" class="form-control phone required" maxlength="255" value="' . $objeto->get('celular') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Subdom&iacute;nio</label>';
        $string .= '<input name="subdominio" type="text" class="form-control required" maxlength="50" value="' . $objeto->get('subdominio') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-4 required">';
        $string .= '<label for="">Banco de dados</label>';
        $string .= '<input name="banco" type="text" class="form-control required" maxlength="50" value="' . $objeto->get('banco') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-4">';
        $string .= '<label for="">Plano</label>';
        $string .= '<select class="form-control" name="id_plano">';
        $rs = Plano::Buscar('id,nome','','','','nome');
        while($rs->next()){
            $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_plano') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
        } 
        $string .= '</select>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-4 required">';
        $string .= '<label for="">Expira&ccedil;&atilde;o</label>';
        $string .= '<input name="expiracao" type="text" class="form-control required date" value="' . Data::getFormat($objeto->get('expiracao'),'d/m/Y') . '"/>';
        $string .= '</div>';


        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-xs-4">Nome</th>
                <th class="col-xs-4">Plano</th>
                <th class="col-xs-2">Subdom&iacute;nio</th>
                <th class="col-xs-2">Expira&ccedil;&atilde;o</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td class="small">
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">' . $objeto->get('id').' - '.$objeto->get('nome') . '</a> 
        </td>
        <td class="small">'.$objeto->getPlano()->get('nome').'</td>
        <td class="small"><a href="https://'.$objeto->get('subdominio').'.posvenda.online" target="_blank">'.$objeto->get('subdominio').'</a></td>
        <td class="small">'.Data::getFormat($objeto->get('expiracao'),'d/m/Y').'</td>
        <td class="small"><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="left" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>';
    }

    public function createPanel(){
        $log = '';
        $subdomain = $this->get('subdominio');
        $database = $this->get('banco');
        $name = $this->get('nome');
        
        $DB = array(
            'user' => 'posvendaonline',
            'pass' => '@@@S3rv3r',
            'name' => 'posvendaonline_sys',
            'host' => 'mysql.flexpoint.com.br',
            'drive' => 'mysql', 
            'port' => 3306,
        );

        $cPanel = new cpanelAPI($DB['user'], $DB['pass'], '127.0.0.1');
        $DB['name'] = $cPanel->user.'_'.$database;
        
        $log .= "----------------<br>";
        $log .= "Creating folder...";
        $dir = $GLOBALS['corePath'].'/../p/'.$subdomain.'/';
        if(!is_dir($dir)){
            mkdir($dir.'uploads',0777, true);

            $log .= 'ok';
            $log .= "<br>----------------<br>";
            $log .= "Creating index.php ...";
            file_put_contents($dir.'index.php', '<?php
global $defaultPath, $predefinedPath, $DBName,$xmlConfig;
$defaultPath = dirname(__FILE__)."/";
$predefinedPath = array(
    ""=> array("folder"=>"sistema/", "path" => ""),
);
$DBName = "'.$DB['name'].'";
require $defaultPath."../../_core/bootstrap.php";
');
            $log .= "ok";

            $log .= "Creating .htaccess ...";
            file_put_contents($dir.'.htaccess', '
RewriteEngine On

RewriteCond %{HTTPS} !=on
RewriteRule ^.*$ https://%{SERVER_NAME}%{REQUEST_URI} [R,L]

RewriteCond %{REQUEST_FILENAME} -s [OR]
RewriteCond %{REQUEST_FILENAME} -l [OR]
RewriteCond %{REQUEST_FILENAME} -d
RewriteRule ^.*$ - [NC,L]

RewriteRule ^(.+)$ index.php?param=$1

Options -Indexes
');
            $log .= "ok";

        }else{
            $log .= 'exists';
        }
        
        $log .= "<br>----------------<br>";
        $log .= "Creating Database...";
        $response = $cPanel->uapi->Mysql->create_database(array('name' => $DB['name']));
        $log .= print_r($response, true);
        $log .= "ok";

        $log .= "<br>----------------<br>";
        $log .= "Grant permissions...";
        $response = $cPanel->uapi->Mysql->set_privileges_on_database(array('user' => $cPanel->user.'_master', 'database' => $DB['name'], 'privileges' => 'CREATE,DROP,EXECUTE,SELECT,INSERT,DELETE,UPDATE'));
        $log .= print_r($response, true);
        $log .= "ok";
        
        $log .= "<br>----------------<br>";
        $log .= "Creating subdomain...";
        $response = $cPanel->api2->SubDomain->addsubdomain(['rootdomain' => 'posvendaonline.com.br', 'domain' => $subdomain, 'dir' => '/public_html/p/'.$subdomain]);
        $log .= print_r($response, true);
        $log .= "ok";
        
        $log .= "<br>----------------<br>";
        $log .= "Importing data to DB...";
        $conn = new Connection($DB);
        $query = '';

        $sqlScript = file($GLOBALS['corePath'].'config/install.sql');
        foreach ($sqlScript as $line)   {
            
            $startWith = substr(trim($line), 0 ,2);
            $endWith = substr(trim($line), -1 ,1);
            
            if (empty($line) || $startWith == '--' || $startWith == '/*' || $startWith == '//') {
                continue;
            }
                
            $query = $query . $line;
            if ($endWith == ';') {
                $conn->prepareStatement(utf8_decode($query))->executeQuery();
                $query= '';
            }
        }
        
        $sql="UPDATE configs SET valor = '{$name}' WHERE chave = 'nome'";
        $conn->prepareStatement($sql)->executeQuery();

        $sql="UPDATE configs SET valor = REPLACE(valor, 'https://www.posvendaonline.com/','https://{$subdomain}.posvendaonline.com/') WHERE valor LIKE 'https://www.posvendaonline.com%'";
        $conn->prepareStatement($sql)->executeQuery();

        $sql="INSERT INTO empresas (nome, usr_cad, dt_cad, usr_ualt, dt_ualt) VALUES ('{$name}','posvendaonline',NOW(),'posvendaonline',NOW())";
        $conn->prepareStatement($sql)->executeQuery();

        $log .= "OK";

        $log .= "<br>----------------<br>";
        $log .= "Result<br>";
        $log .= '<a href="http://'.$subdomain.'.posvendaonline.com.br/" target="_blank">Acessar Admin</a><br>';

        $this->set('status',2);
        $this->Alterar();
        
        $link = 'https://'.$subdomain.'.posvendaonline.com.br/';
        $msg = "
        <p>Ol&aacute; {$name},</p>
        <p>Gostar&iacute;amos de lhe dar as boas vindas e dizer que &eacute; um prazer t&ecirc;-lo como cliente. </p>
        <p>A partir de agora voc&ecirc; ter&aacute; acesso ao sistema e poder&aacute; gerenciar suas vendas e realizar o P&oacute;s-venda de modo eficiente e organizado. Para acessar o sistema utilize os seguintes dados:</p>
        <p>
            <strong>Endere&ccedil;o:</strong> <a href=\"{$link}\" target=\"_blank\">{$link}</a><br>
            <strong>Login:</strong> admin<br>
            <strong>Senha:</strong> admin
        </p>
        <p>Nos colocamos a disposi&ccedil;&atilde;o.</p>
        <p>Atenciosamente,<br>
        Equipe {$Config->NomeSite}</p>
        ";

        $mail = new Mail();
        $mail->SendMail('contato@posvenda.online', 'Pos-venda Online', "Seja bem vindo", array($this->get('email')), $msg, array(), array('contato@posvenda.online','contato@flexpoint.com.br'));

        return $log;
    }
}
