<?php

class Pedido extends Flex {

    protected $nomeTable = 'pedidos';
    protected $mapper = array(
        'id' => 'int',
        'id_empresa' => 'int',
        'id_cliente' => 'int',
        'id_canalvenda' => 'int',
        'id_formaenvio' => 'int',
        'status' => 'int',
        'ref' => 'string',
        'refmp' => 'string',
        'frete' => 'number',
        'data_venda' => 'date',
        'data_previsao' => 'date',
        'data_entrega' => 'date',
        'codigo_rastreio' => 'string',
        
        'rastreio_api' => 'string',
        'rastreio_encontrado' => 'int',
        'rastreio_msg' => 'string',
        
        'cep' => 'string',
        'endereco' => 'string',
        'numero' => 'string',
        'complemento' => 'string',
        'bairro' => 'string',
        'cidade' => 'string',
        'estado' => 'string',

        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',

        'problema' => 'int',
    );
    protected $primaryKey = array('id');
    
    public static $nmStatus = array(
        0 => 'Em aberto',
        1 => 'Em tr&acirc;nsito',
        2 => 'Entregue',
        3 => 'Devolvido',
        // 4 = status virtual de atraso
        5 => 'RMA',
        6 => 'Cancelado',
        7 => 'Com problema',
    );

    protected $a = null;
    public function getCliente() {
        if (!$this->a || $this->a->get('id') != $this->get('id_cliente')) {
            $this->a = Cliente::CarregarObjeto($this->get('id_cliente'));
        }
        return $this->a;
    }

    protected $b = null;
    public function getCanalVenda() {
        if (!$this->b || $this->b->get('id') != $this->get('id_canalvenda')) {
            if($this->get('id_canalvenda') == 0){
                $this->b = new CanalVenda();
                $this->b->set('id',0);
                $this->b->set('nome','N&atilde;o informado');
            }else{
                $this->b = CanalVenda::CarregarObjeto($this->get('id_canalvenda'));
            }
        }
        return $this->b;
    }

    protected $c = null;
    public function getFormaEnvio() {
        if (!$this->c || $this->c->get('id') != $this->get('id_formaenvio')) {
            if(FormaEnvio::VerificaExistencia($this->get('id_formaenvio'),'id')){
                $this->c = FormaEnvio::CarregarObjeto($this->get('id_formaenvio'));
            }else{
                $this->c = new FormaEnvio();
                $this->c->set('nome','APAGADO');

            }

        }
        return $this->c;
    }

    protected $d = null;
    public function getEmpresa() {
        if (!$this->d || $this->d->get('id') != $this->get('id_empresa')) {
            $this->d = Empresa::CarregarObjeto($this->get('id_empresa'));
        }
        return $this->d;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($_POST["id_cliente"]+0 == 0){
            $error .= '<li>Cliente n&atilde;o informado</li>';

        }
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }
            $objeto->set('id_cliente', $_POST["id_cliente"]+0);
            $objeto->set('id_canalvenda', $_POST["id_canalvenda"]+0);
            $objeto->set('id_formaenvio', $_POST["id_formaenvio"]+0);
            $objeto->set('id_empresa', $_POST["id_empresa"]+0);
            $objeto->set('data_venda', (Data::isValid($_POST["data_venda"]) ? Data::getFormat($_POST["data_venda"],'Y-m-d H:i:s') : ''));
            $objeto->set('data_previsao', (Data::isValid($_POST["data_previsao"]) ? Data::getFormat($_POST["data_previsao"],'Y-m-d') : ''));
            $objeto->set('data_entrega', (Data::isValid($_POST["data_entrega"]) ? Data::getFormat($_POST["data_entrega"],'Y-m-d') : ''));
            $objeto->set('codigo_rastreio', $_POST["codigo_rastreio"]);
            $objeto->set('ref', $_POST["ref"]);
            $objeto->set('refmp', $_POST["refmp"]);
            $objeto->set('status', $_POST["status"]);
            $objeto->set('frete', (float) str_replace(',','.',str_replace('.','',$_POST["frete"])));
            
            $objeto->set('cidade', $_POST["cidade"]);
            $objeto->set('estado', $_POST["estado"]);
            $objeto->set('cep', Common::Replace('/[^0-9]/i','',$_POST["cep"]));
            $objeto->set('endereco', $_POST["endereco"]);
            $objeto->set('numero', $_POST["numero"]);
            $objeto->set('complemento', $_POST["complemento"]);
            $objeto->set('bairro', $_POST["bairro"]);
            $objeto->set('problema', $_POST["problema"]+0);
            

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            if(isset($_POST['idTemp']) && $_POST['idTemp']+0 >0 ){
                $conn = new Connection();
                $obj = new ProdutoPedido();
                $sql = "UPDATE  {$obj->getNomeTable()} SET id_pedido = {$retorno[0]} WHERE id_pedido = ".($_POST['idTemp']+0);
                $conn->prepareStatement($sql)->executeQuery();
            }

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('data_previsao',date('Y-m-d', strtotime('+15 days')));
        $objeto->set('frete',0);
        $idTemp = time();
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }else{
            $string .= '<input type="hidden" name="idTemp" value="'.$idTemp.'" />';
            $codigo = $idTemp;
        }


        $string .= '<div class="row"><div class="col-sm-12">';
        $string .= '<ul class="nav nav-tabs">';
        $string .= '<li'.($request->get('tab') != 'historico' ? ' class="active"' : '').'><a href="#tab_dados'.$codigo.'" data-toggle="tab">Dados</a></li>';
        $string .= '<li><a href="#tab_produtos'.$codigo.'" data-toggle="tab">Produtos</a></li>';
        $string .= '<li'.($request->get('tab') == 'historico' ? ' class="active"' : '').'><a href="#tab_historico'.$codigo.'" data-toggle="tab">Hist&oacute;rico Pedido</a></li>';
        if($objeto->get('id_cliente')+0 > 0){
            $rsP = Pedido::Buscar('id',$objeto->get('id_cliente'),'id_cliente','AND id <> '.$codigo,'data_venda DESC');
            
            $string .= '<li><a href="#tab_historico_cli'.$codigo.'" data-toggle="tab">Hist&oacute;rico Cliente</a></li>';
            if($rsP->numRows() > 0)
                $string .= '<li><a href="#tab_pedidos'.$codigo.'" data-toggle="tab">Outros Pedidos</a></li>';
        }
        $string .= '</ul>';
        $string .= '</div></div>';

        $string .= '<div class="tab-content">';
        $string .= '<div class="tab-pane '.($request->get('tab') != 'historico' ? 'active' : '').'" id="tab_dados'.$codigo.'">';

        $string .= '<div class="row">';


            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Empresa</label>';
            $string .= '<select class="form-control" name="id_empresa" id="id_empresa">';
            $rs = Empresa::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_empresa') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Canal de Venda</label>';
            $string .= '<select class="form-control" name="id_canalvenda" id="id_canalvenda">';
            $rs = CanalVenda::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_canalvenda') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Data Venda</label>';
            $string .= '<input type="text" class="form-control datetime" data-drops="up" name="data_venda" id="data_venda" value="'.(Data::isValid($objeto->get('data_venda')) ? Data::getFormat($objeto->get('data_venda'), 'd/m/Y H:i:s') : '').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Forma de Envio</label>';
            $string .= '<select class="form-control" name="id_formaenvio" id="id_formaenvio">';
            $rs = FormaEnvio::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_formaenvio') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Previs&atilde;o Entrega</label>';
            $string .= '<input type="text" class="form-control date" name="data_previsao" id="data_previsao" value="'.(Data::isValid($objeto->get('data_previsao')) ? Data::getFormat($objeto->get('data_previsao'), 'd/m/Y') : '').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">C&oacute;digo de Rastreio</label>';
            $string .= '<input name="codigo_rastreio" type="text" class="form-control" maxlength="255" value="' . $objeto->get('codigo_rastreio') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Situa&ccedil;&atilde;o</label>';
            $string .= '<select class="form-control" name="status" id="status">';
            foreach(self::$nmStatus as $key=>$value){
                $string .= '<option value="'.$key.'" '.($objeto->get('status') == $key? " selected " : "").'>'.$value.'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';
            
            
            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Data Entrega</label>';
            $string .= '<input type="text" class="form-control date" data-drops="up" name="data_entrega" id="data_entrega" value="'.(Data::isValid($objeto->get('data_entrega')) ? Data::getFormat($objeto->get('data_entrega'), 'd/m/Y') : '').'">';
            $string .= '</div>';


            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Valor Frete</label>';
            $string .= '<input name="frete" type="text" class="form-control money" title="Preco" maxlength="255" value="'.Common::parseMoney($objeto->get('frete')).'"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Ref. Sistema</label>';
            $string .= '<input type="text" class="form-control" name="ref" value="'.$objeto->get('ref').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Ref. MarketPlace</label>';
            $string .= '<input type="text" class="form-control" name="refmp" value="'.$objeto->get('refmp').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-md-2">';
            $string .= '<label for="">C&oacute;digo</label>';
            $string .= '<input id="id_cliente" name="id_cliente" type="text" readonly class="readonly form-control" value="' . $objeto->get('id_cliente') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-md-4">';
            $string .= '
            <label for="">
                Cliente 
                <a href="javascript:;" title="Novo Cliente" class="btn btn-primary btn-xs link-add" onclick="javascript:openFastAdd(\'clientes\',\'\',\'\',\'updateAutoCompleteField(\\\'clientes\\\',\\\'\\\',\\\'id_cliente\\\',\\\'cliente\\\',\\\'nomefantasia\\\')\');">
                    <span class="glyphicon glyphicon-plus"></span>
                </a>
            </label>
            ';
            $string .= '<div class="input-group">';
            $string .= '<input id="cliente" type="text" class="form-control autocomplete" autocomplete="off" data-table="clientes" data-name="nomefantasia" data-field="id_cliente" value="' . ($objeto->get('id_cliente')>0?$objeto->getCliente()->get('nomefantasia'):'') . '"/>';
            $string .= '<div class="input-group-addon" id="tipo_cliente"><a href="javascript:;" onclick="javascript:openFastEdit(\'clientes\',$(\'#id_cliente\').val(),\'\',\'\',\'\');"><span class="glyphicon glyphicon-user"></span></a></div>';
            $string .= '</div>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">CEP</label>';
            $string .= '<input name="cep" id="cep" type="text" onblur="getEndereco();" class="form-control" title="CEP" maxlength="10" value="' . $objeto->get('cep') . '"/>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Endere&ccedil;o</label>';
            $string .= '<input name="endereco" id="endereco" type="text" class="form-control" title="Endere&ccedil;o" maxlength="255" value="' . $objeto->get('endereco') . '"/>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-2 col-xs-6">';
            $string .= '<label for="">N&uacute;mero</label>';
            $string .= '<input name="numero" type="text" class="form-control" title="N&uacute;mero" maxlength="10" value="' . $objeto->get('numero') . '"/>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-2 col-xs-6">';
            $string .= '<label for="">Complemento</label>';
            $string .= '<input name="complemento" type="text" class="form-control" title="Complemento" maxlength="255" value="' . $objeto->get('complemento') . '"/>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Bairro</label>';
            $string .= '<input name="bairro" id="bairro" type="text" class="form-control" title="Bairro" maxlength="255" value="' . $objeto->get('bairro') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-md-2 hidden">';
            $string .= '<label for="">C&oacute;d. cidade</label>';
            $string .= '<input id="id_cidade" name="id_cidade" type="text" readonly class="readonly form-control" value="' . $objeto->get('id_cidade') . '"/>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-4">';
            $string .= '<label for="">Cidade</label>';
            $string .= '<input name="cidade" id="cidade" type="text" class="form-control autocomplete" autocomplete="off" data-table="cidades" data-name="nome" data-field="id_cidade" title="Cidade" maxlength="255" value="' . $objeto->get('cidade') . '"/>';
            $string .= '</div>';
            
            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Estado</label>';
            $string .= '<select class="form-control" name="estado" id="estado">';
            foreach($GLOBALS['Estados'] as $key=>$value){
                $string .= '<option value="'.$key.'" '.($objeto->get('estado') == $key? " selected " : "").'>'.$value.'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';


            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Alerta de Problema</label>';
            $string .= '<select class="form-control" name="problema" id="problema">';
            $string .= '<option value="0" '.($objeto->get('problema') != 1? " selected " : "").'>N&atilde;o</option>';
            $string .= '<option value="1" '.($objeto->get('problema') == 1? " selected " : "").'>Sim</option>';
            $string .= '</select>';
            $string .= '</div>';


        $string .= '</div>';
        $string .= '</div>';
        
       

        $string .= '<div class="tab-pane" id="tab_produtos'.$codigo.'">';
        $string .= '<h4>Produtos desse pedido
            <button type="button" onclick="javascript: openFastAdd(\'produtospedido\',\'\',\'/id_pedido/'.($codigo+0>0?$codigo:$idTemp).'\',\'getTableList(\\\'txtprodutos\\\', \\\'produtospedido/id_pedido/'.($codigo+0>0?$codigo:$idTemp).'/filtro/id_pedido,i,'.($codigo+0>0?$codigo:$idTemp).'\\\')\');" class="btn btn-circle btn-sm btn-primary">
              <span class="glyphicon glyphicon-plus"></span>
            </button></h4>';
        $string .= '<div id="txtprodutos">';
        
        $rs = ProdutoPedido::Buscar('*', ($codigo+0>0?$codigo:$idTemp), 'id_pedido', '', 'id ASC');
        $string .= ProdutoPedido::GetTable($rs);
        
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="tab-pane '.($request->get('tab') == 'historico' ? 'active' : '').'" id="tab_historico'.$codigo.'">';
        $string .= '<h4>Hist&oacute;rico do Pedido<button type="button" onclick="javascript: openFastAdd(\'historicopedido\',\'\',\'/id_pedido/'.$codigo.'\',\'getTableList(\\\'txthistorico\\\', \\\'historicopedido/filtro/id_pedido,i,'.$codigo.'\\\')\');" class="btn btn-primary btn-circle btn-sm"><span class="glyphicon glyphicon-plus"></span></button></h4> ';
        $string .= '<div id="txthistorico">';
        
        $rs = HistoricoPedido::Buscar('*', ($codigo+0>0?$codigo:$idTemp), 'id_pedido', '', 'id ASC');
        $string .= HistoricoPedido::GetTable($rs);
        
        $string .= '</div>';
        $string .= '</div>';

        if($objeto->get('id_cliente')+0 > 0){
            $string .= '<div class="tab-pane" id="tab_historico_cli'.$codigo.'">';
                $string .= '<h4>Hist&oacute;rico do Cliente <button type="button" onclick="javascript: openFastAdd(\'historicocliente\',\'\',\'/id_cliente/'.$codigo.'\',\'getTableList(\\\'txthistoricocliente\\\', \\\'historicocliente/filtro/id_cliente,i,'.$codigo.'\\\')\');" class="btn btn-primary btn-circle btn-sm"><span class="glyphicon glyphicon-plus"></span></button></h4> ';
                $string .= '<div id="txthistoricocliente">';
                $rs = HistoricoCliente::Buscar('id', $objeto->get('id_cliente')+0, 'id_cliente', '', 'id DESC');
                $string .= HistoricoCliente::GetTable($rs);
                $string .= '</div>';
            $string .= '</div>'; 

            $string .= '<div class="tab-pane" id="tab_pedidos'.$codigo.'">';
                $string .= '<h4>Outros pedidos deste Cliente</h4> ';
                $string .= Pedido::GetTable($rsP);
            $string .= '</div>';
        }

        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <div class="table-responsive">
            <table class="table table-hover">
            <thead>
              <tr>
                <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                <th class="nowrap text-center">Data Venda</th>
                <th class="w-75">Nome</th>
                <th class="w-10 text-center">Situação</th>
                <th>&nbsp;</th>
                <th class="w-10 text-right">Total</th>
                <th class="w-5">&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>
            </div>";

        return $string;
    }

    public static function GetLine($objeto){
        $objC = $objeto->getCliente();
        $telefones  = $objC->getTelWhatsLink();
        $telefones .= ($objC->get('tel2') != '' ? ' / '.$objC->getTelWhatsLink('2'): '');
        $telefones .= ($objC->get('tel3') != '' ? ' / '.$objC->getTelWhatsLink('3'): '');
        $entregue = Data::isValid($objeto->get('data_entrega'));

        $endereco = '';
        if($objeto->get('endereco') != ''){
            $endereco = $objeto->get('endereco').', '.$objeto->get('numero').' - '.$objeto->get('bairro').' - '.$objeto->get('cidade').'/'.$objeto->get('estado').' - CEP '.$objeto->get('cep');
        }else if($objC->get('endereco') != '') {
            $endereco = $objC->get('endereco').', '.$objC->get('numero').' - '.$objC->get('bairro').' - '.$objC->get('cidade').'/'.$objC->get('estado').' - CEP '.$objC->get('cep');
        }
        
        $rsP = Pedido::Buscar('count(id) qtd',$objeto->get('id_cliente'),'id_cliente');
        $rsP->next();
        $qtdPedidos = $rsP->getInt('qtd');

        //$produtos = '';
        $total = $objeto->get('frete');
        $rs2 = ProdutoPedido::Buscar('quantidade, nome, preco',$objeto->get('id'),'id_pedido','','id');
        while($rs2->next()){
            $sub = $rs2->getInt('quantidade') * $rs2->getNumber('preco');
            $total += $sub;
           // $produtos .= ($produtos != '' ? '<br>' : '').$rs2->getInt('quantidade').'x - '.$rs2->getString('nome').' x R$ '.Common::parseMoney($rs2->getNumber('preco')).' = R$ '.Common::parseMoney( $sub );
        }

        //$status = ($objeto->get('codigo_rastreio') != '' ? '<a href="javascript:;" onclick="verStatusCorreio('.$objeto->get('id').')">':'');
        $status = '';

        if($objeto->get('status') == 2){
            $status .= '
                <span data-toggle="tooltip" data-placement="top" title="Via '.$objeto->getFormaEnvio()->get('nome').'." class="badge text-uppercase" style="background:#45BC7C; border:2px solid #45BC7C" >Entregue</span>
                '.($entregue ? '<br/><small>'.Data::getFormat($objeto->get('data_entrega'),'d/m/Y').'</small>' :'');
        }elseif( in_array($objeto->get('status'),[3,6,7]) ){
            $status .= '
                <span data-toggle="tooltip" data-placement="top" title="'.self::$nmStatus[$objeto->get('status')].' - '.$objeto->get('rastreio_msg').'" class="badge text-uppercase" style="border:2px solid #CC0000; background: #FFF; color:#CC0000">'.self::$nmStatus[$objeto->get('status')].'</span>';
        }else{
            $status .= ' <span class="badge text-uppercase" data-toggle="tooltip" data-placement="top" title="Enviado via '.$objeto->getFormaEnvio()->get('nome').'" 
                    '.(
                        Data::isValid($objeto->get('data_previsao')) && mktime(0,0,0) > Data::getFormat($objeto->get('data_previsao'),'U')
                        ? 'style="background:#CC0000; border:2px solid #CC0000; ">Atrasado'
                        : 'style="background:#FFF;color:#777;border: 2px solid #777">'.self::$nmStatus[$objeto->get('status')]
                    ).
                    '</span>';
        }
        //$status .= ($objeto->get('codigo_rastreio') != '' ? '</a>':'');
        $status .= ($objeto->get('status') == 1 && Data::isValid($objeto->get('data_previsao')) ? '<br/><small>'.Data::getFormat($objeto->get('data_previsao'),'d/m/Y').'</small>' : '');
        
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td class="small text-center">'.Data::getFormat($objeto->get('data_venda'),'d/m/Y\<b\r>\<\s\m\a\l\l\>H:i\<\/s\m\a\l\l\>').'</td>
        <td>
            <a class="text-uppercase" href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');">
            '.$objeto->getCliente()->get('nomefantasia').'
            </a> 
            - '.$telefones.' '.($qtdPedidos > 1 ? ' <span class="badge" style="background:#673ab7">'.$qtdPedidos.' pedidos</span>' : '').'

            '.($objeto->get('problema') == 1 ? '
                 <a class="btn btn-danger btn-xs" data-toggle="tooltip" data-placement="right" title="Resolu&ccedil;&atilde;o do problema" href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'/tab/historico\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');">
                    <i class="fas fa-exclamation-triangle"></i>
                </a> ' : '').'

            <br/><small>'.$endereco.'<br>'.$objeto->getCanalVenda()->get('nome').' Ref: '.$objeto->get('refmp').'</small>
        </td>
        
        <td class="text-center nowrap">'.$status.'</td>
        <td> '.($objeto->get('codigo_rastreio') != '' ? '<a href="javascript:;"  class="btn btn-default btn-sm" onclick="verStatusCorreio('.$objeto->get('id').', \''.$objeto->getCliente()->get('nomefantasia').'\')" data-toggle="tooltip" data-placement="right" title="Acompanhar pedido"><i class="fas fa-truck"></i></a>': '').'
        </td>
        <td class="text-right nowrap">
           <strong>R$ '.Common::parseMoney($total).'</strong>
        </td>
        <td class="text-center">
            <div class="dropdown">
                <button class="btn btn-default dropdown-toggle btn-sm" type="button" id="dropdownMenu2" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                    <span class="caret"></span>
                </button>
                <ul class="dropdown-menu dropdown-menu-right" aria-labelledby="dropdownMenu2">
                    <li><a href="javascript:;" onclick="verProdutosPedido('.$objeto->get('id').');">Ver produtos</a></li>
                    <li><a href="javascript:;" onclick="setProblema('.$objeto->get('id').');">Tratar problema</a></li>
                    <li><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');">Excluir</a></li>
                </ul>
            </div>
            <!--<button onclick="verProdutosPedido('.$objeto->get('id').');" class="btn btn-primary btn-sm"><i class="fas fa-shopping-cart"></i> Ver produtos</button>-->
        </td>
        ';
    }
    
}
