<?php

class Pergunta extends Flex {

    protected $nomeTable = 'perguntas';
    protected $mapper = array(
        'id' => 'int',
        'id_pesquisa' => 'int',
        'descricao' => 'string',
        'posicao' => 'int',
        'tipo' => 'int',
        'visivel_relatorio' => 'int',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static $nmTipo = array(
        '1' => 'Resposta &Uacute;nica',
        '2' => 'M&uacute;ltipla Escolha',
    );
        
    protected $survey = null;
    public function getPesquisa(){
        if(!$this->survey || $this->survey->get('id') != $this->get('id_pesquisa')){
            $this->survey = Pesquisa::CarregarObjeto($this->get('id_pesquisa'));
        }
        return $this->survey;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }else{
                $rs = self::Buscar('IFNULL(MAX(posicao),0)+1 posicao',$_POST["id_pesquisa"]+0,'id_pesquisa');
                $rs->next();
                $objeto->set('posicao', $rs->getInt('posicao'));
            }

            
            $objeto->set('id_pesquisa', $_POST["id_pesquisa"]);
            $objeto->set('descricao', $_POST["descricao"]);
            $objeto->set('tipo', $_POST["tipo"]+0);
            $objeto->set('visivel_relatorio', $_POST["visivel_relatorio"]+0);
            //$objeto->set('valor', str_replace(',','.',  str_replace('.', '', $_POST["valor"])));
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));
        $canDelete = true;
        foreach ($arrIds as $id) {
            $local = array();
            if(Resposta::VerificaExistencia($id, 'id_pergunta')){
                $canDelete = false;
                $local[] = "resposta";
            }
            
        }
        if(!$canDelete){
            MessageBox::Show('Esta pergunta est&aacute; sendo usada em algum(s) registro(s) ('.implode(', ',$local).'). Remova-a antes de excluir.', "danger");
            return false;
        }else{
            return $objeto->Exclui(array('id' => $ids));
        }
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('visivel_relatorio',1);
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }
        
        if($request->get('id_pesquisa')==''){
            $string .= '<div class="form-group col-sm-3 required">';
            $string .= '<label for="">Pesquisa <a href="javascript:;" class="btn btn-primary btn-xs addcat" onclick="javascript:openFastAdd(\'pesquisas\',\'id_pesquisa\',\'\');"><span class="glyphicon glyphicon-plus"></span></a></label>';
            $string .= '<select class="form-control" name="id_pesquisa" id="id_pesquisa">';
            $rs = Pesquisa::Buscar('id,nome','','','',1,'nome ASC');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'" '.($objeto->get('id_pesquisa') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            unset($rs);
            $string .= '</select>';
            $string .= '</div>';
            $size = 4;
        
        }else{
            $size = 7;
            $objeto->set('id_pesquisa',$request->get('id_pesquisa')+0);
            $string .= '<input name="id_pesquisa" type="hidden" class="form-control" value="' . $objeto->get('id_pesquisa') . '"/>';
        
        }
        
        $string .= '<div class="form-group col-sm-'.$size.' required">';
        $string .= '<label for="">Pergunta</label>';
        $string .= '<input name="descricao" type="text" class="form-control required" value="' . $objeto->get('descricao') . '"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Tipo da Pergunta</label>';
        $string .= '<select class="form-control" name="tipo" id="tipo">';
        foreach (self::$nmTipo as $key => $value) {
            $string .= '<option value="' . $key . '" ' . ($objeto->get('tipo') == $key ? " selected " : "") . '>' . $value . '</option>';
        }
        unset($rs);
        $string .= '</select>';
        $string .= '</div>';

        $string .= '<div class="form-group col-md-2 col-sm-12 required">';
        $string .= '<label for="">Vis&iacute;vel Relat&oacute;rio?</label>';
        $string .= '<div class="btn-group btn-group-justified" data-toggle="buttons">';
        $string .= '<label class="btn btn-default'.($objeto->get('visivel_relatorio')==1?' active':'').'"><input type="radio" name="visivel_relatorio" id="option1"'.($objeto->get('visivel_relatorio')==1?' checked':'').' value="1" /> Sim</label>';
        $string .= '<label class="btn btn-default'.($objeto->get('visivel_relatorio')!=1?' active':'').'"><input type="radio" name="visivel_relatorio" id="option2"'.($objeto->get('visivel_relatorio')!=1?' checked':'').' value="0" /> N&atilde;o</label>';
        $string .= '</div>';
        $string .= '</div>';
        
        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
        <div class="table-responsive">
            <table class="table table-striped">
            <tbody>';
        $i = 0;
        if($rs->numRows()>0){
            while ($rs->next()) {
                $objeto = self::CarregarObjeto($rs->getInt('id'));
                $rsR = Resposta::Buscar('*',$objeto->get('id'),'id_pergunta','','id ASC');
                $i++;
                $string .= '<tr>
                    <td class="col-sm-9">
                        <a href="javascript:;" onclick="javascript: openFastEdit(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'txtperguntas\',\'/id_pesquisa/'.$objeto->get('id_pesquisa').'/filtro/id_pesquisa,i,'.$objeto->get('id_pesquisa').'\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('descricao').'</a> 
                         <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'getTableList(\\\'txtperguntas\\\', \\\''.$objeto->getNomeTable().'/filtro/id_pesquisa,i,'.$objeto->get('id_pesquisa').'\\\')\',false);" data-toggle="tooltip" data-placement="right" title="Excluir" class="pull-right"><i class="fas fa-trash"></i></a>
                    </td>
                    <td class="col-sm-3">'.self::$nmTipo[$objeto->get('tipo')].'</td>
                </tr>
                <tr>
                    <td colspan="2">
                        <div class="row" style="margin-bottom: 10px !important;">
                            <div class="col-sm-2">
                                <button title="Nova resposta" type="button" onclick="javascript: openFastAdd(\'respostas\',\'\',\'/id_pergunta/' . $objeto->get('id') . '\',\'getTableList(\\\'txtrespostas'.$objeto->get('id').'\\\', \\\'respostas/id_pergunta/' . $objeto->get('id'). '/filtro/id_pergunta,i,' . $objeto->get('id') . '\\\')\');" class="btn btn-primary btn-sm">
                                <span class="glyphicon glyphicon-plus"></span> Adicionar resposta
                            </div>
                            <div class="col-sm-10" id="txtrespostas'.$objeto->get('id').'">'.Resposta::getTable($rsR).'</div>
                        </div>
                    </td>
                                
                </tr>';
                
            }
        }else{
            $string .= '<tr>
                    <td>Nenhuma pergunta adicionada.</td>
                </tr>';
        }
        unset($i,$rs);

        $string .= "</tbody>
              </table>
            </div>";
         
        return $string;
    } 
    
}
