<?php

class Permissao extends Flex {

    protected $nomeTable = 'permissoes';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'modulo' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';

        if (self::VerificaExistencia(trim($_POST["modulo"]), 'modulo=', $paramAdd)) {
            $error .= '<li>M&oacute;dulo j&aacute; cadastrado;</li>';
        }

        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('modulo', $_POST["modulo"]);

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();

        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-6 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-6 required">';
        $string .= '<label for="">M&oacute;dulo</label>';
        $string .= '<input name="modulo" type="text" class="form-control required" maxlength="50" value="' . $objeto->get('modulo') . '"/>';
        $string .= '</div>';

        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-xs-6">Nome</th>
                <th class="col-xs-6">M&oacute;dulo</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td class="small">
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">' . $objeto->get('id').' - '.$objeto->get('nome') . '</a> 
        </td>
        <td class="small">'.$objeto->get('modulo').'</td>
        <td class="small"><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="left" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>';
    }

    public static function MostraOptionTipos($parametro, $tipo, $id = "") {
        $checked = "";
        $i = 0;
        $id +=0;

        $string = '';
        $string .= '<div class="form-group col-sm-12 modulos">';
        $string .= '<label for="">Permitir quais m&oacute;dulos?</label>';

        $rs = self::Buscar("id,nome,modulo", $parametro, $tipo, "", "nome");

        $string .= '<div class="btn-group col-sm-12" data-toggle="buttons">';
        while ($rs->next()) {
            if ($i > 0 && $i % 4 == 0) {
                $string .= '</div>';
                $string .= '<div class="btn-group col-sm-12" data-toggle="buttons">';
            }
            $checked = PermissaoUsuario::Verifica($id, $rs->getString('modulo'));
            $string .= '<label class="btn btn-default col-sm-3 col-xs-12' . ($checked ? ' active' : '') . '">
                          <input type="checkbox"' . ($checked ? 'checked' : '') . ' name="modulo_' . $i++ . '" value="' . $rs->getInt('id') . '" /> ' . $rs->getString('nome') . '
                        </label>';
        }
        $string .= '</div>';

        $string .= '<input name="modulos" type="hidden" value="' . $rs->numRows() . '">';

        unset($rs);
        return $string;
    }

}
