<?php

class PermissaoUsuario extends Flex {

    protected $nomeTable = 'permissoesusuario';
    protected $mapper = array(
        'id' => 'int',
        'id_permissao' => 'int',
        'id_usuario' => 'int',
        'sel' => 'int',
        'ins' => 'int',
        'upd' => 'int',
        'del' => 'int',
        'usr_cad' => 'string', 
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    protected $permissao = null;
    public function getPermissao() {
        if (!$this->permissao || $this->permissao->get('id') != $this->get('id_permissao')) {
            $this->permissao = Permissao::CarregarObjeto($this->get('id_permissao'));
        }
        return $this->permissao;
    }

    protected $usuario = null;
    public function getUsuario() {
        if (!$this->usuario || $this->usuario->get('id') != $this->get('id_usuario')) {
            $this->usuario = Usuario::CarregarObjeto($this->get('id_usuario'));
        }
        return $this->usuario;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
            
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            
            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('id_permissao', $_POST["id_permissao"]);
            $objeto->set('id_usuario', $_POST["id_usuario"]);
            $objeto->set('sel', (isset($_POST["sel"]) ? 1 : 0));
            $objeto->set('ins', (isset($_POST["ins"]) ? 1 : 0));
            $objeto->set('upd', (isset($_POST["upd"]) ? 1 : 0));
            $objeto->set('del', (isset($_POST["del"]) ? 1 : 0));
            

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($sel = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($sel, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    } 

    public static function Verifica($usuario, $modulo, $action='sel') {
        $objeto = new Permissao();
        $rs = self::Buscar("id_usuario", $usuario, "id_usuario", "AND {$action}=1 AND id_permissao IN (select id from {$objeto->getNomeTable(true)} where modulo = '{$modulo}') ");
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        if($objeto->get('id_usuario')==''){
            $objeto->set('id_usuario',$request->get('id_usuario')+0);
        }
        $string .= '<input name="id_usuario" type="hidden" class="form-control" value="' . $objeto->get('id_usuario') . '"/>';
        
        $string .= '<div class="form-group col-sm-4 required">';
        $string .= '<label for="">M&oacute;dulo</label>';
        $string .= '<select class="form-control" name="id_permissao" id="pu_id_permissao">';
        $rs = Permissao::Buscar('id,nome','','','','nome ASC');
        while($rs->next()){
            $string .= '<option value="'.$rs->getInt('id').'" '.($objeto->get('id_permissao') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
        } 
        
        $string .= '</select>';
        $string .= '</div>';
        
        $string .= '<div class="btn-group col-sm-6" data-toggle="buttons">';
        $string .= '<label for="">Permiss&atilde;o</label><br>';
        $string .= '<label class="btn btn-default btn-md '.($objeto->get('sel') == 1 ? " active" : "").'"><input type="checkbox" name="sel" '.($objeto->get('sel') == 1 ? " checked" : "").' value="1">Ver</label>';
        $string .= '<label class="btn btn-default btn-md '.($objeto->get('ins') == 1 ? " active" : "").'"><input type="checkbox" name="ins" '.($objeto->get('ins') == 1 ? " checked" : "").' value="1">Inserir</label>';
        $string .= '<label class="btn btn-default btn-md '.($objeto->get('upd') == 1 ? " active" : "").'"><input type="checkbox" name="upd" '.($objeto->get('upd') == 1 ? " checked" : "").' value="1">Editar</label>';
        $string .= '<label class="btn btn-default btn-md '.($objeto->get('del') == 1 ? " active" : "").'"><input type="checkbox" name="del" '.($objeto->get('del') == 1 ? " checked" : "").' value="1">Excluir</label>';
        $string .= '</div>';

        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped table-hover">
            <thead>
              <tr>
                <th class="col-sm-8">Permiss&atilde;o</th>
                <th class="col-sm-1 text-center">Ver</th>
                <th class="col-sm-1 text-center">Inserir</th>
                <th class="col-sm-1 text-center">Editar</th>
                <th class="col-sm-1 text-center">Apagar</th>
              </tr>
            </thead>
            <tbody>';
        $i = 0;
        if($rs->numRows()>0){
            while ($rs->next()) {
                $objeto = self::CarregarObjeto($rs->getInt('id'));
                $i++;
                $string .= '<tr id="tr">
                    <td class="link-edit">
                        <a href="javascript:;" onclick="javascript: openFastEdit(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'txtpermissoes\',\'/id_usuario/'.$objeto->get('id_usuario').'/filtro/id_usuario,i,'.$objeto->get('id_usuario').'\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->getPermissao()->get('nome').'</a> 
                        <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'getTableList(\\\'txtpermissoes\\\', \\\''.$objeto->getNomeTable().'/filtro/id_usuario,i,'.$objeto->get('id_usuario').'\\\')\',false);" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a>
                    </td>
                    <td class="small text-center"><strong><span class="glyphicon glyphicon-'.($objeto->get('sel')==1?'ok':'remove').'"></span></td>
                    <td class="small text-center"><strong><span class="glyphicon glyphicon-'.($objeto->get('ins')==1?'ok':'remove').'"></span></td>
                    <td class="small text-center"><strong><span class="glyphicon glyphicon-'.($objeto->get('upd')==1?'ok':'remove').'"></span></td>
                    <td class="small text-center"><strong><span class="glyphicon glyphicon-'.($objeto->get('del')==1?'ok':'remove').'"></span></td>
                </tr>';
            }
        }else{
            $string .= '<tr id="tr">
                    <td colspan="5" class="small text-center">Nenhuma permiss&atilde;o adicionada.</td>
                </tr>';
        }
        unset($i, $rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }
    
}
