<?php

class Pesquisa extends Flex {

    protected $nomeTable = 'pesquisas';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'campo' => 'string',
        'dias' => 'int',
        'inicio' => 'date',
        'fim' => 'date',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    public static $nmCampo = [
        'data_venda' => 'Data da Venda',
        'data_entrega' => 'Data da Entrega',
        'data_posvenda' => 'Data do P&oacute;s Venda',
    ];
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';

        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('campo', $_POST["campo"]);
            $objeto->set('dias', $_POST["dias"]+0);
            $objeto->set('inicio', Data::isValid($_POST["inicio"]) ? Data::getFormat($_POST["inicio"],'Y-m-d') : '' );
            $objeto->set('fim', Data::isValid($_POST["fim"]) ? Data::getFormat($_POST["fim"],'Y-m-d') : '' );

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();
            
            if(isset($_POST['idTemp']) && $_POST['idTemp']+0 >0 ){
                $conn = new Connection();
                $obj = new Pergunta();
                $sql = "UPDATE {$GLOBALS['DBPREFIX']}{$obj->getNomeTable()} SET id_pesquisa = {$retorno[0]} WHERE id_pesquisa = ".($_POST['idTemp']+0);
                $conn->prepareStatement($sql)->executeQuery();
            }
            
            
            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();

        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));

        foreach ($arrIds as $id) {
            
        }

        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->get('dias',1);
        $objeto->get('inicio',date('Y-m-d'));

        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-12 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="Nome" maxlength="255" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';


        $string .= '
        <div class="form-group col-sm-4">
            <label for="">Executar</label>
            <div class="input-group">
                <input name="dias" type="text" class="form-control onlynumbers" maxlength="3" value="' . $objeto->get('dias') . '"/>
                <span class="input-group-addon">dias</span>
            </div>
        </div>';

        $string .= '<div class="form-group col-sm-4">';
        $string .= '<label for="">Ap&oacute;s a</label>';
        $string .= '<select class="form-control" name="campo" id="campo">';
        foreach(self::$nmCampo as $key=>$value){
            $string .= '<option value="'.$key.'" '.($objeto->get('campo') == $key? " selected " : "").'>'.$value.'</option>';
        } 
        $string .= '</select>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2">';
        $string .= '<label for="">Vendas a partir de</label>';
        $string .= '<input type="text" class="form-control date" name="inicio" value="'.(Data::isValid($objeto->get('inicio')) ? Data::getFormat($objeto->get('inicio'), 'd/m/Y') : '').'">';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2">';
        $string .= '<label for="">At&eacute;</label>';
        $string .= '<input type="text" class="form-control date" name="fim" value="'.(Data::isValid($objeto->get('fim')) ? Data::getFormat($objeto->get('fim'), 'd/m/Y') : '').'">';
        $string .= '</div>';
        

        if($codigo+0 == 0){
            $codigo = time();
            $string .= '<input type="hidden" name="idTemp" value="'.$codigo.'" />';
        }
        
        $string .= '<div class="clearfix"></div><h4 class="mt-2">Perguntas desta pesquisa
            <button type="button" onclick="javascript: openFastAdd(\'perguntas\',\'\',\'/id_pesquisa/' . $codigo . '\',\'getTableList(\\\'txtperguntas\\\', \\\'perguntas/id_pesquisa/' . $codigo . '/filtro/id_pesquisa,i,' . $codigo . '\\\')\');" class="btn btn-primary btn-circle btn-sm">
              <span class="glyphicon glyphicon-plus"></span>
            </button></h4>';
        
        $string .= '<div class="col-sm-12" id="txtperguntas">';
        $rs = Pergunta::Buscar('*', $codigo, 'id_pesquisa', '', 'posicao ASC');
        $string .= Pergunta::GetTable($rs);
        $string .= '</div>';
        

        return $string;
    }


    public static function GetTable($rs) {
        $string = '
        <div class="table-responsive">
            <table class="table table-hover">
            <thead>
              <tr>
                <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                <th class="col-sm-9">Nome</th>
                <th class="col-sm-3">&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>
            </div>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');">' . $objeto->get('nome') . ' (' . $objeto->get('dias') . ' dia(s) ap&oacute;s a '.self::$nmCampo[$objeto->get('campo')].
            ')</a> 
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><i class="fas fa-trash"></i></a>-->
        </td>
        <td class="text-right nowrap">
        <a class="btn btn-sm btn-primary" href="'.__PATH__.'relatorio-pesquisas/view/id/'.$objeto->get('id').'" target="_blank" data-toggle="tooltip" data-placement="left" title="Ver relatório de pesquisa"><i class="fas fa-chart-pie"></i></a>
        </td>
        ';
    }

}
