<?php

class Plano extends Flex {

    protected $nomeTable = 'planos';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'valor' => 'number',
        'integracoes' => 'int',
        'espaco' => 'int',
        'url' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';

        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('integracoes', $_POST["integracoes"]);
            $objeto->set('espaco', $_POST["espaco"]);
            $objeto->set('url', $_POST["url"]);
            $objeto->set('valor', str_replace(',','.', str_replace('.','',$_POST["valor"])));

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('valor',0);

        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-6 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Mensalidade</label>';
        $string .= '<input name="valor" type="text" class="form-control money required" maxlength="11" value="' . Common::parseMoney($objeto->get('valor')) . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Integra&ccedil;&otilde;es</label>';
        $string .= '<input name="integracoes" type="text" class="form-control required" maxlength="11" value="' . $objeto->get('integracoes') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Espa&ccedil;o</label>';
        $string .= '<input name="espaco" type="text" class="form-control required" maxlength="11" value="' . $objeto->get('espaco') . '"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-sm-12 required">';
        $string .= '<label for="">URL Hotmart</label>';
        $string .= '<input name="url" type="text" class="form-control required" value="' . $objeto->get('url') . '"/>';
        $string .= '</div>';

        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-xs-6">Nome</th>
                <th class="col-xs-2">Mensal</th>
                <th class="col-xs-2">Integra&ccedil;&otilde;es</th>
                <th class="col-xs-2">Espa&ccedil;o</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td class="small">
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">' . $objeto->get('id').' - '.$objeto->get('nome') . '</a> 
        </td>
        <td class="small">R$ '.Common::parseMoney($objeto->get('valor')).'</td>
        <td class="small">'.$objeto->get('integracoes').'</td>
        <td class="small">'.$objeto->get('espaco').'</td>
        <td class="small"><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="left" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>';
    }

}
