<?php

class PosVenda extends Flex {

    protected $nomeTable = 'posvendas';
    protected $mapper = array(
        'id' => 'int',
        'id_empresa' => 'int',
        'id_pesquisa' => 'int',
        'id_usuario' => 'int',
        'id_pedido' => 'int',
        'id_canalcomunicacao' => 'int',
        'pontos' => 'int',
        'status' => 'int',
        'avaliacao' => 'int',
        'inicio' => 'date',
        'fim' => 'date',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static $nmStatus = array(
        1 => 'Aguardando',
        2 => 'Em andamento',
        3 => 'Realizado',
        4 => 'Parado',
        5 => 'Sem contato',
    );

    public static $nmAvaliacao = array(
        0 => 'N&atilde;o avaliado',
        1 => 'Ruim',
        2 => 'Regular',
        3 => 'Bom',
        4 => '&Oacute;timo',
    );

    protected $a = null;
    public function getPesquisa() {
        if (!$this->a || $this->a->get('id') != $this->get('id_pesquisa')) {
            $this->a = Pesquisa::CarregarObjeto($this->get('id_pesquisa'));
        }
        return $this->a;
    }

    protected $b = null;
    public function getUsuario() {
        if (!$this->b || $this->b->get('id') != $this->get('id_usuario')) {
            if(Usuario::VerificaExistencia($this->get('id_usuario'),'id')){
                $this->b = Usuario::CarregarObjeto($this->get('id_usuario'));
            }else{
                $this->b = new Usuario();
                $this->b->set('nome','APAGADO');
            }
        }
        return $this->b;
    }

    protected $c = null;
    public function getPedido() {
        if (!$this->c || $this->c->get('id') != $this->get('id_pedido')) {
            $this->c = Pedido::CarregarObjeto($this->get('id_pedido'));
        }
        return $this->c;
    }
    
    protected $d = null;
    public function getEmpresa() {
        if (!$this->d || $this->d->get('id') != $this->get('id_empresa')) {
            if(Empresa::VerificaExistencia($this->get('id_empresa'),'id')){
                $this->d = Empresa::CarregarObjeto($this->get('id_empresa'));
            }else{
                $this->d = new Empresa();
                $this->d->set('nome','APAGADO');
            }
        }
        return $this->d;
    }

    protected $e = null;
    public function getCanalComunicacao() {
        if (!$this->e || $this->e->get('id') != $this->get('id_canalcomunicacao')) {
            if(CanalComunicacao::VerificaExistencia($this->get('id_canalcomunicacao'),'id')){
                $this->e = CanalComunicacao::CarregarObjeto($this->get('id_canalcomunicacao'));
            }else{
                $this->e = new CanalComunicacao();
                $this->e->set('nome','APAGADO');
            }
        }
        return $this->e;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('id_pesquisa', $_POST["id_pesquisa"]+0);
            $objeto->set('id_usuario', $_POST["id_usuario"]+0);
            $objeto->set('id_empresa', $_POST["id_empresa"]+0);
            $objeto->set('id_pedido', $_POST["id_pedido"]+0);
            $objeto->set('id_canalcomunicacao', $_POST["id_canalcomunicacao"]+0);
            $objeto->set('pontos', $_POST["pontos"]+0);
            $objeto->set('status', $_POST["status"]+0);
            $objeto->set('avaliacao', $_POST["avaliacao"]+0);
            $objeto->set('inicio', (Data::isValid($_POST["inicio"].' '.$_POST["hr_inicio"]) ? Data::getFormat($_POST["inicio"],'Y-m-d').' '.$_POST["hr_inicio"] : ''));
            $objeto->set('fim', (Data::isValid($_POST["fim"].' '.$_POST["hr_fim"]) ? Data::getFormat($_POST["fim"],'Y-m-d').' '.$_POST["hr_fim"] : ''));
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();
            
            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('status', 1);
        $objeto->set('avaliacao', 3);
        $idTemp = time();
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Empresa</label>';
            $string .= '<select class="form-control" name="id_empresa" id="id_empresa">';
            $rs = Empresa::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_empresa') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Respons&aacute;vel</label>';
            $string .= '<select class="form-control" name="id_usuario" id="id_usuario">';
            $rs = Usuario::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_usuario') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Pesquisa</label>';
            $string .= '<select class="form-control" name="id_pesquisa" id="id_pesquisa">';
            $rs = Pesquisa::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_pesquisa') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Canal de Comunica&ccedil;&atilde;o</label>';
            $string .= '<select class="form-control" name="id_canalcomunicacao" id="id_canalcomunicacao">';
            $rs = CanalComunicacao::Buscar('id,nome','','','','nome');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'"'.($objeto->get('id_canalcomunicacao') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-3">';
            $string .= '<label for="">Id Pedido</label>';
            $string .= '<input type="text" class="form-control" name="id_pedido" value="'.$objeto->get('id_pedido').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Situa&ccedil;&atilde;o</label>';
            $string .= '<select class="form-control" name="status" id="status">';
            foreach(self::$nmStatus as $key=>$value){
                $string .= '<option value="'.$key.'" '.($objeto->get('status') == $key? " selected " : "").'>'.$value.'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">In&iacute;cio</label>';
            $string .= '<input type="text" class="form-control date" name="inicio" value="'.(Data::isValid($objeto->get('inicio')) ? Data::getFormat($objeto->get('inicio'), 'd/m/Y') : '').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Hora</label>';
            $string .= '<input type="text" class="form-control hour" name="hr_inicio" value="'.(Data::isValid($objeto->get('inicio')) ? Data::getFormat($objeto->get('inicio'), 'H:i:s') : '').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Fim</label>';
            $string .= '<input type="text" class="form-control date" name="fim" value="'.(Data::isValid($objeto->get('fim')) ? Data::getFormat($objeto->get('fim'), 'd/m/Y') : '').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Hora</label>';
            $string .= '<input type="text" class="form-control hour" name="hr_fim" value="'.(Data::isValid($objeto->get('fim')) ? Data::getFormat($objeto->get('fim'), 'H:i:s') : '').'">';
            $string .= '</div>';

            $string .= '<div class="form-group col-sm-2">';
            $string .= '<label for="">Pontos</label>';
            $string .= '<input type="text" class="form-control onlynumbers" name="pontos" value="'.$objeto->get('pontos').'">';
            $string .= '</div>';

        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th class="col-sm-12">Nome</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        $objC = $objeto->getCliente();
        $telefones  = $objC->getTelWhatsLink();
        $telefones .= ($objC->get('tel2') != '' ? ' / '.$objC->getTelWhatsLink('2'): '');
        $telefones .= ($objC->get('tel3') != '' ? ' / '.$objC->getTelWhatsLink('3'): '');
        
        $endereco = '';
        if($objC->get('endereco') != '') 
            $endereco = $objC->get('endereco').', '.$objC->get('numero').' - '.$objC->get('bairro').' - '.$objC->get('cidade').'/'.$objC->get('estado').' - CEP '.$objC->get('cep');

        $produtos = '';
        $total = 0;
        $rs2 = ProdutoPedido::Buscar('quantidade, nome, preco',$objeto->get('id'),'id_pedido','','id');
        while($rs2->next()){
            $sub = $rs2->getInt('quantidade') * $rs2->getNumber('preco');
            $total += $sub;
            $produtos .= ($produtos != '' ? '<br>' : '').$rs2->getInt('quantidade').'x - '.$rs2->getString('nome').' x R$ '.Common::parseMoney($rs2->getNumber('preco')).' = R$ '.Common::parseMoney( $sub );
        }
        return '
        <td class="small">
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('id').' - '.$objeto->getCliente()->get('nomefantasia').' - '.$telefones.'</a> 
            <br><span class="small">'.$endereco.'</span>
        </td>
        <td class="small">'.$produtos.'</td>
        <td class="text-right small">R$ '.Common::parseMoney($total).'</td>
        <td><a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a></td>
        ';
    }

    
}
