<?php

class Produto extends Flex {

    protected $nomeTable = 'produtos';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'sku' => 'string',
        'descricao' => 'string',
        'img' => 'string',
        'preco' => 'number',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static $tamImagem = array(
        'regular' => array('w'=>200,'h'=>200),
    );

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id') + 0;
        $paramAdd = 'AND id NOT IN(' . $id . ')';
        
        if ($error == '') {
            return true;
        } else {
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }

    public static function Salvar() {
        $valid = self::validate();
        if ($valid) {

            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('descricao', $_POST["descricao"]);
            $objeto->set('sku', $_POST["sku"]);
            $objeto->set('preco', (float) str_replace(',','.',str_replace('.','',$_POST["preco"])));

            $imgBefore = "";
            if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
                $imgBefore = $objeto->get('img');
                $objeto->set('img', Image::configureName($_FILES["imagem"]["name"]));
            }

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            $id = ( $request->getParameter('id') != "" ? $objeto->get('id') : $retorno[0] );
            if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
                Image::SaveFromUpload($imgBefore,'imagem', self::$tamImagem, $id, $objeto->getNomeTable());
            }

            MessageBox::Show("Registro salvo com sucesso!", "success");
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));
        foreach ($arrIds as $id) {
            self::ExcluirImagem($id);
        }
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function ExcluirImagem($id){
        $obj = self::CarregarObjeto($id);
        Image::DeleteImage(self::$tamImagem, $id, $obj->getNomeTable(), $obj->get('img'));
        unset($obj);
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('preco',0);
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }


        $string .= '<div class="form-group col-sm-8 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('nome') . '"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-4 required">';
        $string .= '<label for="">SKU</label>';
        $string .= '<input name="sku" type="text" class="form-control required" maxlength="255" value="' . $objeto->get('sku') . '"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-3">';
        $string .= '<label for="">Pre&ccedil;o</label>';
        $string .= '<input name="preco" type="text" class="form-control money" title="Preco" maxlength="255" value="'.Common::parseMoney($objeto->get('preco')).'"/>';
        $string .= '</div>';

        $string .= '<div class="form-group col-md-9">';
        $string .= '<label for="">Imagem Principal <small class="rule">('.implode(', ',Image::$TypesAllowed).')</small></label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span>';
        $string .= '<input name="imagem" type="file" class="form-control" title="Imagem" value=""/>';
        $string .= '</div>';
        $string .= '</div>';

        if ($codigo + 0 > 0) {
            $string .= Image::ShowImageGG($objeto);
        }

        $string .= '<div class="form-group col-sm-12">';
        $string .= '<label for="">Especifica&ccedil;&atilde;o T&eacute;cnica/Observa&ccedil;&otilde;es</label>';
        $string .= '<textarea name="descricao" type="text" class="form-control" rows="10">'.$objeto->get('descricao').'</textarea>';
        $string .= '</div>';

        if($codigo > 0){
            $string .= '
            <div class="form-group col-sm-12">
                <h4>Avalia&ccedil;&otilde;es do Produto</h4>
                <div id="txtAvaliacoes"></div>
                <script> getTableList(\'txtAvaliacoes\', \'avaliacoesproduto/filtro/id_produto,i,'.$codigo.'\'); </script>
            </div>';
        }

        return $string;
    }


    public static function GetTable($rs) {
        $string = '
            <table class="table table-hover">
            <thead>
              <tr>
                <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                <th class="col-sm-9">Nome</th>
                <th class="col-sm-3">SKU</th>
                <th class=" text-right">Pre&ccedil;o</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td>
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');">' . $objeto->get('nome') . '</a> 
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir"><i class="fas fa-trash"></i></a>-->
        </td>
        <td class="nowrap">'.$objeto->get('sku').'</td>
        <td class="nowrap text-right">R$ '.Common::parseMoney($objeto->get('preco')+0).'</td>
        ';
    }

}
