<?php

class ProdutoPedido extends Flex { 

    protected $nomeTable = 'produtospedido';
    protected $mapper = array(
        'id' => 'int',
        'id_pedido' => 'int',
        'id_produto' => 'int',
        'nome' => 'string',
        'quantidade' => 'int',
        'preco' => 'number',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    protected $pedido = null;
    public function getPedido() {
        if (!$this->pedido || $this->pedido->get('id') != $this->get('id_pedido')) {
            $this->pedido = Pedido::CarregarObjeto($this->get('id_pedido'));
        }
        return $this->pedido;
    }
    protected $produto = null;
    public function getProduto() {
        if (!$this->produto || $this->produto->get('id') != $this->get('id_produto')) {
            $this->produto = Produto::CarregarObjeto($this->get('id_produto'));
        }
        return $this->produto;
    }
   
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('id_pedido', $_POST["id_pedido"]);
            if(isset($_POST['id_produto'])){
                $objeto->set('id_produto', $_POST["id_produto"]);
                $objeto->set('nome', $objeto->getProduto()->get('nome'));
            }else{
                $objeto->set('nome', $_POST["nome"]);
            }
            $objeto->set('quantidade', (int) $_POST["quantidade"]+0);
            $objeto->set('preco', (float) str_replace(',', '.', str_replace('.', '', $_POST["preco"])));
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }

    public static function AlterarTempId($idAnt, $newId) {
        $classe = __CLASS__;
        $objeto = new $classe();
        try {
            $connection = new Connection();
            $statement = $connection->prepareStatement("UPDATE {$GLOBALS['DBPREFIX']}{$objeto->getNomeTable()} SET id_pedido = :nid: WHERE id_pedido = :id:");
            $statement->setInt("id", $idAnt);
            $statement->setInt("nid", $newId);
            $statement->executeQuery();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
    }

    public static function ExcluirPorPedido($id_pedido) {
        $classe = __CLASS__;
        $objeto = new $classe();
        try {
            $connection = new Connection();
            $statement = $connection->prepareStatement("DELETE FROM {$GLOBALS['DBPREFIX']}{$objeto->getNomeTable()} WHERE id_pedido = :id_pedido:");
            $statement->setInt("id_pedido", $id_pedido+0);
            $statement->executeQuery();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ativo = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, $ativo, $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "", $ativo = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional, $ativo);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('quantidade',0);
        $objeto->set('preco',0);
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        if($request->get('id_pedido')==''){
            $string .= '<div class="form-group col-sm-12 required">';
            $string .= '<label for="">Pedido <a href="javascript:;" class="btn btn-primary btn-xs addcat" onclick="javascript:openFastAdd(\'pedidos\',\'id_pedido\',\'\');"><span class="glyphicon glyphicon-plus"></span></a></label>';
            $string .= '<select class="form-control" name="id_pedido" id="id_pedido">';
            $rs = Pedido::Buscar('id','','','','nome ASC');
            while($rs->next()){
                $string .= '<option value="'.$rs->getInt('id').'" '.($objeto->get('id_pedido') == $rs->getInt('id')? " selected " : "").'>#'.$rs->getString('id').'</option>';
            } 
            unset($rs);
            $string .= '</select>';
            $string .= '</div>';
        
        }else{
            $objeto->set('id_pedido',$request->get('id_pedido')+0);
            $string .= '<input name="id_pedido" type="hidden" class="form-control" value="' . $objeto->get('id_pedido') . '"/>';
        
        }

        if($codigo+0 > 0){
            $string .= '<div class="form-group col-sm-8 required">';
            $string .= '<label for="">Produto</label>';
            $string .= '<input name="nome" type="text" class="form-control" value="' . $objeto->get('nome') . '"/>';
            $string .= '</div>';
        }else{
            if($request->get('id_produto')==''){
                $string .= '<div class="form-group col-sm-8 required">';
                $string .= '<label for="">Produto</label><a href="javascript:;" class="btn btn-primary btn-xs link-add" onclick="javascript:openFastAdd(\'produtos\',\'id_produto\',\'\');"><span class="glyphicon glyphicon-plus"></span></a>';
                $string .= '<select class="form-control" name="id_produto" id="id_produto" onchange="$(\'#pp_preco\').val($(this).find(\':selected\').data(\'price\'))">';
                $rs = Produto::Buscar('id, nome, preco','','','','nome ASC');
                while($rs->next()){
                    if($objeto->get('preco') == 0){
                        $objeto->set('preco', $rs->getNumber('preco'));
                    }
                    $string .= '<option data-price="'.Common::parseMoney($rs->getNumber('preco')).'" value="'.$rs->getInt('id').'" '.($objeto->get('id_produto') == $rs->getInt('id')? " selected " : "").'>'.$rs->getString('nome').'</option>';
                } 
                unset($rs);
                $string .= '</select>';
                $string .= '</div>';
            
            }else{
                $objeto->set('id_produto',$request->get('id_produto')+0);
                $string .= '<input name="id_produto" type="hidden" class="form-control" value="' . $objeto->get('id_produto') . '"/>';
            
            }
        }
        
        $string .= '<div class="form-group col-sm-2 required">';
        $string .= '<label for="">Quantidade</label>';
        $string .= '<input name="quantidade" type="text" class="form-control required onlynumbers" value="' . $objeto->get('quantidade') . '"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-2">';
        $string .= '<label for="">Pre&ccedil;o Unit&aacute;rio</label>';
        $string .= '<input name="preco" id="pp_preco" type="text" class="form-control money" maxlength="20" value="' . Common::parseMoney($objeto->get('preco')) . '"/>';
        $string .= '</div>';
        
        return $string; 
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-hover">
            <thead>
              <tr>
                <th class="">Produto</th>
                <th class="text-center">Quantidade</th>
                <th class="text-right">Pre&ccedil;o</th>
                <th class="text-right">Total</th>
              </tr>
            </thead>
            <tbody>';
        if($rs->numRows()>0){
            $total = $totalAV = 0;
            while ($rs->next()) {
                $objeto = self::CarregarObjeto($rs->getInt('id'));
                $total += $objeto->get('preco')*$objeto->get('quantidade');
                
                $string .= '<tr>
                    <td>
                        <a href="#editar-'.$objeto->get('id').'" onclick="javascript: openFastEdit(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'txtprodutos\',\'/id_pedido/'.$objeto->get('id_pedido').'/filtro/id_pedido,i,'.$objeto->get('id-pedido').'\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('nome').'</a> 
                        <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'getTableList(\\\'txtprodutos\\\', \\\''.$objeto->getNomeTable().'/filtro/id_pedido,i,'.$objeto->get('id_pedido').'\\\')\',false);" data-toggle="tooltip" data-placement="right" title="Excluir" class="pull-right"><i class="fas fa-trash"></i></a>
                    </td>
                    <td class="text-center">'.$objeto->get('quantidade').'</td>
                    <td class="nowrap text-right">R$ '.Common::parseMoney($objeto->get('preco')).'</td>
                    <td class="nowrap text-right">R$ '.Common::parseMoney($objeto->get('preco')*$objeto->get('quantidade')).'</td>
                </tr>';
            }
            $string .= '<tr id="tr">
                    <td colspan="3" class="text-right"><strong>Total</strong></td>
                    <td class="text-right"><strong>R$ '.Common::parseMoney($total).'</strong></td>
                </tr>';
            /*if($total != $totalAV){
                $string .= '<tr id="tr">
                        <td colspan="4" class="text-right">&Agrave; vista</td>
                        <td class="text-right">R$ '.Common::parseMoney($totalAV).'</td>
                    </tr>';
            }*/
        }else{
            $string .= '<tr id="tr">
                    <td class="text-center" colspan="4">Nenhum produto adicionado.</td>
                </tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";
        
        return $string;
    }
    

}

