<?php

class Publicacao extends Flex {

    protected $nomeTable = 'publicacoes';
    protected $prefixTable = 'posvendaonline_system.';
    protected $mapper = array(
        'id' => 'int',
        'titulo' => 'string',
        'subtitulo' => 'string',
        'descricao' => 'string',
        'data' => 'string',
        'autor' => 'string',
        'fonte' => 'string',
        'legenda' => 'string',
        'posicaoimg' => 'string',
        'destaque' => 'int',
        'ativo' => 'int',
        'keywords' => 'string',
        'img' => 'string',
        'video' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    public static $tamImagem = array(
        'thumb' => array('w'=>56,'h'=>56),
        'small' => array('w'=>136,'h'=>102),
        'regular' => array('w'=>480,'h'=>360),
        'zoom' => array('w'=>800,'h'=>600),
    );
    public static $nmPosicao = array(
        'left' => 'Esquerda',
        'right' => 'Direita',
        'full' => 'Todo o espa&ccedil;o',
    );

    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
            if($_FILES["imagem"]["error"] != 0){
                $error .= '<li>Imagem inv&aacute;lida;</li>';
            }
            if(!in_array(Common::getFileExtension($_FILES["imagem"]["name"]), Image::$TypesAllowed)){
                $error .= '<li>Tipo de imagem n&atilde;o suportado. Tipos suportados ('.implode(',',Image::$TypesAllowed).');</li>';
            }
        }
        
        if(!Data::isValid($_POST["data"]." ".$_POST['hora'])){
            $error .= '<li>Data/hora inv&aacute;lida;</li>';
        }
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') == "") {
                $objeto->set('ativo', 1);
            } else {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('titulo', $_POST["titulo"]);
            $objeto->set('subtitulo', $_POST["subtitulo"]);
            $objeto->set('descricao', $_POST["descricao"]);
            $objeto->set('autor', $_POST["autor"]);
            $objeto->set('fonte', $_POST["fonte"]);
            $objeto->set('legenda', $_POST["legenda"]);
            $objeto->set('posicaoimg', $_POST["posicaoimg"]);
            $objeto->set('destaque', $_POST["destaque"]);
            $objeto->set('video', $_POST["video"]);
            $objeto->set('data', Data::getFormat($_POST["data"],'Y-m-d')." ".$_POST['hora']);
            $objeto->set('keywords', $_POST["keywords"]);
            $imgBefore = "";
            if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
                $imgBefore = $objeto->get('img');
                $objeto->set('img', Image::configureName($_FILES["imagem"]["name"]));
            }

            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            $id = ( $request->getParameter('id') != "" ? $objeto->get('id') : $retorno[0] );
            if (isset($_FILES["imagem"]) && $_FILES["imagem"]["name"] != "") {
                Image::SaveFromUpload($imgBefore,'imagem', self::$tamImagem, $id, $objeto->getNomeTable());
            }
            
           
            if ($_POST['uploader-id'] == 0 ) {
                $tid = $_POST['uploader-tid'];
                Foto::AlterarTempImage($tid, $id, $objeto->getNomeTable());
                $dest = $GLOBALS['defaultPath']."uploads/{$objeto->getNomeTable()}/";
                $dirTemp = $dest."{$tid}";
                $newDir = $dest."{$id}";
                if ( is_dir($dirTemp) ){
                    rename($dirTemp, $newDir);
                }
            }

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function ExcluirImagem($id){
        $obj = self::CarregarObjeto($id);
        Image::DeleteImage(self::$tamImagem, $id, $obj->getNomeTable(), $obj->get('img'));
        unset($obj);
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();

        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));

        foreach ($arrIds as $id) {
            self::ExcluirImagem($id);
            Foto::ExcluiByTipo($id, $objeto->getNomeTable());
            
            $caminho = $GLOBALS['defaultPath']."uploads/".$objeto->getNomeTable()."/{$id}/";
            if(is_dir($caminho)){
                $ponteiro  = opendir($caminho);
                while ($nome_itens = readdir($ponteiro)) {
                    if($nome_itens != "." && $nome_itens != ".."){
                        @unlink($caminho.$nome_itens);
                    }
                }
               @rmdir($caminho);
            }
        }

        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {

        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('data',date('Y-m-d H:i:s'));
                
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        $string .= '<div class="form-group col-sm-6 col-md-6 required">';
        $string .= '<label for="">T&iacute;tulo</label>';
        $string .= '<input name="titulo" type="text" class="form-control required" title="Título" maxlength="255" value="'.$objeto->get('titulo').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-xs-6 col-sm-3 col-md-2 required">';
        $string .= '<label for="">Data</label>';
        $string .= '<input type="text" class="form-control date" name="data" value="'.Data::getFormat($objeto->get('data'), 'd/m/Y').'">';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-xs-6 col-sm-3 col-md-2 required">';
        $string .= '<label for="">Hora</label>';
        $string .= '<input type="text" class="form-control hour" name="hora" value="'.Data::getFormat($objeto->get('data'), 'H:i:s').'">';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-3 col-md-2">';
        $string .= '<label for="">Destacar?</label><br/>';
        $string .= '<div class="btn-group" data-toggle="buttons">';
        $string .= '<label class="btn btn-default'.($objeto->get('destaque')==1?' active':'').'"><input type="radio" name="destaque" id="option1"'.($objeto->get('destaque')==1?' checked':'').' value="1" /> Sim</label>';
        $string .= '<label class="btn btn-default'.($objeto->get('destaque')!=1?' active':'').'"><input type="radio" name="destaque" id="option2"'.($objeto->get('destaque')!=1?' checked':'').' value="0" /> N&atilde;o</label>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-12 col-md-12">';
        $string .= '<label for="">Subt&iacute;tulo</label>';
        $string .= '<input name="subtitulo" type="text" class="form-control" title="Subtítulo" maxlength="255" value="'.$objeto->get('subtitulo').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-12 required">';
        $string .= '<label for="">Texto</label>';
        $string .= '<textarea title="Texto" class="ckeditor" id="descricao" name="descricao" height="80">'.$objeto->get('descricao').'</textarea>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-6 col-md-6">';
        $string .= '<label for="">Autor</label>';
        $string .= '<input name="autor" type="text" class="form-control" title="Autor" maxlength="255" value="'.$objeto->get('autor').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-6 col-md-6">';
        $string .= '<label for="">Fonte</label>';
        $string .= '<input name="fonte" type="text" class="form-control" title="Fonte" maxlength="255" value="'.$objeto->get('fonte').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-md-4">';
        $string .= '<label for="">Imagem Principal <small class="rule">('.implode(', ',Image::$TypesAllowed).')</small></label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-picture"></span></span>';
        $string .= '<input name="imagem" type="file" class="form-control" title="Imagem" value=""/>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-7 col-md-4">';
        $string .= '<label for="">Legenda da Imagem</label>';
        $string .= '<input name="legenda" type="text" class="form-control" title="Legenda" maxlength="255" value="'.$objeto->get('legenda').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-5 col-md-4">';
        $string .= '<label for="">Alinhamento da Imagem no Texto</label>';
        $string .= '<select name="posicaoimg" class="form-control">';
        foreach (self::$nmPosicao as $key => $value)
            $string .= "<option value=\"{$key}\"" . ($objeto->get('posicaoimg') == $key ? " selected " : "") . ">" . ucfirst($value) . "</option>";
        $string .= '</select>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-6">';
        $string .= '<label for="">V&iacute;deo  <small class="rule">(Link do Youtube ou Vimeo...)</small></label>';
        $string .= '<input name="video" type="text" class="form-control" title="V&iacute;deo" value="'.$objeto->get('video').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-6">';
        $string .= '<label for="">Keywords  <small class="rule">(m&aacute;x. 10 keywords separadas por v&iacute;rgula)</small></label>';
        $string .= '<span class="glyphicon glyphicon-question-sign" data-toggle="tooltip" data-placement="top" title="Keywords, em portugu&ecirc;s palavras-chave, s&atilde;o os termos principais que determinam qual &eacute; o assunto de uma determinada p&aacute;gina da internet. &Eacute; muito importante escolher as keywords certas, pois &eacute; baseado nelas que os mecanismos de buscas exibem seus resultados. Quando voc&ecirc; busca na internet pela palavra &quote;eletrodom&eacute;sticos&quote;?, por exemplo, s&atilde;o listados todos os sites que possuam essa como uma de suas keywords."></span>';
        $string .= '<input name="keywords" type="text" class="form-control" title="Keywordks" value="'.$objeto->get('keywords').'"/>';
        $string .= '</div>';
        
        if ($codigo + 0 > 0) {
            $string .= Image::ShowImageGG($objeto);
        }
        
        /* inicio sistema galerias */
        
        $time = time();
        $string .= '<input type="hidden" name="uploader-table" id="uploader-table" value="'.$objeto->getNomeTable().'">';
        $string .= '<input type="hidden" name="uploader-id" id="uploader-id" value="'.($objeto->get('id')+0).'">';
        $string .= '<input type="hidden" name="uploader-tid" id="uploader-tid" value="'.$time.'">';
        $string .= '<div class="form-group col-md-12" id="uploader"><p>Seu navegador n&atilde;o suporta Flash, Silverlight ou HTML5.</p></div>';
        $string .= '<div class="form-group col-sm-12">';
        $string .= '<label for="">Galeria de Imagens Atual</label>';
        $string .= '<div class="thumbs row" id="gallery"></div>';
        $string .= '</div>';
        /* fim sistema galerias */
        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-responsive table-striped">
            <thead>
              <tr>
                <th width="10"><input id="qtdRegistros" type="checkbox" onclick="javascript:marcaCheckBoxGG();" value="'.$rs->numRows().'"/></th>
                <th class="col-sm-1 text-center"><span class="hidden-xs">Imagem</span></th>
                <th class="col-sm-9 col-xs-12">T&iacute;tulo</th>
                <th class="col-sm-2 text-center hidden-xs">Criado</th>
                <th width="10"></th>
              </tr>
            </thead>
            <tbody>';
        $i = 0;
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $i++;
            $img = $objeto->getImage('t'); 
            $string .= '<tr id="tr">
                <td><input type="checkbox" id="chkDel'.$i.'" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
                <td class="text-center">
                      <img src="'.($img!=''?$img:__BASEPATH__.'uploads/img/no-pic.jpg').'" class="imgPreviewList" />
                </td>
                <td class="link-edit">
                    <a href="#editar-'.$objeto->get('id').'" onclick="javascript: showEditForm(\''.$objeto->getNomeTable().'\','.$objeto->get('id').');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('titulo').'</a> 
                    <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').');" data-toggle="tooltip" data-placement="right" title="Excluir"><span class="glyphicon glyphicon-trash"></span></a>
                </td>
                <td class="small text-center hidden-xs">'.Data::getFormat($objeto->get('data'), 'd/m/Y H:i:s').'</td>
                <td id="status'.$objeto->get('id').'" ><a href="javascript:;" onclick="javascript: changeStatus(\''.$objeto->getNomeTable().'\','.$objeto->get('id').', '.($objeto->get('ativo')==1?'0':'1').')"><span class="glyphicon glyphicon-ok-sign '.($objeto->get('ativo')==1?'':'d').'pub" title="'.($objeto->get('ativo')==1?'Desativar':'Ativar').'"></span></a></td>
            </tr>';
        }
        unset($i,$rs);

        $string .= "</tbody>
              </table>";
        
        return $string;
    }
    
    
}
