<?php

class Resposta extends Flex {

    protected $nomeTable = 'respostas';
    protected $mapper = array(
        'id' => 'int',
        'id_pergunta' => 'int',
        'descricao' => 'string',
        'pontos' => 'int',
        'tipo' => 'int',
        'posicao' => 'int',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    public static $nmTipo = array(
        '1' => 'Sem coment&aacute;rio',
        //'2' => 'Com resposta curta',
        '3' => 'Com coment&aacute;rio',
    );
    
    protected $question = null;
    public function getPergunta(){
        if(!$this->question || $this->question->get('id') != $this->get('id_pergunta')){
            $this->question = Pergunta::CarregarObjeto($this->get('id_pergunta'));
        }
        return $this->question;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }else{
                $rs = self::Buscar('IFNULL(MAX(posicao),0)+1 posicao',$_POST["id_pergunta"]+0,'id_pergunta');
                $rs->next();
                $objeto->set('posicao', $rs->getInt('posicao'));
                $objeto->set('pontos', 0);
            }
            
            $objeto->set('id_pergunta', $_POST["id_pergunta"]);
            $objeto->set('descricao', $_POST["descricao"]);
            //$objeto->set('pontos', $_POST["pontos"]);
            $objeto->set('tipo', $_POST["tipo"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = '') {
        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }

        global $request;
        $string = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        $objeto->set('id_pergunta',$request->get('id_pergunta')+0);
        $objeto->set('pontos',0);
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
        }
        $string .= '<input name="id_pergunta" type="hidden" value="'.$objeto->get('id_pergunta').'"/>';
        
        $string .= '<div class="form-group col-md-9 required">';
        $string .= '<label for="">Resposta</label>';
        $string .= '<input name="descricao" type="text" class="form-control required" title="Descri&ccedil;&atilde;o" maxlength="255" value="'.$objeto->get('descricao').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-3 required">';
        $string .= '<label for="">Tipo da resposta</label>';
        $string .= '<select class="form-control" name="tipo" id="tipo">';
        foreach (self::$nmTipo as $key => $value) {
            $string .= '<option value="' . $key . '" ' . ($objeto->get('tipo') == $key ? " selected " : "") . '>' . $value . '</option>';
        }
        unset($rs);
        $string .= '</select>';
        $string .= '</div>';
        /*
        
        $string .= '<div class="form-group col-md-2 required">';
        $string .= '<label for="">Pontos</label>';
        $string .= '<input name="pontos" type="text" class="form-control required onlynumbers" maxlength="11" value="'.$objeto->get('pontos').'"/>';
        $string .= '</div>';*/
        
        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-hover">
            <tbody>';
        $i = 0;
        if($rs->numRows()>0){
            while ($rs->next()) {
                $objeto = self::CarregarObjeto($rs->getInt('id'));
                $i++;
                $string .= '<tr>
                    <td class="col-sm-8">
                        <a href="javascript:;" onclick="javascript: openFastEdit(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'txtrespostas'.$objeto->get('id_pergunta').'\',\'/id_pergunta/'.$objeto->get('id_pergunta').'/filtro/id_pergunta,i,'.$objeto->get('id_pergunta').'\');" data-toggle="tooltip" data-placement="top" title="Editar">'.$objeto->get('descricao').'</a> 
                        <a href="javascript:;" onclick="javascript: delFormAction(\''.$objeto->getNomeTable().'\','.$objeto->get('id').',\'getTableList(\\\'txtrespostas'.$objeto->get('id_pergunta').'\\\', \\\''.$objeto->getNomeTable().'/filtro/id_pergunta,i,'.$objeto->get('id_pergunta').'\\\')\',false);" data-toggle="tooltip" data-placement="right" title="Excluir" class="pull-right"><i class="fas fa-trash"></i></a>
                    </td>
                    <td class="col-sm-3 small text-center hidden-xs nowrap">'.self::$nmTipo[$objeto->get('tipo')].'</td>
                    <td class="col-sm-1 small text-center hidden-xs nowrap">'.$objeto->get('pontos').'</td>
                </tr>';
            }
        }else{
             $string .= '<tr><td colspan="2" class="text-center">Nenhuma resposta adicionada.</td></tr>';
        }
        unset($i,$rs);

        $string .= "</tbody>
              </table>";
        
        return $string;
    }
}
