<?php

class RespostaPesquisa extends Flex {

    protected $nomeTable = 'respostaspesquisa';
    protected $mapper = array(
        'id' => 'int',
        'id_posvenda' => 'int',
        'id_pergunta' => 'int',
        'id_resposta' => 'int',
        'descricao' => 'string',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    protected $primaryKey = array('id');
    
    protected $pp = null;
    public function getPosVenda(){
        if(!$this->pp || $this->pp->get('id') != $this->get('id_posvenda')){
            $this->pp = PosVenda::CarregarObjeto($this->get('id_posvenda'));
        }
        return $this->pp;
    }
    
    protected $pergunta = null;
    public function getPergunta(){
        if(!$this->pergunta || $this->pergunta->get('id') != $this->get('id_pergunta')){
            $this->pergunta = Pergunta::CarregarObjeto($this->get('id_pergunta'));
        }
        return $this->pergunta;
    }
    
    protected $resposta = null;
    public function getResposta(){
        if(!$this->resposta || $this->resposta->get('id') != $this->get('id_resposta')){
            $this->resposta = Resposta::CarregarObjeto($this->get('id_resposta'));
        }
        return $this->resposta;
    }
    
    public static function validate() {
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') != "") {
                $objeto = self::CarregarObjeto($request->getParameter('id'));
            }

            $objeto->set('id_posvenda', $_POST["id_posvenda"]);
            $objeto->set('id_pergunta', $_POST["id_pergunta"]);
            $objeto->set('id_resposta', $_POST["id_resposta"]);
            $objeto->set('descricao', $_POST["descricao"]);
            
            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }
    
    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->Exclui(array('id' => $ids));
    }
    
    public static function ExcluiRespostas($pp, $pergunta) {
        $classe = __CLASS__;
        $objeto = new $classe();
        try {
            $connection = new Connection();
            $statement = $connection->prepareStatement("DELETE FROM {$GLOBALS['DBPREFIX']}{$objeto->getNomeTable()} WHERE id_posvenda = :id_posvenda: AND id_pergunta = :pergunta:");
            $statement->setInt("id_posvenda", $pp);
            $statement->setInt("pergunta", $pergunta);
            $statement->executeQuery();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
    }
    public static function ExcluiRespostasByPP($pp) {
        $classe = __CLASS__;
        $objeto = new $classe();
        try {
            $connection = new Connection();
            $statement = $connection->prepareStatement("DELETE FROM {$GLOBALS['DBPREFIX']}{$objeto->getNomeTable()} WHERE id_posvenda = :id_posvenda:");
            $statement->setInt("id_posvenda", $pp);
            $statement->executeQuery();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
    }
    
    public static function ExcluiRespostasByPerg($id) {
        $classe = __CLASS__;
        $objeto = new $classe();
        try {
            $connection = new Connection();
            $statement = $connection->prepareStatement("DELETE FROM {$GLOBALS['DBPREFIX']}{$objeto->getNomeTable()} WHERE id_pergunta = :id_pergunta:");
            $statement->setInt("id_pergunta", $id);
            $statement->executeQuery();
        } catch (SQLException $e) {
            echo $e->getMessage();
            exit;
        }
    }

    public static function CarregarObjeto($id) {
        $classe = __CLASS__;
        $objeto = new $classe(array($id));
        $objeto->carregaObjeto();
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ativo = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        $ativo = '';
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, $ativo, $ordena, $limit);
    }
        

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "", $ativo = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional, $ativo);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

}
