
<?php 
require  __DIR__.'/_core/config/config.php';
require  __DIR__.'/_core/autoload.php';
$debug = isset($_GET['debug']);

$prefix = 'posvendaonline_';

$DBName = $prefix."system";
$conn = new Connection();

$sql = "SELECT banco FROM `paineis` WHERE expiracao >= DATE(NOW()) AND banco <> 'demo' ORDER BY dt_ualt";
$rsDB = $conn->prepareStatement($sql)->executeReader();
$databases = array();
while($rsDB->next()){
    $databases[] = $prefix.$rsDB->getString('banco');
}
$conn->closeConnection();

function updatePainel($database){
    global $conn, $prefix, $debug;
    $database = (str_replace($prefix, '', $database));
    $conn->prepareStatement("UPDATE posvendaonline_system.paineis SET dt_ualt = NOW(), usr_ualt='crontab' WHERE banco = '{$database}'")->executeQuery();
    //if($debug) echo '<script> setTimeout(function(){ location.reload(); },1000);</script>';
    
}

foreach($databases as $database){
    $DBName = $database;
    $conn = new Connection();
    
    if($debug) echo "<h2>{$database}</h2>";
    
    $sql = "
    SELECT 
        id, codigo_rastreio 
    FROM pedidos 
    WHERE 
        status IN (0,1,4,7) 
        AND data_venda > DATE_SUB(DATE(NOW()), INTERVAL 45 DAY) 
        AND IFNULL(codigo_rastreio,'') <> '' 
        AND IFNULL(rastreio_api,'') <> 'error' 
        AND DATE(dt_ualt) < DATE(NOW())
    ORDER BY dt_ualt
    LIMIT 0,40";
    $rs = $conn->prepareStatement($sql)->executeReader();
    
    if($debug) echo "Executando rastreios: {$rs->numRows()} ";

    if($rs->numRows() > 0){
        while($rs->next()){
            $obj = new Entrega($rs->getString('codigo_rastreio'), $rs->getInt('id'));
            $obj->verificaTodos();
        }

        updatePainel($database);
        exit;
    }
    if($debug) echo "executados<br>";

    $sql = "
    SELECT id, sistema, data11, data8 FROM integracoes 
    WHERE importar = 1 AND (DATE(NOW()) > DATE(data9) OR data9='' OR CAST(IFNULL(data10,0) AS UNSIGNED) > CAST(IFNULL(data11,0) AS UNSIGNED) OR IFNULL(data8,'') <> '')
    ORDER BY dt_ualt";
    //data9 ultima execucao
    //data10 total de paginas
    //data11 pagina atual

    $rs = $conn->prepareStatement($sql)->executeReader();
    if($debug) echo "Executando integracoes: ";
    $executados = 0;
    if($rs->numRows() > 0){
        while($rs->next()){
            if($debug) echo ' ('.Integracao::$nmSistema[$rs->getInt('sistema')].') ';
            $obj = null;
            if($rs->getInt('sistema') == 1){//bling 
                $obj = new Bling($rs->getInt('id'));

            }elseif($rs->getInt('sistema') == 2){//meli 
                $obj = new MercadoLivre($rs->getInt('id'));

            }elseif($rs->getInt('sistema') == 3){ //ideris
                $obj = new Ideris($rs->getInt('id'));
                
            }elseif($rs->getInt('sistema') == 4){//tiny 
                $obj = new Tiny($rs->getInt('id'));
                //executando importacao parcial
                if($rs->getString('data8') != ''){
                    $ids = explode(',', $rs->getString('data8'));
                    $min = min(20, count($ids));
                    for($i = 0; $i < $min; $i++){
                        $obj->getPedidoById($ids[$i]);
                    }
                    array_splice($ids, 0, $min);
                    $obj->integracao->set('data8', implode(',',$ids));
                    $executados++;
                }else{
                    $obj->integracao->set('data8', '');
                }
                $obj->integracao->Alterar();
                
            }

            if($executados == 0 && $obj){
                $executados++;
                if($obj->integracao->get('data9') == date('Y-m-d', strtotime('-1 day'))) {
                    $page = 1;
                }else{
                    $page = $rs->getInt('data11')+1;
                }
                $obj->getPedidos(
                    date('Y-m-d', strtotime('-1 day')), 
                    date('Y-m-d'), 
                    $page, 
                    true
                );
            }

            if($debug) echo "{$executados} executados<br><br>";
            if($executados > 0){
                updatePainel($database);
                $conn->closeConnection();
                exit;
            }
        
        }
    }

    
    updatePainel($database);
    $conn->closeConnection();

}

