function blockUi(){
    $.blockUI({ message: '<img src="'+__BASEPATH__ +'css/img/loading.gif" width="20px" /> Aguarde...',
        css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        }
    });
}

function unblockUi(){
    $.unblockUI();
}

function blockOnSubmit(){
    $.blockUI({ message: '<img src="'+__BASEPATH__ +'css/img/loading.gif" width="20px" /> <span id="progressPercent">0%</span>',
        css: {
            border: 'none',
            padding: '15px',
            backgroundColor: '#000',
            '-webkit-border-radius': '10px',
            '-moz-border-radius': '10px',
            opacity: .5,
            color: '#fff'
        }
    });
}

function showErrorAlert(title, message){
    BootstrapDialog.show({
        title: title,
        message: message,
        type: BootstrapDialog.TYPE_DANGER
    });
}


function getEndereco(cep) {
    function getDataFromApi(cep){
        $.getJSON( "https://viacep.com.br/ws/" + cep.replace(/[^0-9]/g,'')+"/json/", function( data ) {
            if (data) {
                $("#endereco").val(unescape(data.logradouro));
                $("#bairro").val(unescape(data.bairro));
                if($("#id_cidade")) $("#id_cidade").val(unescape(data.ibge));
                $("#cidade").val(unescape(data.localidade));
                $("#estado option").each(function() {
                    if($(this).val() == unescape(data.uf)) {
                      $(this).attr('selected', 'selected');            
                    }                        
                });
                
            }
        });
    }

    if ($.trim(cep) != "") {
        if($("#endereco").val() == ''){
            getDataFromApi(cep);
        }else{
            BootstrapDialog.show({
                title: 'Confirma&ccedil;&atilde;o',
                message: 'Deseja substituir o endere&ccedil;o existente?',
                buttons: [{
                        label: 'N&atilde;o',
                        action: function(dialog) {
                            dialog.close();
                        }
                    }, {
                        label: 'Sim',
                        cssClass: 'btn-primary',
                        action: function(dialog) {
                            getDataFromApi(cep);
                            dialog.close();
                        }
                    }]
            });
        }



        
    }
}


function buscaPessoaDB(cpf, nasc){
    if(cpf && nasc){
        var dtAux = nasc.split('/');
        $.ajax({
            url: __PATH__+'ajax/busca-pessoa/cpf/'+cpf+'/nasc/'+dtAux[2]+'-'+dtAux[1]+"-"+dtAux[0],
            type: 'GET',
            dataType: "json",
            success: function(data) {
                if (data['ok']) {
                    var obj = data['obj'];

                    $("#sexo option").each(function() {
                        if($(this).val() == unescape(obj.sexo)) {
                          $(this).attr('selected', 'selected');            
                        }                        
                    });
                    
                    $("#estado option").each(function() {
                        if($(this).val() == unescape(obj.estado)) {
                          $(this).attr('selected', 'selected');            
                        }                        
                    });
                    $('#nome').val(obj.nomefantasia).prop('disabled',true);
                    $('#rg').val(obj.rg).prop('disabled',true);
                    $('#tel').val(obj.tel).prop('disabled',true);
                    $('#tel2').val(obj.tel2).prop('disabled',true);
                    $('#tel3').val(obj.tel3).prop('disabled',true);
                    $('#email').val(obj.email).prop('disabled',true);
                    $('#instagram').val(obj.instagram).prop('disabled',true);
                    $('#facebook').val(obj.facebook).prop('disabled',true);
                    $('#cep').val(obj.cep).prop('disabled',true);
                    $('#endereco').val(obj.endereco).prop('disabled',true);
                    $('#numero').val(obj.numero).prop('disabled',true);
                    $('#complemento').val(obj.complemento).prop('disabled',true);
                    $('#bairro').val(obj.bairro).prop('disabled',true);
                    $('#cidade').val(obj.cidade).prop('disabled',true);
                    $('#pai').val(obj.pai).prop('disabled',true);
                    $('#tel_pai').val(obj.tel_pai).prop('disabled',true);
                    $('#mae').val(obj.mae).prop('disabled',true);
                    $('#tel_mae').val(obj.tel_mae).prop('disabled',true);
                    $('#senha,#senhac,#estado,#sexo').prop('disabled',true);
                    

                }
            },
            error: function(jqXHR, textStatus, errorThrown)
            {
                showErrorAlert('Erro buscando dados', 'JQXHR: ' + jqXHR.responseText + '<br>Status: ' + textStatus + '<br>Throw: ' + errorThrown);
            }
        });
    }
}

var form = $('#frm-inscricao');
function submitInscricao(){

    form.ajaxSubmit({
        url: __PATH__+'ajax/cadastra-pessoa/',
        type: "POST",
        dataType: "json",
        beforeSend: function() {
            blockOnSubmit();
            $('#progressPercent').html('0%');
        },
        uploadProgress: function(event, position, total, percentComplete) {
            $('#progressPercent').html(percentComplete + '%');
        },
        success: function(data, textStatus, jqXHR)
        {
            unblockUi();
            if (data['ok']) {
                location = data['redirect'];
            } else {
                showErrorAlert('Erro no salvamento do registro', data['data']);
                
            }

        },
        error: function(jqXHR, textStatus, errorThrown)
        {
            unblockUi();
            showErrorAlert('Erro no salvamento do registro', 'JQXHR: ' + jqXHR.responseText + '<br>Status: ' + textStatus + '<br>Throw: ' + errorThrown);
            
        }
    });

}

jQuery.extend(jQuery.validator.messages, {
     required: "",
     remote: "Por favor, corrija este campo.",
     email: "Por favor, forne&ccedil;a um endereço eletr&ocirc;nico v&aacute;lido.",
     url: "Por favor, forne&ccedil;a uma URL v&aacute;lida.",
     date: "Por favor, forne&ccedil;a uma data v&aacute;lida.",
     dateISO: "Por favor, forne&ccedil;a uma data v&aacute;lida (ISO).",
     number: "Por favor, forne&ccedil;a um n&uacute;mero v&aacute;lido.",
     digits: "Por favor, forne&ccedil;a somente d&iacute;gitos.",
     creditcard: "Por favor, forne&ccedil;a um cart&atilde;o de cr&eacute;dito v&aacute;qlido.",
     equalTo: "Por favor, forne&ccedil;a o mesmo valor novamente.",
     accept: "Por favor, forne&ccedil;a um valor com uma extens&atilde;o v&aacute;lida.",
     maxlength: jQuery.validator.format("Por favor, forne&ccedil;a n&atilde;o mais que {0} caracteres."),
     minlength: jQuery.validator.format("Por favor, forne&ccedil;a ao menos {0} caracteres."),
     rangelength: jQuery.validator.format("Por favor, forne&ccedil;a um valor entre {0} e {1} caracteres de comprimento."),
     range: jQuery.validator.format("Por favor, forne&ccedil;a um valor entre {0} e {1}."),
     max: jQuery.validator.format("Por favor, forne&ccedil;a um valor menor ou igual a {0}."),
     min: jQuery.validator.format("Por favor, forne&ccedil;a um valor maior ou igual a {0}.")
 });

 
form.steps({
    headerTag: "h3",
    bodyTag: "fieldset",
    transitionEffect: "slideLeft",
    titleTemplate: '<span class="number">#index#.</span> <span class="hidden-xs">#title#</span> ',
    /* Labels */
    labels: {
        cancel: "Cancelar",
        current: "Passo atual:",
        pagination: "Pagina&ccedil;&atilde;o",
        finish: "Finalizar",
        next: "Pr&oacute;ximo",
        previous: "Anterior",
        loading: "Carregando ..."
    },
    onStepChanging: function (event, currentIndex, newIndex)
    {
        // Allways allow previous action even if the current form is not valid!
        if (currentIndex > newIndex)
        {
            return true;
        }
        // Needed in some cases if the user went back (clean up)
        if (currentIndex < newIndex)
        {
            // To remove error styles
            form.find(".body:eq(" + newIndex + ") label.error").remove();
            form.find(".body:eq(" + newIndex + ") .error").removeClass("error");
        }

        form.validate().settings.ignore = ":disabled,:hidden";
        var isValid = form.valid();

        if(isValid && currentIndex == 0 && newIndex == 1){
            blockUi();
            $.ajax({
                url: __PATH__+'ajax/pessoa-esta-inscrita/id/'+$('#id').val()+'/cpf/'+$('#cpf').val().replace(/[^0-9]/g,''),
                type: 'GET',
                dataType: "json",
                async: false,
                success: function(data) {
                    if(data['exists']){
                        showErrorAlert('Erro na Inscri&ccedil;&atilde;o',data['data']);
                        isValid = false;
                    }
                },
                error: function(jqXHR, textStatus, errorThrown)
                {
                    console.log('JQXHR: ' + jqXHR.responseText + ', Status: ' + textStatus + ', Throw: ' + errorThrown);
                }
            }).done(function() {
                unblockUi();
            });
        }
        return isValid;
        
    },
    onStepChanged: function (event, currentIndex, priorIndex)
    {
        
        if(priorIndex == 0 && currentIndex == 1 && $('#nome').val() == ''){
            buscaPessoaDB($('#cpf').val(), $('#nasc').val());
        }

    },
    onFinishing: function (event, currentIndex)
    {
        submitInscricao();
        form.validate().settings.ignore = ":disabled,:hidden";
        return form.valid();
    },
}).validate({
    errorPlacement: function errorPlacement(error, element) { element.before(error); },
    rules: {
    },messages: {
        required: "Campo obrigat&oacute;rio",
    }
});
