function getEndereco(idField, nameField) {
    function getDataFromApi(cep){
        $.getJSON( "https://viacep.com.br/ws/" + cep.replace(/[^0-9]/g,'')+"/json/", function( data ) {
            if (data) {
                $("#endereco").val(unescape(data.logradouro));
                $("#bairro").val(unescape(data.bairro));
                if($("#id_cidade")) $("#id_cidade").val(unescape(data.ibge));
                $("#cidade").val(unescape(data.localidade));
                $("#estado option").each(function() {
                    if($(this).val() == unescape(data.uf)) {
                      $(this).attr('selected', 'selected');            
                    }                        
                });
                
            }
        });
    }

    if ($.trim($("#cep").val()) != "") {
        if($("#endereco").val() == ''){
            getDataFromApi($("#cep").val());
        }else{
            BootstrapDialog.show({
                title: 'Confirma&ccedil;&atilde;o',
                message: 'Deseja substituir o cep existe?',
                buttons: [{
                        label: 'N&atilde;o',
                        action: function(dialog) {
                            dialog.close();
                        }
                    }, {
                        label: 'Sim',
                        cssClass: 'btn-primary',
                        action: function(dialog) {
                            getDataFromApi($("#cep").val());
                            dialog.close();
                        }
                    }]
            });
        }



        
    }
}

function showErrorAlert(title, message){
    BootstrapDialog.show({
        title: title,
        message: message,
        type: BootstrapDialog.TYPE_DANGER
    });
}

function buscaCredenciais(form, text, path)
{
    if (validaForm(form))
    {
        location = path + '/busca/por/' + text;
    }
    
    return false;
}

function buscar(form, text, path)
{
    if (validaForm(form))
    {
        location = path + 'buscar/por/text/' + text;
    }
    
    return false;
}

function buscarRequerimento(path)
{
    if (($('#tipo').val()+0) > 0)
    {
        location = path + 'requerimento/buscar/tipo/' + $('#tipo').val() + '/tipo_pessoa/' + $('#tipo_pessoa').val();
    }
}

function loadMore(pos, id)
{
    var url = __PATH__ + 'ajax/load-more/pos/'+pos+'/id/'+id;

    $.ajax({
            url: url,
            type: 'GET',
            dataType: "json",
            success: function(data, textStatus, jqXHR)
            {
                if (data['data'] != "")
                {
                    $("#loadMore").append(data['data']);
                    $("#loadMoreBtn").attr("onClick", "javascript: loadMore("+(pos + 8)+", "+id+");");
                }
                else
                {
                    $("#loadMoreBtn").remove();
                }
            },
            error: function(jqXHR, textStatus, errorThrown)
            {
                    alert("JQXHR: "+jqXHR.responseText+" | Status: "+textStatus+" | Throw: "+errorThrown);
            }
    });
}

function loadMoreArtigos(pos, id)
{
    var url = __PATH__ + 'ajax/load-more-artigos/pos/'+pos+'/id/'+id;

    $.ajax({
            url: url,
            type: 'GET',
            dataType: "json",
            success: function(data, textStatus, jqXHR)
            {
                if (data['data'] != "")
                {
                    $("#loadMore").append(data['data']);
                    $("#loadMoreBtn").attr("onClick", "javascript: loadMore("+(pos + 8)+", "+id+");");
                }
                else
                {
                    $("#loadMoreBtn").remove();
                }
            },
            error: function(jqXHR, textStatus, errorThrown)
            {
                    alert("JQXHR: "+jqXHR.responseText+" | Status: "+textStatus+" | Throw: "+errorThrown);
            }
    });
}

function changeLang(a)
{
    var elemento = "";
    
    if (document.createEvent) 
    {
        var c = document.createEvent("HTMLEvents");
        c.initEvent("click", true, true)
    }
    
    if (a == 'pt')
    {
        elemento = $(".goog-te-banner-frame:eq(0)").contents().find("button[id*='restore']");
    } 
    else
    {
        elemento = $(".goog-te-menu-frame:eq(0)").contents().find("span:contains('Ing')");
    }
    
    if (elemento.length > 0)
    {
        if (document.createEvent)
        {
            elemento[0].dispatchEvent(c);
        }
        else
        {
            elemento[0].click();
        }
    }
}
function googleTranslateElementInit()
{
    new google.translate.TranslateElement({
        pageLanguage: 'pt',
        autoDisplay: false,
        includedLanguages: 'en',
        layout: google.translate.TranslateElement.InlineLayout.SIMPLE
    },'google_translate_element');
    
    $('#lang_type').bind('DOMSubtreeModified', function() {
        var id = $('html').attr("class") == "translated-ltr" ? "en" : "pt";
    
        if (id == "pt")
        {
            $('#pt_img').attr("class","active");
            $('#en_img').attr("class","");
        }
        else
        {
            $('#pt_img').attr("class","");
            $('#en_img').attr("class","active");
        }
    });
}

function translate(element)
{
    var id = element.getAttribute("id");
    
    if (id == "pt")
    {
        $('#pt_img').attr("class","active");
        $('#en_img').attr("class","");
    }
    else
    {
        $('#pt_img').attr("class","");
        $('#en_img').attr("class","active");
    }
    
    $('#lang_type').unbind();
    changeLang(id);
}

function newsListServico(id, page, cls)
{
    if (cls == "")
        cls = "#morenews";
    
    $(cls).html('Aguarde, buscando...');
    var url = __PATH__ + 'ajax/news-list-servicos/id/' + id + '/page/' + page;
    $.ajax({
        url: url,
        type: 'GET',
        dataType: "json",
        success: function(data, textStatus, jqXHR) {
            if (data['ok']) {
                $(cls).html(data['data']);
            } else {
                $(cls).html(data['data']);
            }
        },
        error: function(jqXHR, textStatus, errorThrown)
        {
            $(cls).html('<li>JQXHR: ' + jqXHR.responseText + '<br>Status: ' + textStatus + '<br>Throw: ' + errorThrown+'</li>');
        }
    });
}

function newsListGrupo(id, page, cls)
{
    if (cls == "")
        cls = "#morenews";
    
    $(cls).html('Aguarde, buscando...');
    var url = __PATH__ + 'ajax/news-list-grupos/id/' + id + '/page/' + page;
    $.ajax({
        url: url,
        type: 'GET',
        dataType: "json",
        success: function(data, textStatus, jqXHR) {
            if (data['ok']) {
                $(cls).html(data['data']);
            } else {
                $(cls).html(data['data']);
            }
        },
        error: function(jqXHR, textStatus, errorThrown)
        {
            $(cls).html('<li>JQXHR: ' + jqXHR.responseText + '<br>Status: ' + textStatus + '<br>Throw: ' + errorThrown+'</li>');
        }
    });
}

function checa(mail) {
    var er = new RegExp(/^[A-Za-z0-9_\-\.]+@[A-Za-z0-9_\-\.]{2,}\.[A-Za-z0-9]{2,}(\.[A-Za-z0-9])?/);
    if (typeof (mail) == "string") {
        if (er.test(mail)) {
            return true;
        }
    } else if (typeof (mail) == "object") {
        if (er.test(mail.value)) {
            return true;
        }
    } else {
        return false;
    }
}

function cadastraEmail(email)
{
    if (checa(email)) 
    {
        var url = __PATH__ + 'ajax/envia-email/email/' + email;
        $.ajax({
            url: url,
            type: 'GET',
            dataType: "json",
            success: function(data, textStatus, jqXHR) {
                if (data['ok']) {
                    alert(data['data']);
                }
            },
            error: function(jqXHR, textStatus, errorThrown)
            {
                alert('JQXHR: ' + jqXHR.responseText + '<br>Status: ' + textStatus + '<br>Throw: ' + errorThrown);
            }
        });
    }
    else
    {
        alert('Email incorreto...');
    }
}