<?php

ob_start();
require 'dao/connection.class.php';
require 'dao/resultset.class.php';
require 'dao/sqlexception.class.php';
require 'dao/statement.class.php';
require 'basics/cpaneluapi.class.php';

function replace($regularexp, $to, $string){
    return preg_replace_callback($regularexp, function () use ($to) { return $to; }, $string);
}

function randomPassword($size=32) {
    $alphabet = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890';
    $pass = array(); //remember to declare $pass as an array
    $alphaLength = strlen($alphabet) - 1; //put the length -1 in cache
    for ($i = 0; $i < $size; $i++) {
        $n = rand(0, $alphaLength);
        $pass[] = $alphabet[$n];
    }
    return implode($pass); //turn the array into a string
}

function rrmdir($dir) { 
   if (is_dir($dir)) { 
     $objects = scandir($dir); 
     foreach ($objects as $object) { 
       if ($object != "." && $object != "..") { 
         if (is_dir($dir."/".$object))
           rrmdir($dir."/".$object);
         else
           unlink($dir."/".$object); 
       } 
     }
     rmdir($dir); 
   } 
 }

function normalize ($string) {
    $table = array(
        ''=>'S', ''=>'s', ''=>'Dj', ''=>'Z', ''=>'z', 'C'=>'C', 'c'=>'c', 'C'=>'C', 'c'=>'c',
        ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'A', ''=>'C', ''=>'E', ''=>'E',
        ''=>'E', ''=>'E', ''=>'I', ''=>'I', ''=>'I', ''=>'I', ''=>'N', ''=>'O', ''=>'O', ''=>'O',
        ''=>'O', ''=>'O', ''=>'O', ''=>'U', ''=>'U', ''=>'U', ''=>'U', ''=>'Y', ''=>'B', ''=>'Ss',
        ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'a', ''=>'c', ''=>'e', ''=>'e',
        ''=>'e', ''=>'e', ''=>'i', ''=>'i', ''=>'i', ''=>'i', ''=>'o', ''=>'n', ''=>'o', ''=>'o',
        ''=>'o', ''=>'o', ''=>'o', ''=>'o', ''=>'u', ''=>'u', ''=>'u', ''=>'y', ''=>'y', ''=>'b',
        ''=>'y', 'R'=>'R', 'r'=>'r',
    );

    return strtr($string, $table);
}

$DB = array(
    'user' => 'posvendaonline',
    'pass' => '@@@S3rv3r',
    'name' => 'posvendaonline_sys',
    'host' => 'mysql.flexpoint.com.br',
    'drive' => 'mysql', 
    'port' => 3306,
);


$acao = isset($_GET['action'])?$_GET['action']:'';


if($acao == 'create' && count($_POST) > 0){
    
    if($_POST['password'] == '@@Notime'){

    $subdomain = replace('/[^0-9_a-z]/','',strtolower(normalize($_POST['subdomain'])));
    $database = $subdomain;
    $name = $_POST['name'];
    
    $cPanel = new cpanelAPI($DB['user'], $DB['pass'], '127.0.0.1');
    $DB['name'] = $cPanel->user.'_'.$database;
    
    echo "----------------<br>";
    echo "Creating folder...";
    $dir = __DIR__.'/../'.$subdomain.'/';
    if(!is_dir($dir)){
        mkdir($dir.'uploads',0777, true);

        echo 'ok';
        echo "<br>----------------<br>";
        echo "Creating index.php ...";
        file_put_contents($dir.'index.php', '<?php
global $defaultPath, $predefinedPath, $DBName,$xmlConfig;
$defaultPath = dirname(__FILE__)."/";
$predefinedPath = array(
    ""=> array("folder"=>"sistema/", "path" => ""),
);
$DBName = "'.$DB['name'].'";
require $defaultPath."../../_core/bootstrap.php";
');
        echo "ok";

        echo "Creating .htaccess ...";
        file_put_contents($dir.'.htaccess', 'ErrorDocument 404 /erro/

RewriteEngine On

RewriteCond %{HTTPS} !=on
RewriteRule ^.*$ https://%{SERVER_NAME}%{REQUEST_URI} [R,L]

RewriteCond %{REQUEST_FILENAME} -s [OR]
RewriteCond %{REQUEST_FILENAME} -l [OR]
RewriteCond %{REQUEST_FILENAME} -d
RewriteRule ^.*$ - [NC,L]

RewriteRule ^(.+)$ index.php?param=$1

Options -Indexes
');
        echo "ok";

    }else{
        echo 'exists';
    }
    
    echo "<br>----------------<br>";
    echo "Creating Database...";
    $response = $cPanel->uapi->Mysql->create_database(array('name' => $DB['name']));
    print_r($response);
    echo "ok";

    echo "<br>----------------<br>";
    echo "Grant permissions...";
    $response = $cPanel->uapi->Mysql->set_privileges_on_database(array('user' => $cPanel->user.'_master', 'database' => $DB['name'], 'privileges' => 'CREATE,DROP,EXECUTE,SELECT,INSERT,DELETE,UPDATE'));
    print_r($response);
    echo "ok";
    
    echo "<br>----------------<br>";
    echo "Creating subdomain...";
    $response = $cPanel->api2->SubDomain->addsubdomain(['rootdomain' => 'posvendaonline.com.br', 'domain' => $subdomain, 'dir' => '/public_html/p/'.$subdomain]);
    print_r($response);
    echo "ok";
    
    echo "<br>----------------<br>";
    echo "Importing data to DB...";
    $conn = new Connection($DB);
    $query = '';

    $sqlScript = file('install.sql');
    foreach ($sqlScript as $line)   {
        
        $startWith = substr(trim($line), 0 ,2);
        $endWith = substr(trim($line), -1 ,1);
        
        if (empty($line) || $startWith == '--' || $startWith == '/*' || $startWith == '//') {
            continue;
        }
            
        $query = $query . $line;
        if ($endWith == ';') {
            $conn->prepareStatement(utf8_decode($query))->executeQuery();
            $query= '';
        }
    }
    
    $sql="UPDATE configs SET valor = '{$name}' WHERE chave = 'nome'";
    $conn->prepareStatement($sql)->executeQuery();

    $sql="UPDATE configs SET valor = REPLACE(valor, 'https://www.posvendaonline.com/','https://{$subdomain}.posvendaonline.com/') WHERE valor LIKE 'https://www.posvendaonline.com%'";
    $conn->prepareStatement($sql)->executeQuery();

    $sql="INSERT INTO empresas (nome, usr_cad, dt_cad, usr_ualt, dt_ualt) VALUES ('{$name}','posvendaonline',NOW(),'posvendaonline',NOW())";
    $conn->prepareStatement($sql)->executeQuery();

    echo "OK";

    echo "<br>----------------<br>";
    echo "Result<br>";
    echo '<a href="http://'.$subdomain.'.posvendaonline.com.br/" target="_blank">Acessar Admin</a><br>';
    
    
    }else{
        echo "wrong password";
    }
}else{
    ?>
    <form method="post" action="./?action=create">
        <table>
            <tr>
                <td>Nome da Empresa</td>
                <td><input type="text" name="name" /></td>
            </tr>
            <tr>
                <td>Subdominio</td>
                <td><input type="text" name="subdomain" /></td>
            </tr>
            <tr>
                <td>Password</td>
                <td><input type="password" name="password" /></td>
            </tr>
        </table>
        
        <button type="submit">Criar</button>
    </form>
    <?
}
